#include "owbasic.h"
#include "comp.h"
#include "cstack.h"

cstack_entry cstack[FOR_NEST];
int cstack_label = 0;

/*------------------------------------------------*/

static void NEAR noopenerror (int type)
{
  switch (type)
  {
  case CIF:  serror (15); break;
  case CFOR: serror (18); break;
  }
  serror (11);
}

void notclosederror (int type)
{
  switch (type)
  {
  case CIF:  serror (21); break;
  case CFOR: serror (23); break;
  }
  serror (11);
}

void cpush (cstack_entry i)
{
  i.brkuse = 0;
  if ((i.type != CIF) && (i.type != CCASE))
  {
    i.brkcnt = cstack_label++;
    i.brkuse = ctos;
  }
  else if (ctos > 0)
  {
    /*i.brkcnt = cstack[ctos - 1].brkcnt;*/ /* should not be necessary */
    i.brkuse = cstack[ctos - 1].brkuse & C_NMASK;
  }

  if (ctos > FOR_NEST)
    serror (10);
  cstack[ctos++] = i;
}

cstack_entry cpopandtest (int type)
{
  if (ctos == 0)
    noopenerror (type);
  if (cstack[--ctos].type != type)
    noopenerror (type);
  return (cstack[ctos]);
}

cstack_entry cpop (void)
{
  if (ctos == 0)
    noopenerror (-1);
  return (cstack[--ctos]);
}
/* ----------------------------------------------*/
