#include "modeldef.h"
#include <shared.h>
#include <string.h>
#include <modecall.h>
#include "owbasic.h"
#include "comp.h"
#include "graphic.h"
#include "rc.h"
/*
  Error messages
*/
char FAR e0[]  = {"Syntax error"}; /* C0 */
char FAR e1[]  = {"Unbalanced parenthesis"}; /* C1 */
char FAR e2[]  = {"No expression present"}; /* C2 */
char FAR e3[]  = {"" /*"Integer stack underflow"*/}; /* R3 */
char FAR e4[]  = {"L-value expected" /*"Not a variable"*/}; /* C4 */
char FAR e5[]  = {"Symbol table full"}; /* C5 */
char FAR e6[]  = {"Double defined label"}; /* C6 */
char FAR e7[]  = {"" /*"Integer stack overflow"*/}; /* R7 */
char FAR e8[]  = {"Call stack underflow" /*"GOSUB stack underflow"*/}; /* R8 */
char FAR e9[]  = {"Call stack overflow" /*"GOSUB stack overflow"*/}; /* R9 */
char FAR e10[] = {"Too many nested controls"}; /* C10 */
char FAR e11[] = {"Controls unbalanced"}; /* C11 */
char FAR e12[] = {"Type already exists" /*"Too many nested GOSUBs"*/}; /* C12 */
char FAR e13[] = {"Last code reached"}; /* C13 */
char FAR e14[] = {"Expression delimiter\rexpected"}; /* C14 */
char FAR e15[] = {"No open IF"}; /* C15 */
char FAR e16[] = {"Unknown type" /*"Too many labels"*/};  /* C16 */
char FAR e17[] = {"Unknown function"}; /* C17 */
char FAR e18[] = {"No open FOR"}; /* C18 */
char FAR e19[] = {"Default argument missing" /*"Expected '<', '>' or '='"*/};/* C19 */
char FAR e20[] = {"Undefined constant"};/* C20 */
char FAR e21[] = {"Unclosed IF"};/* C21 */
char FAR e22[] = {"Type mismatch"};/* C22 */
char FAR e23[] = {"Unclosed FOR"}; /* C23 */
char FAR e24[] = {"Undefined variable" /*"Wrong operator"*/}; /* C24 */
char FAR e25[] = {"" /*"Float stack underflow"*/}; /* R25 */
char FAR e26[] = {"" /*"Float stack overflow"*/}; /* R26 */
char FAR e27[] = {"Not implemented"}; /* R27 */
char FAR e28[] = {"Global variable exist" /*"Integer number expected"*/}; /* C28 */
char FAR e29[] = {"2D-Array needed"}; /* C29 */
char FAR e30[] = {"Index out of range"}; /* R30 */
char FAR e31[] = {"Array variable used\rbefore DIM"}; /* C31 */
char FAR e32[] = {"String too long"};/* R32 */
char FAR e33[] = {"Memory full"};/* RC33 */
char FAR e34[] = {"String stack underflow"}; /* R34 */
char FAR e35[] = {"String stack overflow"}; /* R35 */
char FAR e36[] = {"Negative argument"}; /* R36 */
char FAR e37[] = {"Label expected"}; /* C37 */
char FAR e38[] = {"Wrong parameter"}; /*C38*/
char FAR e39[] = {"Failed"}; /* R39 */
char FAR e40[] = {"Unknown procedure"}; /* C40 */
char FAR e41[] = {"Invalid code address" /*"Expected identifier"*/}; /* R41 */
char FAR e42[] = {"Include stack overflow"}; /* C42 */
char FAR e43[] = {"Include file not found"}; /* C43 */
char FAR e44[] = {"Append file not found"}; /* C44 */
char FAR e45[] = {"Error position found"}; /* R45 */
char FAR e46[] = {"Too many parameters"}; /* C46 */
char FAR e47[] = {"Too less parameters"}; /* C47 */
char FAR e48[] = {"Nested procedure"}; /* C48 */
char FAR e49[] = {"ENDP without PROC"}; /* C49 */
char FAR e50[] = {"PROC or FUNC not at\rbegin"}; /* C50 */
char FAR e51[] = {"Wrong version" /*"Too many procedures"*/}; /* C51 */
char FAR e52[] = {"Procedure already exists"}; /* C52 */
char FAR e53[] = {"Interrupted"}; /* R53 */
char FAR e54[] = {"Undefined label"}; /* C54 */
char FAR e55[] = {"Expected constant\rexpression"}; /* C55 */
char FAR e56[] = {"Pointer expected" /*"Aborted"*/}; /* C56 */
char FAR e57[] = {"Division by 0"}; /* R57 */
char FAR e58[] = {"Wrong mode"}; /* R58 */
char FAR e59[] = {"No valid icon"}; /* R59 */
char FAR e60[] = {"No more data"}; /* R60 */
char FAR e61[] = {"Not found"}; /* R61 */
char FAR e62[] = {"Wrong font" /*"File exists"*/}; /* R62 */
char FAR e63[] = {"Missing ENDP"}; /* C63 */
char FAR e64[] = {"Arrays must be VAR\rparameter"}; /* C64 */
char FAR e65[] = {"Coordinates out of\rrange"}; /* R65 */
char FAR e66[] = {"VAR parameters not\rallowed here"}; /* C66 */
char FAR e67[] = {"Not initialized"}; /* R67 */
char FAR e68[] = {"Can't save overlay"}; /* C68 */
char FAR e69[] = {"Can't load overlay"}; /* R69 */
char FAR e70[] = {"Same overlay"}; /* C70 */
char FAR e71[] = {"File too big"}; /* R71 */

char FAR * (FAR e)[]= {
   e0, e1, e2, e3, e4, e5, e6, e7, e8, e9,
  e10,e11,e12,e13,e14,e15,e16,e17,e18,e19,
  e20,e21,e22,e23,e24,e25,e26,e27,e28,e29,
  e30,e31,e32,e33,e34,e35,e36,e37,e38,e39,
  e40,e41,e42,e43,e44,e45,e46,e47,e48,e49,
  e50,e51,e52,e53,e54,e55,e56,e57,e58,e59,
  e60,e61,e62,e63,e64,e65,e66,e67,e68,e69,
  e70,e71,
};

void serror (int error)
{
  uchar s = 0;
  serror1 (error, &s);
}

void serrortoken (int error)
{
  *token_end = 0;
  serror1 (error, (uchar*) token_start);
}

static char FAR errormsg0a[] = "Line %d %s:\r%s\r\r%s";
static char FAR errormsg0b[] = "%s,%d: %s";
static char FAR errormsg1a[] = "Line %d %s:\rExpected %s (%d)\r\r%s";
static char FAR errormsg1b[] = "%s,%d: Expected %c (%d)";
static char FAR errormsg2a[] = "Line %d %s:\r%s\r>>%s<<\r\r%s";
static char FAR errormsg2b[] = "%s,%d: %s >>%s<<";
static char FAR rterrormsg1a[] = "Address: %d\rFound in: %s\rError: %s";
/*static char FAR rterrormsg2a[] = "%s\r%s";*/
static char FAR rterror_search[] = "\rSearch position?";
static char FAR rterrormsg1b[] = "%s:%s";
static char FAR rterrormsg2b[] = "%s:%s %s";


static uchar FAR eex_nothing[] = "";
static uchar FAR eex_identifier[] = "identifier";
static uchar FAR eex_to[] = "TO";

static const uchar FAR* NEAR eex_name (int error)
{
  switch (error)
  {
  case IDENT:   return (eex_identifier);
  case TO:      return (eex_to);
  default:      return (eex_nothing);
  }
}

void serror1 (int error, const uchar *cptr)
{
  int h;
  int herror;  /* format and content of error message */
  char disptext[400];
  uchar etext[300]; /* composition of error message */
  uchar emsg[40];
  uchar *hprog = prog - 5;
  herror = error / 1000;
  /*
    switch (herror & 3)
    0 - normal message
    1 - message "expected ... "
    2 - message with *cptr as text

    herror & 4 - don't show context
  */
  error %= 1000;

  if ((error == 45) && (!isFindRTE))
    error = 13;

  etext[0] = 0;

  /* program context of error */
  if (((herror & 4) == 0) && (!switches.remote))
    /* not for include file, undefined label;
       not in remote control mode */
  {
    h = 0;
    while ((h < 20) && (*hprog != '\r') && (hprog > prog_start))
    {
      ++h;
      --hprog;
    }
    if (*hprog == '\r')
      ++hprog;

    h = 0;
    /* text before position */
    while (hprog < prog)
      etext[h++] = *(hprog++);
    /* mark position */
    etext[h++] = /*'_'*/ 0xD6 /* arrow */;
    /* fill with following */
    while ((h < 29) && (*hprog != 0) && (*hprog != '\r'))
      etext[h++] = *(hprog++);
    etext[h] = 0;
  }

  strcpy_nf (emsg, (const uchar FAR*) e[error]);

  switch (herror & 3)
  {
  case 0: /* simple error without additional text */

#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif

      sprintf (disptext, Near (errormsg0a), /* "Line %d %s:\r\r%s\r\r%s", */
        ITOS.line, ITOS.fname, emsg, etext);

#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf (disptext, Near (errormsg0b), /* "%s,%d: %s", */
        ITOS.fname, ITOS.line, emsg);
      rc_finish (FALSE, disptext);
    }
#endif
    break;

  case 1: /* Error expected ...(char or keyword) */
#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif
      if (error < 256) /* character token */
      {
        emsg[0] = error;
        emsg[1] = '\0';
      }
      else
        strcpy_nf ((const uchar*) emsg, eex_name (error));

      sprintf (disptext, Near (errormsg1a), /* "Line %d %s:\r\rExpected %s (%d)\r\r%s", */
        ITOS.line, ITOS.fname, emsg, error, etext);
#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf (disptext, Near (errormsg1b), /* "%s,%d: Expected %c (%d)", */
        ITOS.fname, ITOS.line, error, error);
      rc_finish (FALSE, disptext);
    }
#endif
    break;
  case 2: /* Error with *cptr as text */

#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif
      sprintf (disptext, Near (errormsg2a), /* "Line %d %s:\r\r%s\r\r>>%s<<\r\r%s", */
        ITOS.line, ITOS.fname, emsg, cptr, etext);
#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf (disptext, Near (errormsg2b), /* "%s,%d: %s >>%s<<", */
        ITOS.fname, ITOS.line, emsg, cptr);
      rc_finish (FALSE, disptext);
    }
#endif

    break;
  }

#ifdef REMOTE_CONTROL
  if (!switches.remote)
#endif
    msgbox ((const uchar*) disptext, msg_compilererror, 0.0, MBX_OK);

#if FALSE
  switch (herror & 3)
  {
  case 0: /* simple error without additional text */
    strcpy_nf (emsg, (uchar FAR*) e[error]);
#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif
      LibPutMsgDlg ((byte*) Near (errormsg0a), /* "Line %d %s:\r\r%s\r\r%s", */
        ITOS.line, ITOS.fname, emsg, etext);
#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf ((char*) etext, Near (errormsg0b), /* "%s,%d: %s", */
        ITOS.fname, ITOS.line, emsg);
      rc_finish (FALSE, etext);
    }
#endif
    break;

  case 1: /* Error expected ...(char or keyword) */
#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif
      LibPutMsgDlg ((byte*) Near (errormsg1a), /* "Line %d %s:\r\rExpected %c (%d)\r\r%s", */
        ITOS.line, ITOS.fname, error,error, etext);
#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf ((char*) etext, Near (errormsg1b), /* "%s,%d: Expected %c (%d)", */
        ITOS.fname, ITOS.line, error, error);
      rc_finish (FALSE, etext);
    }
#endif
    break;
  case 2: /* Error with *cptr as text */
    strcpy_nf (emsg, (uchar FAR*) e[error]);
#ifdef REMOTE_CONTROL
    if (!switches.remote)
    {
#endif
      LibPutMsgDlg ((byte*) Near (errormsg2a), /* "Line %d %s:\r\r%s\r\r>>%s<<\r\r%s", */
        ITOS.line, ITOS.fname, emsg, cptr, etext);
#ifdef REMOTE_CONTROL
    }
    else
    {
      sprintf ((char*) etext, Near (errormsg2b), /* "%s,%d: %s >>%s<<", */
        ITOS.fname, ITOS.line, emsg, cptr);
      rc_finish (FALSE, etext);
    }
#endif

    break;
  }
#endif

  longjmp (errorret, 1); /* terminate compilation */
}


#ifdef LSI_C
 uchar* rterrormsg = ((uchar*) IncStack) + MAXSTRLEN + 1;
#else
 #ifdef __HITACHI__
  uchar* rterrormsg = (uchar*) IncStack;
 #else
  uchar _rterrormsg[30];
  uchar* rterrormsg = _rterrormsg;
 #endif
#endif

void rterror (const uchar FAR* funcname, int err)
{
  uchar emsg[40];
  uchar fname[NAMELEN];
  uchar msg[NAMELEN + 200];
  bool srchdlg = pref.searcherror && !xdata[errorhandler];

  unsigned int apc = pc.c - bin;
  int rterrormode = err / 1000;

/*
 * errormode:
 * 0 - normal error message
 * 1 - error message with additional text
 *
 */


  err %= 1000;

  strcpy_nf (fname, funcname);
  strcpy_nf (emsg, (uchar FAR*) e[err]);
  xdata[error] = err;
  if (block_errors == 0)
  {
#ifdef REMOTE_CONTROL
    if (switches.remote)
    {
      if (rterrormode == 1)
        sprintf ((char*) msg, (byte*) Near (rterrormsg2b), fname, emsg, rterrormsg);
      else
        sprintf ((char*) msg, (byte*) Near (rterrormsg1b), fname, emsg);
      rc_finish (FALSE, msg);
      Restart (STATUS_RC);
    }
    else
    {
#endif

      sprintf ((char*) msg, Near (rterrormsg1a),
        apc, fname, emsg);
      if (rterrormode = 1)
        strcat ((char*) msg, (char*) rterrormsg);
      if (srchdlg)
        strcat ((char*) msg, Near (rterror_search));

      if (switches.rterror = (byte) msgbox (msg, msg_runtimeerror, 0.0, srchdlg ? MBX_YESNO : MBX_OK))
        mystatus = (mystatus & MC_CALLMASK) | STATUS_FIND_RTE;

      fbbinit ();
      fbbputstring (progname);
      fbbputint (progcat);
      fbbputint (apc);
      saveshared ((byte*) "rterror", (byte*) PROGNAME, FBB, FBBNUM);

#ifdef REMOTE_CONTROL
    }
#endif
    if (xdata[errorhandler] && !switches.rterror)
      jump (errorhandler, err);
    else
      longjmp (rterrorret, 1);
  }
}





