#include <owbasic.h>
#include "comp.h"
#include "ostring.h"

static bool NEAR binop (datatype_t* ltype, uchar level);
static bool NEAR level5 (datatype_t* ltype, int* is_var);
static void NEAR deref (type_t type);
static bool NEAR cte_unary (PC cpc, type_t rtype);


/* characters for types */
/* for errormessages */
uchar typechar[TYPEMASK + 1] = ".ifbscpe.....rlj";

/* definition of binary operators */
typedef struct op_ {
  smalltype_t top1; /* type of operand1 */
  int         optoken; /* operator (tok from lex ()) */
  smalltype_t top2; /* type of operand2 */
  smalltype_t tresult; /* type of result */
  word        opcode;
} oper; /* LSI_C: 7 bytes, __HITACHI__: 9 bytes */


typedef oper FAR *operp;

oper FAR ol0[]={
{DBOOLEAN,OR,DBOOLEAN,DBOOLEAN,B_OR_BB},
{DBOOLEAN,XOR,DBOOLEAN,DBOOLEAN,B_XOR_BB},
{DINTEGER,OR,DINTEGER,DINTEGER,B_OR_II},
{DINTEGER,XOR,DINTEGER,DINTEGER,B_XOR_II},
{0,0,0,0,0}};

oper FAR ol1[]={
{DBOOLEAN,AND,DBOOLEAN,DBOOLEAN,B_AND_BB},
{DINTEGER,AND,DINTEGER,DINTEGER,B_AND_II},
{0,0,0,0,0}};

oper FAR ol2[]={
{DPOINTER,GREATER,DPOINTER,DBOOLEAN,B_GREATER_II},
{DPOINTER,NOT_LESS,DPOINTER,DBOOLEAN,B_NOT_LESS_II},
{DPOINTER,'=',DPOINTER,DBOOLEAN,B_EQUAL_II},
{DPOINTER,NOT_GREATER,DPOINTER,DBOOLEAN,B_NOT_GREATER_II},
{DPOINTER,LESS,DPOINTER,DBOOLEAN,B_LESS_II},
{DPOINTER,NOT_EQUAL,DPOINTER,DBOOLEAN,B_NOT_EQUAL_II},

{DFLOAT,GREATER,DFLOAT,DBOOLEAN,B_GREATER_FF},
{DFLOAT,NOT_LESS,DFLOAT,DBOOLEAN,B_NOT_LESS_FF},
{DFLOAT,'=',DFLOAT,DBOOLEAN,B_EQUAL_FF},
{DFLOAT,NOT_GREATER,DFLOAT,DBOOLEAN,B_NOT_GREATER_FF},
{DFLOAT,LESS,DFLOAT,DBOOLEAN,B_LESS_FF},
{DFLOAT,NOT_EQUAL,DFLOAT,DBOOLEAN,B_NOT_EQUAL_FF},

{DFLOAT,GREATER,DINTEGER,DBOOLEAN,B_GREATER_FI},
{DFLOAT,NOT_LESS,DINTEGER,DBOOLEAN,B_NOT_LESS_FI},
{DFLOAT,'=',DINTEGER,DBOOLEAN,B_EQUAL_FI},
{DFLOAT,NOT_GREATER,DINTEGER,DBOOLEAN,B_NOT_GREATER_FI},
{DFLOAT,LESS,DINTEGER,DBOOLEAN,B_LESS_FI},
{DFLOAT,NOT_EQUAL,DINTEGER,DBOOLEAN,B_NOT_EQUAL_FI},

{DINTEGER,GREATER,DFLOAT,DBOOLEAN,B_GREATER_IF},
{DINTEGER,NOT_LESS,DFLOAT,DBOOLEAN,B_NOT_LESS_IF},
{DINTEGER,'=',DFLOAT,DBOOLEAN,B_EQUAL_IF},
{DINTEGER,NOT_GREATER,DFLOAT,DBOOLEAN,B_NOT_GREATER_IF},
{DINTEGER,LESS,DFLOAT,DBOOLEAN,B_LESS_IF},
{DINTEGER,NOT_EQUAL,DFLOAT,DBOOLEAN,B_NOT_EQUAL_IF},

{DINTEGER,GREATER,DINTEGER,DBOOLEAN,B_GREATER_II},
{DINTEGER,NOT_LESS,DINTEGER,DBOOLEAN,B_NOT_LESS_II},
{DINTEGER,'=',DINTEGER,DBOOLEAN,B_EQUAL_II},
{DINTEGER,NOT_GREATER,DINTEGER,DBOOLEAN,B_NOT_GREATER_II},
{DINTEGER,LESS,DINTEGER,DBOOLEAN,B_LESS_II},
{DINTEGER,NOT_EQUAL,DINTEGER,DBOOLEAN,B_NOT_EQUAL_II},

{DSTRING,GREATER,DSTRING,DBOOLEAN,B_GREATER_SS},
{DSTRING,NOT_LESS,DSTRING,DBOOLEAN,B_NOT_LESS_SS},
{DSTRING,'=',DSTRING,DBOOLEAN,B_EQUAL_SS},
{DSTRING,NOT_GREATER,DSTRING,DBOOLEAN,B_NOT_GREATER_SS},
{DSTRING,LESS,DSTRING,DBOOLEAN,B_LESS_SS},
{DSTRING,NOT_EQUAL,DSTRING,DBOOLEAN,B_NOT_EQUAL_SS},

{DCHAR,GREATER,DSTRING,DBOOLEAN,B_GREATER_CS},
{DCHAR,NOT_LESS,DSTRING,DBOOLEAN,B_NOT_LESS_CS},
{DCHAR,'=',DSTRING,DBOOLEAN,B_EQUAL_CS},
{DCHAR,NOT_GREATER,DSTRING,DBOOLEAN,B_NOT_GREATER_CS},
{DCHAR,LESS,DSTRING,DBOOLEAN,B_LESS_CS},
{DCHAR,NOT_EQUAL,DSTRING,DBOOLEAN,B_NOT_EQUAL_CS},

{DSTRING,GREATER,DCHAR,DBOOLEAN,B_GREATER_SC},
{DSTRING,NOT_LESS,DCHAR,DBOOLEAN,B_NOT_LESS_SC},
{DSTRING,'=',DCHAR,DBOOLEAN,B_EQUAL_SC},
{DSTRING,NOT_GREATER,DCHAR,DBOOLEAN,B_NOT_GREATER_SC},
{DSTRING,LESS,DCHAR,DBOOLEAN,B_LESS_SC},
{DSTRING,NOT_EQUAL,DCHAR,DBOOLEAN,B_NOT_EQUAL_SC},

{DCHAR,GREATER,DCHAR,DBOOLEAN,B_GREATER_II},
{DCHAR,NOT_LESS,DCHAR,DBOOLEAN,B_NOT_LESS_II},
{DCHAR,'=',DCHAR,DBOOLEAN,B_EQUAL_II},
{DCHAR,NOT_GREATER,DCHAR,DBOOLEAN,B_NOT_GREATER_II},
{DCHAR,LESS,DCHAR,DBOOLEAN,B_LESS_II},
{DCHAR,NOT_EQUAL,DCHAR,DBOOLEAN,B_NOT_EQUAL_II},

{DBOOLEAN,'=',DBOOLEAN,DBOOLEAN,B_EQUAL_II},
{DBOOLEAN,NOT_EQUAL,DBOOLEAN,DBOOLEAN,B_NOT_EQUAL_II},
{0,0,0,0,0}};

oper FAR ol3[]={
{DPOINTER,'+',DINTEGER,DPOINTER,B_ADD_II},
{DINTEGER,'+',DPOINTER,DPOINTER,B_ADD_II},
{DPOINTER,'-',DINTEGER,DPOINTER,B_SUB_II},
{DPOINTER,'-',DPOINTER,DINTEGER,B_SUB_II},

{DINTEGER,'-',DINTEGER,DINTEGER,B_SUB_II},
{DINTEGER,'+',DINTEGER,DINTEGER,B_ADD_II},
{DINTEGER,'+',DFLOAT,DFLOAT,B_ADD_IF},
{DINTEGER,'-',DFLOAT,DFLOAT,B_SUB_IF},
{DFLOAT,'+',DINTEGER,DFLOAT,B_ADD_FI},
{DFLOAT,'-',DINTEGER,DFLOAT,B_SUB_FI},
{DFLOAT,'+',DFLOAT,DFLOAT,B_ADD_FF},
{DFLOAT,'-',DFLOAT,DFLOAT,B_SUB_FF},
{DSTRING,'+',DSTRING,DSTRING,B_ADD_SS},
{DCHAR,'+',DSTRING,DSTRING,B_ADD_CS},
{DSTRING,'+',DCHAR,DSTRING,B_ADD_SC},
{DCHAR,'+',DCHAR,DSTRING,B_ADD_CC},
{0,0,0,0,0}};

oper FAR ol4[]={
{DINTEGER,'*',DINTEGER,DINTEGER,B_MUL_II},
{DINTEGER,'/',DINTEGER,DINTEGER,B_DIV_II},
{DINTEGER,'%',DINTEGER,DINTEGER,B_MOD_II},
{DFLOAT,'*',DINTEGER,DFLOAT,B_MUL_FI},
{DFLOAT,'/',DINTEGER,DFLOAT,B_DIV_FI},
{DINTEGER,'*',DFLOAT,DFLOAT,B_MUL_IF},
{DINTEGER,'/',DFLOAT,DFLOAT,B_DIV_IF},
{DFLOAT,'*',DFLOAT,DFLOAT,B_MUL_FF},
{DFLOAT,'/',DFLOAT,DFLOAT,B_DIV_FF},
{0,0,0,0,0}};

oper FAR ol5[]={
{DINTEGER,'^',DINTEGER,DINTEGER,B_POW_II},
{DFLOAT,'^',DINTEGER,DFLOAT,B_POW_FI},
{0,0,0,0,0}};

operp FAR olist[] = {ol0, ol1, ol2, ol3, ol4, ol5, NULL};

PC apc;
int varaddr;


type_t typesize (type_t type)
{
  register type_t mtype = type & (TYPEMASK | KREFERENCE | KPOINTER);
  if ((mtype & (KREFERENCE | KPOINTER)) || (mtype == DENUM) || (mtype == DCHAR) || (mtype == DBOOLEAN) || (mtype == DFPTR))
    return (DINTEGER);
  return (type & ~(KLAST | KARRAY | KCONST));
}

void conv (type_t* current_type, type_t required_type, PC lpc, bool constant)
{
  int i;

  if (*current_type == DINTEGER)
  {
    if (((required_type & KPOINTER) || (required_type == DFPTR)) && lpc.c && getint (lpc) == 0)
      *current_type = required_type; /* automatic conversion NULL -> POINTER/FPTR */
    else if (required_type == DFLOAT)
    { /* automatic conversion INT -> FLOAT for operand on stack */
      if (!constant) /* conversion not necessary for constant expressions */
      {
        if (lpc.c)
        {
          pc = lpc;
          i = getint (pc);
          ADDCODE (B_IMM_F);
          ADDVALF ((FLOATT) i);
        }
        else
        {
          ADDCODE (B_CONV_IF);
        }
      }
      *current_type = DFLOAT;
    }
    else if ((required_type == DBOOLEAN) && lpc.c && ((getint (lpc) & ~1) == 0) /* 0 or 1 */)
      *current_type = DBOOLEAN;
  }
  else if ((*current_type == DCHAR) && !constant)
  {
    if (required_type == DSTRING)  /* automatic conversion CHAR -> STRING for operand on stack */
    {
      ADDCODE (B_CONV_CS);
      *current_type = DSTRING;
    }
  }
  else if ((*current_type & KPOINTER) && (required_type == DBOOLEAN))
    *current_type = DBOOLEAN;
}

/* entry points into expression parser */
bool comp_exput (datatype_t* ltype)
{  /* expression parser with unknown type, type is returned */
  bool is_number;

  lex ();
  if (tok == DELIMITER)
    serror (2); /* empty expression */
  is_number = binop (ltype, 0);
  putback ();
  return (is_number);
}

bool comp_simple_exp (type_t wtype)
{
  datatype_t type;

  type.type = wtype;
  type.ext = 0;
  return (comp_exp (&type));
}

bool comp_exp (datatype_t* wtype)
{
  bool is_number;
  PC lpc;

  /* expression parser with given type */
  uchar errorstr[] = "\x7F" "a->" "\x7F" "b";
  datatype_t ltype;

  lpc = pc;
  is_number = comp_exput (&ltype);
  if (!is_number)
    lpc.c = NULL;
  conv (&(ltype.type), wtype->type, lpc, FALSE); /* implicit conversion if neccesary */
  if ((wtype->type != ltype.type) || ((wtype->ext != ltype.ext) && wtype->ext && ltype.ext))  /* check type */
  {
    if (wtype->type & KPOINTER)
      errorstr[4] = '&';
    if (ltype.type & KPOINTER)
      errorstr[0] = '&';
    errorstr[5] = typechar[wtype->type & TYPEMASK];
    errorstr[1] = typechar[ltype.type & TYPEMASK];
    serror1 (2022, errorstr);
  }
  if (wtype->ext == 0)
    wtype->ext = ltype.ext;
  return (is_number);
}

void expect_constexput (datatype_t* ltype)
{
  PC lpc = pc;

  if (!comp_exput (ltype))
    serror (55);
  pc = lpc;
  if (ltype->type == DFLOAT)
    lexfloat = getfloat (pc);
  else
    lexfloat = (lexint = getint (pc));
}

int expect_simple_constexp (type_t type)
{
  datatype_t dtype;

  dtype.type = type;
  dtype.ext = 0;
  return (expect_constexp (&dtype));
}

int expect_constexp (const datatype_t* type)
{
  datatype_t rtype;

  expect_constexput (&rtype);
  conv (&(rtype.type), type->type, pc /* dummy */, TRUE);
  if ((rtype.type != type->type) && (rtype.ext != type->ext) && type->ext && rtype.ext)
    serror (22);
  return (lexint);
}

bool comp_lvalue (datatype_t* ltype)
{
  int is_lvalue, is_var;

  level5 (ltype, &is_lvalue);
  if (!is_lvalue)
    serror (4);
  putback ();

  is_var = (apc.c != NULL) && ((ltype->type & KREFERENCE) == NULL);
  ltype->type &= ~(KREFERENCE | KARRAY);
  return (is_var);
}

/* --------------------- */

int is_operator (int optoken, uchar level)
{
  /* is given operator an operator of the level level */
  operp op;

  for (op = olist[level]; op->optoken != 0; ++op)
    if (op->optoken == optoken)
      return (TRUE);

  return (FALSE);
}

int operatorcode (type_t top1, type_t top2, int optoken, uchar level,
     type_t* tres, int *bcode)
{
  /* find operator/operand combination in level level, return result type
     and operation code */
  operp op;
  int a, b;
  type_t rmask = DUNKNOWN;

  a = top1 & KPOINTER;
  b = top2 & KPOINTER;
  if (a || b)
  { /* there is only one kind of operators for all pointer types */
    if (a && b && ((top1 & TYPEMASK) != (top2 & TYPEMASK)))
      return (FALSE);
    rmask = a ? top1 : top2;
    if (a)
      top1 = DPOINTER;
    if (b)
      top2 = DPOINTER;
  }

  for (op = olist[level]; op->optoken != 0; ++op)
  {
    if ((op->optoken == optoken)
     && (op->top1 == top1)
     && (op->top2 == top2))
    {
      if ((*tres = op->tresult) == DPOINTER)
        *tres = rmask;
      *bcode = op->opcode;
      return (TRUE);
    }
  }
  return (FALSE);
}


int getint (PC p)
{
  switch (*(p.c))
  {
  case B_IMM:
    return (*((int*) (p.c + 1)));
  case B_IMM0:
    return (0);
  case B_IMM1:
    return (1);
  case B_IMM2:
    return (2);
  case B_IMMM1:
    return (-1);
  }
}

static bool NEAR binop (datatype_t* ltype, uchar level)
{
  /* binary operators */
  datatype_t top1, top2;
  int vop = '+';
  int oper;
  int opcode;
  codet code;
  bool bopl, bopr = FALSE;
  PC op1 = pc, op2;

  uchar errorstr[] = "L0(" "\x7F" "a," "\x7F" "b)";

  if (olist[level] == NULL)  /* lowest level (highest number) reached -> simple operand */
  {
    if (tok == NOT) /* unary operator NOT */
    {
      bopr /* neg */ = TRUE;
      lex ();
    }

    if (token_type != TCHAR)
      if (tok == '+' || tok == '-') /* sign operator */
      {
        vop = tok;
        lex ();
      }

    bopl = level5 (ltype, &oper);


    if (oper)
    {
      if (((ltype->type & (DSTRING | KREFERENCE)) == ltype->type) && (tok == '{'))
      { /* single character */
        comp_simple_exp (DINTEGER);
        ADDCODE (B_GETCHAR);
        expect ('}');
        lex ();
        ltype->type = /*(ltype->type & ~TYPEMASK) |*/ DCHAR;
        /* oper = FALSE */ /* not necessary since oper is not used any more */
      }
      else
      {
        deref (ltype->type);
        ltype->type &= ~(KREFERENCE | KARRAY);
      }
    }

    if (vop == '-')
    {
      switch (ltype->type)
      {
      case DINTEGER: ADDCODE (B_NEG); break;
      case DFLOAT: ADDCODE (B_NEG_F); break;
      default: serror (22);
      }
      if (bopl /* is_number */)
        cte_unary (op1, ltype->type);
    }
    if (bopr)
    {
      switch (ltype->type)
      {
      case DBOOLEAN:
        ADDCODE (B_NOT);
        break;
      case DINTEGER:
        ADDCODE (B_NOT_I);
        break;
      default:
        serror (22);
      }
      if (bopl /* is_number */)
        cte_unary (op1, ltype->type);
    }
  }
  else
  {
    op1 = pc;
    bopl = binop (ltype, level + 1); /* first operand */
    top1 = *ltype;
    while (is_operator (tok, level)) /* follows valid operator ? */
    {
      apc.c = NULL;
      oper = tok;         /* store operator for later use */
      lex ();
      op2 = pc;
      bopr = binop (&top2, level + 1); /* second operand */
      if (!operatorcode (ltype->type, top2.type, oper, level,
            &(ltype->type), &opcode))
      {
        errorstr[1] += level;
        if (ltype->type & KPOINTER)
          errorstr[3] = '&';
        if (top2.type & KPOINTER)
          errorstr[6] = '&';
        errorstr[4] = typechar[ltype->type & TYPEMASK];
        errorstr[7] = typechar[top2.type & TYPEMASK];
        serror1 (2022, errorstr);
      }

      if (ltype->ext == 0)
        ltype->ext = top2.ext;

      if (bopl && bopr && ((top1.type & 0x03) || (top1.type & KPOINTER)) && ((top2.type & 0x03) || (top2.type & KPOINTER)))
     /*&& (((top1 == DINTEGER) || (top1 == DBOOLEAN) || (top1 == DFLOAT))
       &&  ((top2 == DINTEGER) || (top2 == DBOOLEAN) || (top2 == DFLOAT))))*/
      { /* compile time evaluation (MB,4.40) */
        pc = op1;
        GETCODEPC (code);
        ftable[code] (); /* push 1st operand */
        GETCODEPC (code);
        ftable[code] (); /* push 2nd operand */
        ftable[opcode] (); /* execute operator function */

        pc = op1;
        if ((datatype.type = ltype->type) == DFLOAT)
          lexfloat = fpop ();
        else
          lexint = ipop ();
        comp_number ();
      }
      else
      {
        bopl = FALSE;
        ADDCODE (opcode);
      }
    }
  }
  return (bopl);
}

static bool NEAR cte_unary (PC cpc, type_t rtype)
{ /* compile time evaluation (MB,4.40) */
  codet code;

  pc = cpc;
  GETCODEPC (code);
  ftable[code] (); /* push operand */
  GETCODEPC (code);
  ftable[code] (); /* execute operator function */

  pc = cpc;
  if ((datatype.type = rtype) == DFLOAT)
    lexfloat = fpop ();
  else
    lexint = ipop ();
  comp_number ();
}


static small_codet FAR addrtable[] = {
  B_IMM, B_IMM,        /* variable */
  B_GETVAR, B_GETVAR, /* reference */ /* ADDRESS */

  B_GETARRVAR, B_GETARRVAR_F,        /* variable */
  B_GETNCARRVAR2, B_GETNCARRVAR2_F, /* reference (not array reference!) */ /* 1D-ARRAY ADDRESS */

  B_GETARR2VAR, B_GETARR2VAR_F,    /* variable */
  B_GETARR2VAR2, B_GETARR2VAR2_F, /* reference */ /* 2D-ARRAY ADDRESS */

  B_GETARRVAR2, B_GETARRVAR2_F, /* array reference */ /* 1D-ARRAY ADDRESS (checked) */
};

static small_codet FAR valtable[] = {
  B_GETVAR, B_GETVAR_F, B_GETVAR_S,     /* variable */
  B_GETVAR2, B_GETVAR2_F, B_GETVAR2_S, /* reference */ /* IMM VALUE */

  B_GETVARI, B_GETVARI_F, B_GETVARI_S,  /* variable & reference */ /* STACK VALUE */
};

static codet NEAR addrtv (type_t type, int at)
{
  at *= 4;
  if (type & KREFERENCE)
  {
    at += 2;
    if ((type & KARRAY) && (at == 6))
      at = 12;
  }

  if ((type & TYPEMASK) == DFLOAT)
    ++at;

  return (addrtable[at]);
}

static codet NEAR valtv (type_t type, int at)
{
  register type_t bt = type & (TYPEMASK | KPOINTER);

  if (at)
    at = 6;
  else if (type & KREFERENCE)
    at = 3;

  if (bt == DFLOAT)
    ++at;
  else if (bt == DSTRING)
    at += 2;

  return (valtable[at]);
}

#define AT(type,at) addrtv (type, at)
#define VT(type,at)  valtv (type, at)


static void NEAR deref (type_t type)
{
  if (apc.c)
  {
    *apc.c = VT (type, 0);
    apc.c = NULL;
#ifdef DEBUGCOMP
    OutputITrm (VT (type, 0)); OutputTrm ((uchar*) ("\xF1" "/DEREF "));
#endif
  }
  else
    ADDCODE (VT (type, 1));
}

static bool NEAR level5 (datatype_t* ltype, int* is_var)
{
  PC apc2;
  int var, addr;
  datatype_t hdtype;
  bool is_number = FALSE /*, simple_operand = TRUE*/;
  int addr_type = 0;
  int cn, i;
  int arrl = 0;
  bool dereferencing = FALSE;

  *is_var = FALSE;
  apc2.c = NULL;

  if ((tok == '*') && (token_type != TCHAR)) /* pointer dereferencing (MB,4.41) */
  {
    dereferencing = TRUE;
    lex ();
  }

#if FALSE
    /*   __________________________________________
        | prefix | description             | value |
        ||||
        | (-)    | variable                | 0x00  |
        | &      | address                 | 0x01  |
        | ~      | pointer array values    | 0x02  |
        | &~     | pointer array addresses | 0x03  |
        | &&     | pointer address         | 0x04  |
             */

  switch (tok) /* pointer operators (MB,4.20) */
  {
  case '&': /* variable/reference -> pointer */
    addr_type = 1;
    break;
  case '~': /* pointer array -> reference (pointer array indexing) */
    addr_type = 2;
    break;
  case OP_PTRARRAYADDR: /* &~ : pointer array -> pointer (array indexing) */
    addr_type = 3;
    break;
  case OP_PTRADDR: /* && : pointer -> pointer (to pointer) */
    addr_type = 4;
    break;
  default: /* no pointer operator */
    addr_type = 0;
  }
  if (addr_type)
    lex ();
#endif

  if (tok == '(')
  {
    /*simple_operand = FALSE;*/
    is_number = comp_exput (&hdtype);
    expect (')');
    lex ();
  }
  else
  {
    hdtype = datatype;
    addr_type = lex_ref; /* TODO: remove this and prefix recognition in lex () */
    if (addr_type == 1)
      hdtype.type |= KREFERENCE;

    /* primitive */
    switch (token_type)
    {
    case TKEY:
      switch (i = tok)
      {
      case FILEBUFFER:
      case CLIPBOARD:
        expect ('[');
        comp_simple_exp (DINTEGER);
        expect (']');
        ADDCODE ((i == FILEBUFFER) ? B_FBGET : B_CBGET);
        hdtype.type = DINTEGER;
        break;
      case PROP_FBBSIZE:
        ADDCODE (B_GETFBBSIZE);
        hdtype.type = DINTEGER;
        break;
      case True:
      case False:
        ADDCODE ((tok == True) ? B_IMM1 : B_IMM0);
        is_number = TRUE;
        hdtype.type = DBOOLEAN;
        break;
      default:
        serror (0);
      }
      break;
    case TIDENT:
      if (LEX_CHAR == '(')
      {
        /* function call */
        if (!compile_userprocedure (&(hdtype.type), FALSE))
          is_number = compile_function (&hdtype);
      }
      else
      {
        *is_var = TRUE;

#if FALSE
        if ((found_variable >= 0)
         && (((hdtype.type & TYPEMASK) == (xdata[found_variable - 3] & TYPEMASK))
          || (hdtype.type == DUNKNOWN)))
        { /* already found in lex () */
          var = found_variable;
          found_variable = -1;
          hdtype.type = xdata[var - 3];
          /*tokcpy_ident (MACRO_EXPANSION_SPACE);
          LibPutMsgDlg ("%s\r%s\r%d,%d", MACRO_EXPANSION_SPACE, Near ((uchar FAR*) (&xdata[var + 4])), hdtype, xdata[var - 3]);*/
        }
        else
#endif
        var = xdata[addr = findentry_token (&hdtype)]; /* find variable */

        hdtype.ext = xdata[addr - 2];
        hdtype.type = xdata[addr - 3] & EVALMASK; /* remove KCONST, KLAST etc. */
        apc2 = pc;
        cn = (addr_type == 1) ? B_IMM : AT (hdtype.type, arrl);
        ADDCODE (cn); /* getvar opcode */
        ADDVAL (var); /* runtime address */
      }
      break;

    case TSTRING:
      ADDCODE (B_IMM_S);
      comp_str ();
      ADDVAL (firstconst);
      break;

    case TCHAR:
    case TNUMBER:
      is_number = TRUE;
      comp_number ();
      break;

    default:
      serror (0);
    }
    lex ();
  }

  if ((addr_type == 1) && *is_var && ((hdtype.type & KREFERENCE) == 0))
  {
    *is_var = FALSE;
    is_number = TRUE;
  }
  if ((addr_type >= 2) && (addr_type <= 4)) /* ~, &~, && operators */
  {
    if (!(hdtype.type & KREFERENCE) || !apc2.c)
      serror (4);
    /**apc2.c = B_IMM;*/
    hdtype.type = (hdtype.type & ~(KREFERENCE | KARRAY)) | KPOINTER;
    if (addr_type == 4)
    {
      *apc2.c = B_IMM;
      *is_var = FALSE;
      hdtype.type = DINTEGER | KPOINTER; /* pointer to pointer */
    }
  }

index:
  if (tok == '[')
  {
    arrl = 1; /* 1d array */
    if (apc2.c)
    {
      var = *((int*) (apc2.c + 1)); /* variable runtime address */
      pc = apc2;
    }

    cn = comp_simple_exp (DINTEGER);

    if (LEX_CHAR == ',')
    {
      lex ();
      if (hdtype.type & KREFERENCE)
      {
        if (!(hdtype.type & KARRAY))
          serror (0); /* pointers cannot have 2d indices */
      }
      else
      {
        if (apc2.c && xdata[addr + 2] == 0)
          serror (29);
      }
      cn = FALSE;
      arrl = 2; /* 2d array */
      comp_simple_exp (DINTEGER);
    }

    if ((addr_type == 1) && !(*is_var))
      is_number = cn;

    if (apc2.c)
    {
      if (cn && (((i = getint (apc2)) == 0) || ((hdtype.type & KREFERENCE) == 0)))
      { /* constant array index */
        arrl = 0; /* constant index is evaluated at compile time -> no array */
        pc = apc2;
        var += (i * ((hdtype.type == DFLOAT) ? FLOATSIZE : 1));
        ADDCODE (AT (hdtype.type, arrl));
        ADDVAL (var);
      }
      else
      { /* normal array index */
        apc2.c = NULL;
        ADDCODE (AT (hdtype.type, arrl));
        ADDVAL (var);
      }
    }
    else
    {
      ADDCODE ((hdtype.type & DFLOAT) ? B_GETNCARRVARI_F : B_ADD_II); /* simply add index to base address, no index checks */
    }

    expect (']');
    lex ();

    if ((addr_type == 2) || (addr_type == 3)) /* ~, &~ operators */
    {
      apc = apc2; /* set apc for the deref () function */
      if (addr_type == 2)
      {
        deref (hdtype.type);
        apc2.c = NULL;

        hdtype.type &= ~KPOINTER;
      }

      if (tok == '[')
      {
        if (addr_type == 3)
        {
          deref (hdtype.type);
          apc2.c = NULL;

          *is_var = FALSE;
        }
        addr_type = 0;
        goto index;
      }
    }
  }

  if (addr_type == 1) /* & operator */
  {
    hdtype.type = (hdtype.type & ~(KREFERENCE | KARRAY)) | KPOINTER;
    if (arrl) /* indiced address operator */
      *is_var = FALSE; /* pointers are already dereferenced */
  }

  if (dereferencing)
  {
    if ((hdtype.type & KPOINTER) == 0)
      serror (56);
    hdtype.type = (hdtype.type & ~KPOINTER) | KREFERENCE;
    *is_var = TRUE;
  }

  *ltype = hdtype;
  apc = apc2;
  varaddr = var;

  return (is_number);
}

void comp_number (void)
{
  switch (typesize (datatype.type))
  {
  case DINTEGER: /* including integer sized types */
    switch (lexint)
    {
    case 0:
      ADDCODE (B_IMM0);
      break;
    case 1:
      ADDCODE (B_IMM1);
      break;
    case 2:
      ADDCODE (B_IMM2);
      break;
    case -1:
      ADDCODE (B_IMMM1);
      break;
    default:
      ADDCODE (B_IMM);
      ADDVAL (lexint);
    }
    break;
  case DFLOAT:
    ADDCODE (B_IMM_F);
    ADDVALF (lexfloat);
    break;
  }
}

int comp_str (void)
{
  char hex[3];
  int sl, il, i;
  uchar FAR *fp;
  uchar *np;
  bool esc;

  hex[2] = 0;
  sl = token_end - token_start - 2;
  il = (sl + sizeof (int)) / sizeof (int);
  firstconst -= il;
  if (firstconst < datanext)
    serror (33);
  fp = (uchar FAR*) &xdata[firstconst];
  np = token_start + 1;
  esc = FALSE;

  while (np < token_end - 1)
  {
    if (esc)
    {
      if (tolower (*np) == 'x')
      {
        hex[0] = *(++np);
        hex[1] = *(++np);
        sscanf (hex, "%x", &i);
        *(fp++) = i;
      }
      else
        *(fp++) = *np;
      esc = FALSE;
    }
    else
    {
      if (*np == '\\')
        esc = TRUE;
      else
      {
        if (*np == NEWLINESYMBOL)
          *fp = NEWLINE;
        else
          *fp = *np;
        ++fp;
      }
    }
    ++np;
  }
  *fp = 0;
  return (fp - ((uchar FAR*) &xdata[firstconst]));
}


void comp_para (void FAR* para, int FAR* proc, uchar* version, int delim, uchar parawidth)
{ /* compile parameter for procedure and function calls */
  #define PARA(i) (parawidth ? ((type_t FAR*) para)[i] : ((smalltype_t FAR*) para)[i])
  int i;
  type_t cp;
  int ltok;
  datatype_t typ, xtype;
  int FAR* paraval;
  int FAR* paraext = NULL;

  i = 0; /* first parameter */
  if (proc)
    if (proc[3])
      paraext = &xdata[proc[3]];
  ltok = lex ();
  while (((cp = PARA (i)) != DUNKNOWN) /* not end of parameter list */
      && (ltok != delim)               /* not (normal) delimiter */
      && (ltok != END))                /* not end of source */
  {
    putback ();
    if (i != 0)
      expect (',');

    typ.type = cp & (TYPEMASK | KPOINTER);
    typ.ext = paraext ? paraext[i] : 0;

    if (cp & KREFERENCE)    /* var parameter */
    {
      lex ();
      comp_lvalue (&xtype);
      if (((xtype.type & (TYPEMASK | KPOINTER)) != typ.type) || (xtype.ext != typ.ext))
        serror (22);
    }
    else
      /* call by value */
      comp_exp (&typ);
    ++i;
    ltok = lex ();
  }

  cp = PARA (i);

  if (delim == ')')
  {
    if (ltok != ')')
      serror (46);
  }
  else
  {
    if ((ltok != delim) && (ltok != END))
      serror (46);
  }

  if ((cp != DUNKNOWN) && ((cp & KLAST) == 0))
    serror (47);

  if (version) /* built-in procedure */
  {
    *version = 0;
    while ((cp = PARA (i)) != DUNKNOWN)
    {
      if (cp & KLAST)
        ++(*version);
      ++i;
    }
  }
  else /* user defined procedure */
  { /* add default parameter values if necessary */
    paraval = &xdata[proc[2]];
    while ((cp = PARA (i)) != DUNKNOWN)
    {
      if (cp & KLAST)
      {
        if (cp & KREFERENCE)
          cp = DINTEGER; /* treat references as integer */
        lexint = paraval[i];
        switch (cp & TYPEMASK)
        {
        case DFLOAT:
          ADDCODE (B_GETVAR_F);
          ADDVAL (lexint);
          break;
        case DSTRING:
          ADDCODE (B_IMM_S);
          ADDVAL (lexint);
          break;
        default:
          datatype.type = cp & TYPEMASK;
          comp_number ();
        }
      }
      ++i;
    }
  }

  #undef PARA(i)
}

int compile_function (datatype_t* ltype)
{
  int found;
  int lookup;
  datatype_t atyp, hdtype;
  uchar fname[IDENTLEN];
  uchar version;
  bool is_number = FALSE;
  KeywordFn FAR* hptr = functable;

  hdtype.type = DT (datatype.type);
  hdtype.ext = datatype.ext;
  tokcpy_ident (fname);
  lookup = look_up (keyfunctable);
  expect ('(');

  ltype->ext = 0;

  switch (lookup)
  {
  case F_INT:
    is_number = comp_exput (&atyp);
    if ((atyp.type & KPOINTER) == 0) /* convert pointer to integer (MB,4,41) */
      switch (atyp.type)
      {
      case DFLOAT:   is_number = FALSE; ADDCODE (B_CONV_FI); break;
      case DSTRING:  is_number = FALSE; ADDCODE (B_CONV_SI); break;
      case DCHAR:    is_number = FALSE; ADDCODE (B_CONV_CI); break;
      case DENUM:
      case DFPTR:
      case DBOOLEAN: /*serror (22);*/ break; /* allow casting from bool to int (MB,4.10) */
      case DINTEGER: if (desired_version > 250) serror (22);
      default:       serror (22);
      }
    ltype->type = DINTEGER;
    expect (')');
    break;

  case F_BOOL:
    is_number = comp_simple_exp (DINTEGER);
    ltype->type = DBOOLEAN;
    break;

  case F_FLOAT:
    is_number = comp_exput (&atyp);
    switch (atyp.type)
    {
    case DBOOLEAN: /* serror(22); break; */ /* allow casting from bool to float (MB,4.10) */
    case DINTEGER: is_number = FALSE; ADDCODE (B_CONV_IF); break;
    case DSTRING:  is_number = FALSE; ADDCODE (B_CONV_SF); break;
    case DFLOAT:   if (desired_version > 250) serror (22);
    default:       serror (22);
    }
    ltype->type = DFLOAT;
    expect (')');
    break;

  case F_STRING:
    is_number = FALSE;
    comp_exput (&atyp);
    switch (atyp.type)
    {
    case DINTEGER: ADDCODE (B_CONV_IS); break;
    case DFLOAT:   ADDCODE (B_CONV_FS); break;
    case DBOOLEAN: ADDCODE (B_CONV_BS); break;
    case DCHAR:    ADDCODE (B_CONV_CS); break;
    case DSTRING:  if (desired_version > 250) serror (22);
    default:       serror (22);
    }
    ltype->type = DSTRING;
    expect (')');
    break;

  case F_CHAR:
    is_number = comp_simple_exp (DINTEGER);
    switch (hdtype.type)
    {
    case DINTEGER:
      ltype->type = DCHAR;
    case DCHAR:   break;
    case DSTRING: is_number = FALSE; ADDCODE (B_CHAR_S); break;
    default:      serror (22);
    }
    expect (')');
    break;

  case F_ENUM: /* convert integer to enum (MB,4.50) */
    is_number = comp_simple_exp (DINTEGER);
    if (hdtype.ext == 0)
      serror (22);
    *ltype = hdtype;
    expect (')');
    break;

  case F_POINTER: /* convert integer to pointer or pointer to pointer of another type (MB,4.41) */
    is_number = comp_exput (&atyp);
    if (((atyp.type & KPOINTER) == 0) && (atyp.type != DINTEGER))
      serror (22);
    expect (')');
    ltype->type = hdtype.type | KPOINTER;
    break;

  case F_ASC:
    is_number = comp_exput (&atyp);
    switch (atyp.type)
    {
    case DCHAR:   break;
    case DSTRING: is_number = FALSE; ADDCODE (B_ASC_S); break;
    default:      serror (22);
    }
    expect (')');
    ltype->type = DINTEGER;
    break;

  case F_ARRAYSIZE:
    lex ();
    comp_lvalue (&atyp);
    if (LEX_CHAR == ',')
    {
      lex (); /* skip ',' */
      comp_simple_exp (DINTEGER);
      ADDCODE (B_ARRAYSIZE);
    }
    else
    {
      ADDCODE (B_ARRAYSIZE1);
    }
    ltype->type = DINTEGER;
    expect (')');
    break;

  case F_CALL:
    compile_userprocedure (&hdtype.type, TRUE); /* ')' is removed by compile_userprocedure */
    ltype->type = hdtype.type;
    break;

  case F_PROC:
  case F_FUNC:
    is_number = TRUE;
    lex ();
    if (lookup == F_FUNC)
      datatype.type = DT (datatype.type);

    tokcpy_ident (fname);
    if ((lookup = search_procfunc (fname, datatype.type)) == -1)
      serrortoken (2040); /* unknown procedure */

    ADDCODE (B_IMM);
    ADDVAL (xdata[lookup]);
    ltype->type = DFPTR;
    ltype->ext = 0;
    expect (')');
    break;

  case D_VARDEF:
    is_number = TRUE;
    lex ();
    atyp = datatype;
    lexint = (searchentry_token (&atyp) < 0) ? 0 : 1;
    ltype->type = datatype.type = DBOOLEAN;
    comp_number ();
    expect (')');
    break;

  case D_PROCFUNCDEF:
    is_number = TRUE;
    lex ();
    tokcpy_ident (fname);
    lexint = (search_procfunc (fname, datatype.type) < 0) ? 0 : 1;
    ltype->type = datatype.type = DBOOLEAN;
    comp_number ();
    expect (')');
    break;

  default:
    found = FALSE;
    /* all normal functions in KeywordFn */
    while ((!found) && (hptr->command != NULL))
    {
      if ((hptr->rtype == hdtype.type) && (strcmp_nf (fname, hptr->command) == 0))
      {
        /* found */
        /* evaluate parameters */
        comp_para (hptr->paratype, NULL, &version, ')', 0);
        /* function call */
        ADDCODE (hptr->bincode[version]);
        found = TRUE;
      }
      else
        ++hptr;
    }
    if (!found)
      serror1 (2017, fname);
  }

  return (is_number);
}
