#include <owbasic.h>
#include <form.h>
#include <graphic.h>
#include <inter.h>



FElement FAR Form[MAXFORMELEMENTS];
/*int formstrings;*/
int lastelement;
uchar defaultstatus;
int formfont;

#ifdef NEVER_DEFINED
int buttondisplay (int);
int switchdisplay (int);
int selectdisplay (int);

int buttonpress (int);
int switchpress (int);
int selectpress (int);
#endif

#ifndef SMALL_NO_FORMFUNCS
typedef int (*formfunc_t) (int);

formfunc_t formdisplayfuncs[] = {
  buttondisplay,
  switchdisplay,
  selectdisplay
};

formfunc_t formpressfuncs[] = {
  buttonpress,
  switchpress,
  selectpress
};
#endif

int forminit (uchar defstat, int deffont)
{
  ipush (formstrings);
  x_clears (); /* free string space of former forms */

  lastelement = -1;
  defaultstatus = defstat;
  formfont = deffont;
  return (0);
}

int formentry (uchar* name, int x1, int y1, int x2, int y2,
        int typ, int id)
{
  PFElement elem;

  if ((typ < 0) || (typ > 2))
    typ = 0;
  if ((++lastelement) >= MAXFORMELEMENTS)
    return (33);
  if (!checkxy2 (x1, y1, x2, y2))
    return (65);

  elem = &Form[lastelement];
  elem->x1 = x1;
  elem->y1 = y1;
  elem->x2 = x2;
  elem->y2 = y2;
  elem->typ = typ;
  elem->id = id / 10;
  elem->subid = id % 10;
  elem->status = defaultstatus;
  putvar (formstrings + lastelement, name);
  return (0);
}

int findid (int fid)
{
  int i = 0;
  int id = fid / 10;
  int subid = fid % 10;

  for (; i < lastelement; ++i)
    if ((Form[i].id == id) && (Form[i].subid == subid))
      return (i);
  return (-1);


  /*while ((i < lastelement) && ((Form[i].id != id) || (Form[i].subid != subid)))
    ++i;
  if ((Form[i].id != id) || (Form[i].subid != subid))
    return (-1);
  return (i);*/
}

int formsetstatus (int fid, int sel)
{
  int n = findid (fid);

  if (n == -1)
    return (61);
  Form[n].status |= sel;
  return (0);
}

int formresetstatus(int fid,int sel)
{
  int n = findid (fid);

  if (n == -1)
    return (61);
  Form[n].status &= 0xFF ^ sel;
  return (0);
}

int formtext (uchar *text, int x1, int y1, int x2, int y2)
{
  int gnr;

  if (!checkxy2 (x1, y1, x2, y2))
    return (65);
  if (text[0] == '#')
  {
    sscanf ((char*) text, "#%d", &gnr);
    LibPutFarData (x1 + 3, y1 + 3, gnr);
  }
  else
    drawtext (text, x1, y1, x2, y2, formfont);

  return (0);
}

int buttondisplay (int i)
{
  spush (formstrings + i);
  formtext (STOS, Form[i].x1, Form[i].y1, Form[i].x2, Form[i].y2);
  spop1 ();
  return (0);
}

int selectdisplay(int i)
{
  int sel;
  spush (formstrings + i);
  formtext (STOS, Form[i].x1 + 15, Form[i].y1, Form[i].x2, Form[i].y2);
  spop1 ();
  sel = ((Form[i].status & 1) == 0) ? 13 : 12;
  LibPutFarData (Form[i].x1 + 7, (Form[i].y1 + Form[i].y2) / 2 - 4, sel);
  return (0);
}

int switchdisplay(int i)
{
  int sel;
  spush (formstrings + i);
  formtext (STOS, Form[i].x1 + 15, Form[i].y1, Form[i].x2, Form[i].y2);
  spop1 ();
  sel = ((Form[i].status & 1) == 0) ? 16 : 9;
  LibPutFarData (Form[i].x1 + 7, (Form[i].y1 + Form[i].y2) / 2 - 4, sel);
  return (0);
}


int formdisplay ()
{
  int i;
  if (lastelement < 0)
    return (67);
  for (i = 0; i <= lastelement; ++i)
  {
    if (!(Form[i].status & 16)) /* hidden element? */
    {
#ifdef SMALL_NO_FORMFUNCS
      switch (Form[i].typ)
      {
      case 0: buttondisplay(i); break;
      case 1: switchdisplay(i); break;
      case 2: selectdisplay(i); break;
      }
#else
      formdisplayfuncs[Form[i].typ] (i);
#endif
      if ((Form[i].status & 2)==0) /* no frame ? */
        Box(Form[i].x1,Form[i].y1,Form[i].x2,Form[i].y2,1);
      if ((Form[i].status & 4)>0)  /* double frame */
        Box(Form[i].x1-2,Form[i].y1-2,Form[i].x2+2,Form[i].y2+2,1);
      if ((Form[i].status & 8)>0) /* inactive */
        Box(Form[i].x1,Form[i].y1,Form[i].x2,Form[i].y2,12);
    }
  }
  LibPutDisp();
  return 0;
}

#ifdef NEVER_DEFINED
int buttonpress(int n)
{
  /* nothing to do */
  return 0;
}
#endif

int switchpress(int n)
{
  Form[n].status = Form[n].status ^ 1;
  Form[n].subid = Form[n].status & 1;
  return 0;
}

int selectpress(int n)
{
  int i;
  if ((Form[n].status & 1)==0)
    {
      for (i=0;i<=lastelement;i++)
  {
    if (Form[i].id==Form[n].id)
      {
        Form[i].status &= 0xfe;
      }
  }
      Form[n].status |= 1;
    }
  return 0;
}

int formtouch(int *sel,int nowait)
{
  int touchx,touchy;
  int n, nn;

  *sel=-1;
  if (lastelement<0) return 67;

  LibPutDisp();

  do {
    check_touch();
    if (newtouched)
      {
  touchx=*tchxp; touchy=*tchyp;
  if ((touchy>ESC_Y1)&&(touchx>ESC_X1)&&(touchy<ESC_Y2)) /* ESC */
    {
      if (verify_abort()) return 56;
    }

  for (n=0;n<=lastelement;n++)
    {
      if (((Form[n].status & 8)==0) &&
    (Form[n].id != 0) &&
    (Form[n].x1 <= touchx) &&
    (Form[n].y1 <= touchy) &&
    (Form[n].x2 >= touchx) &&
    (Form[n].y2 >= touchy))
        {
#ifdef SMALL_NO_FORMFUNCS
    switch(Form[n].typ)
      {
      case 0: /*buttonpress(n);*/ break;
      case 1: switchpress(n); break;
      case 2: selectpress(n); break;
      }
#else
    formpressfuncs[Form[n].typ] (n);
#endif
    nn = n;
    *sel = Form[n].id*10+Form[n].subid;
        }
    }

  formdisplay();

  if (*sel>=0)
    {
      if (!(Form[nn].status & 16)) /* not hidden */
        {
    Box(Form[nn].x1,Form[nn].y1,Form[nn].x2,Form[nn].y2,11);
    WaitNoTouch();
    Box(Form[nn].x1,Form[nn].y1,Form[nn].x2,Form[nn].y2,10);
    formdisplay();
        }
      else
        WaitNoTouch();
    }
  newtouched=FALSE;
      }
  }
  while ((*sel<0)&&(!nowait));

  return 0;
}

void x_calcinput()
{
  TCHSTS tsts;
  CALWRAM calram;
  bool done=FALSE;
  int i;
  float res;
  /******************/
  /* Touch settings */
  /******************/
  LibTchStackClr();
  LibTchStackPush(TchHardIcon);
  LibTchStackPush(TchModeIcon);
  LibTchInit();

  /****************************/
  /* Initializing calculator. */
  /****************************/
  LibCalKeyInit(&calram); /* Initializes calculator keyboard. */
  LibCalKeyDsp(&calram); /* Displays Calculator keyboard. */
  LibPutDisp(); /* Reflects to the screen. */
  while(!done){
    LibCalKeyTchWait(&calram,&tsts); /* Waits for touch of calculator */
    switch(tsts.obj){
    case OBJ_CAL_NEXT: /* "Next" */
      /***** Writing and item move processes, etc. *****/
      if (calram.calerror==0x00) done=TRUE;
      break;
    case OBJ_CAL_EQUAL: /* "=" */
      /***** Writing process and others... *****/
      if (calram.calerror==0x00) done=TRUE;
      break;
    case OBJ_HIC_ESC: /* ESC */
      LibCalKeyInit(&calram);
      done=TRUE;
      break;
    default:
      break;
    }
  }

  res=0;
  for (i=2;i<14;i++)
    {
      res=res/10.0+(calram.calxbuf[i] & 0xf);
    }
  if (calram.calxbuf[1]==0x0c) res=-res;
  for (i=0;i<calram.calxbuf[0];i++)
    res=res*10.;
  fpush(res);
}
