#include "owbasic.h"
#include "graphic.h"
#include "comp.h"
#include "inter.h"
#include "gui.h"
#include <string.h>
#include <modeldef.h>

/*static byte FAR foldericon[] = {
  GSIZE (8, 6),
  0x70,
  0x7E,
  0x81,
  0x81,
  0x81,
  0x7E,
};*/

static byte FAR owbicon[] = {
  GSIZE (12, 12),
  0x00, 0x06,
  0x00, 0x09,
  0x3B, 0xC9,
  0x65, 0x2F,
  0x45, 0x20,
  0x85, 0xE7,
  0x85, 0x1A,
  0x89, 0x1A,
  0x99, 0x17,
  0x73, 0xE0,
  0x00, 0x0F,
  0x00, 0x0F,
  0x32, 0x2F,
};



#ifdef LSI_C
static char FAR* FAR optionsmenu[] = {msg_mm_settings, msg_mm_findrte, msg_mm_remote, msg_mm_cache, msg_mm_about};
#define OPTIONSMENU_CNT   5
#define OPTIONSMENU_LINES 0x09
#else
static char FAR* FAR optionsmenu[] = {msg_mm_settings, msg_mm_findrte, msg_mm_cache, msg_mm_about};
#define OPTIONSMENU_CNT   4
#define OPTIONSMENU_LINES 0x05
#endif


static void NEAR list_load (void);
static void NEAR list_draw (int mode, word* list);
static void NEAR mainmenu_draw (int mode);
static int  NEAR mainmenu_options (void);
static int  NEAR mainmenu_category (void);
#define GM_FILTER stringstack2

#define SCR__SIZE 125 /* Height of scroll bar */

T_SCR_POS scrollbar = {
  149, 31,   /* x, y position */
  SCR__SIZE, /* height */
  130,       /* number of elements (dummy) */
  13,        /* number of display records on the screen */
  0          /* position */
};

static TCHTBL FAR TchScrollBar[] =
{ /* Scroll bar */
  149, 31 + 9, 149 + SCR_XSIZE - 1, 32 + SCR__SIZE - 1 - 9,
  ACT_SCR_BAR,
  OBJ_SCR_BAR,
  0x0000,

  /* End recognition */
  0, 0, 0, 0,
  ACT_NONE,
  OBJ_END,
  0x0000
};


#define LIST_NONE (~1)
#define LIST_EXIT (~0)

word* mainmenu_list = (word*) bin;

void dlist (int x, int y, int x2, int cnt, int lines, char FAR* FAR* entries)
{
  int n;
  int y2 = y + cnt * 10 - 1;

  dbox (x, y, x2, y2 + 1, NULL);
  x += 2; x2 -= 2;

  for (n = 0; n < cnt; ++n)
  {
    LibPutProStr (IB_PFONT1, x, y + 2, (uchar*) Near (entries[n]), x2);
    y += 10;
    if ((lines >> n) & 0x01)
      Line (x, y, x2 + 1, y, 4);
  }
}

int qlist (int x, int y, int x2, int cnt)
{
  int n;
  int y2 = y + cnt * 10 - 1;

  newtouched = FALSE;

  if (!check_touch ())
    return (LIST_NONE);
  if (tchinside (x, y, x2, y2))
  {
    n = (*tchyp - y) / 10;
    y += n * 10;
    y2 = y + 10;
    /*x2 += 2;*/
    /*LibPutMsgDlg ("x:%d,y:%d,x2:%d,y2:%d\rnewtouched:%d,touch:%d", x, y, x2, y2, newtouched, touched);*/
    if (qbox (x, y, x2, y2))
      return (n);
    newtouched = FALSE;
    return (LIST_NONE);
  }
  return (LIST_EXIT);
}


static void NEAR mainmenu_draw (int mode)
{
  char version[6]; /* vx.yy */

  sprintf (version, "v%0.2lf", (double) (OWBVersion / 100.0));
  LibClrDisp ();

  LibPutGraph (0, 0, owbicon);

  dbox (15, 0, 56, 10, (uchar*) Near (msg_mm_options));

  /*dbox (56, 0, 125, 10, (uchar*) (Near ((mode == GM_FILE) ? msg_mm_mfile : msg_mm_mprog)));*/

  dbox (129, 0, 158, 10, msg_mm_tools);

  LibPutProStr (IB_PFONT2, 132, 16, (byte*) version, 27);

  /*LibPutFarData (0, 13, 79);*/ /* drawstring: 2, 15 */
  Box (0, 13, 13, 24, 1);
  LibGdsDotOff (0, 13);
  LibGdsDotOff (0, 24);
  LibPutFarData (13, 13, 115);
  LibPutProFont (IB_PFONT1, '0' + (switches.progsub & 0x0F), 2, 15);
  if (switches.progsub & 0xF0) /* secret mode */
    LibPutProFont (IB_PFONT1, 'S', 7, 15);

  Box (36, 13, 120, 24, 1);
  Box (37, 14, 120, 24, 1);
  LibPutProStr (IB_PFONT1, 39, 16, GM_FILTER, 118 - 36);

  Box (0, 28, 159, 158, 1);
  Line (147, 28, 147, 158, 1);
  LibDotOff (0, 28);
  LibDotOff (0, 158);
  LibDotOff (159, 28);
  LibDotOff (159, 158);

  list_draw (mode, mainmenu_list);
  LibScrollPrint (scrollbar);
  LibScrollArrowPrint (scrollbar, SCR_ALL_MASK);
}


static void NEAR list_load (void)
{
  uchar sig[] = {'!', ' '};
  word* list = (word*) bin;
  uchar FAR* data = (uchar FAR*) xdata;
  uchar* src;
  register uchar bc;

  scrollbar.vol = 0;
  SetFP (3, switches.progsub, 0xFFFF);

  do
  {
    fb.fsb_sub_entry_  = switches.progsub & 0x0F;
    LibFileFindNext (&fb, &finf, 0x00);

    if (LibFileReadEx (&fb, &finf, 1))
      if ((*FB == *sig) && (FB[1] == sig[1]))
      {
        if (*GM_FILTER)
        {
          src = FB + 2 - 1;
          do
            bc = *(++src);
          while ((bc != 0x0A) && (bc != 0x0D) && (bc != 0x00));
          *src = 0x00;
          if (pos (GM_FILTER, FB + 2, FALSE) < 0)
            continue;
        }
        if (((int) data) & 0x01)
          ++data; /* align to word for PV-S1600 */
        *((word FAR*) data) = (3 /* category */ << 4) | switches.progsub;
        data += sizeof (word);
        *(list++) = GF_ISVALID | GF_ISENTRY;
        *(list++) = data - ((uchar FAR*) xdata);

        src = FB + 2 - 1;
        do
          *(data++) = bc = *(++src);
        while ((bc != 0x0A) && (bc != 0x0D) && (bc != 0x00));
        *(data - 1) = 0;

        ++scrollbar.vol;
      }
  } while (finf.fp != 0xFFFF);
  *list = 0;
}


static void NEAR list_draw (int mode, word* list)
{
  int x = 2;
  int y;

  Box (1, 29, 146, 157, 10);
  for (y = 38; y < 158; y += 10)
    Line (2, y, 145, y, 4);

  if (mode == GM_PROG)
    x = 14;

  list += (scrollbar.pos * 2);

  /*LibPutFarData (2, 30, 310);*/

  for (y = 30; (y < 160) && (*list & GF_ISENTRY); y += 10, list += 2)
    LibPutProStr (IB_PFONT1, x, y, Near (((uchar FAR*) xdata) + *(list + 1)), 146 - 11);
}

static int NEAR mainmenu_options (void)
{
  int n;
  int rval = 0;

  msg_mm_cache[13] = switches.savetocache ? ' ' : '\0';

  dlist (15, 10, 112, OPTIONSMENU_CNT, OPTIONSMENU_LINES, optionsmenu);

  LibPutDisp ();

  while ((n = qlist (15, 10, 112, OPTIONSMENU_CNT)) == LIST_NONE);
  switch (n)
  {
  case 0: /* settings */
    ITOS.min = 0; /* search all categories */
    switches.statistics = FALSE;
    switches.progsub = switches.includesub = 0;
    switches.quiet = TRUE;
    strcpy_nf (ITOS.fname, (uchar FAR*) msg_mm_settings_progname);
    rval = 1;
    break;
  case 1: /* find runtime error */
    Restart (STATUS_FIND_RTE);
    break;
#ifdef LSI_C
  case 2: /* enter remote mode */
    /*Restart (STATUS_RC);*/
    rval = 3;
    break;
  case 3: /* cache program */
    switches.savetocache = !switches.savetocache;
    break;
  case 4: /* about OWBasic */
    rval = 2;
#else
  case 2: /* cache program */
    switches.savetocache = !switches.savetocache;
    break;
  case 3: /* about OWBasic */
    rval = 2;
#endif
  }

  return (rval);
}


static int NEAR mainmenu_category (void)
{
  int i;
  int c;
  int n = 0;
  char names[20 * 12];
  char FAR* labels[12];

  for (i = 0; i < 12; ++i, n += 20)
  {
    if ((c = i % 6) == 0)
      strcpy (names + n, msg_mm_all);
    else
    {
      LibLblAreaRead ((uchar*) (names + n), 0x04 + c);
      if (names[n] == 0)
      {
        strcpy_nf ((uchar*) (names + n), (uchar FAR*) msg_mm_category);
        names[n + 9] += c;
      }
    }
    if (i >= 6)
      strcat (names + n, msg_mm_secret);
    labels[i] = names + n;
  }

  dlist (0, 24, 129, 12, 32, labels);
  LibPutDisp ();

  while ((n = qlist (0, 24, 129, 12)) == LIST_NONE);
  if (n == LIST_EXIT)
    return (FALSE);
  if (n >= 6)
    n += 10;
  switches.progsub = n;
  return (TRUE);
}


void mainmenu (int mode)
{
  TCHSTS tsts;
  int i;
  int status = 0;
  /*word* list = (word*) bin;*/

  GM_FILTER[0] = 0;

 reload:
  scrollbar.pos = 0;
  LibTchStackClr ();
  LibTchStackPush (NULL);
  LibTchStackPush (TchAllDsp);
  LibTchStackPush (TchHardIcon);
  LibTchStackPush (TchScrollBar);

  list_load ();

repaint:
  mainmenu_draw (mode);
  LibPutDisp ();
  LibTchInit ();

  if (status == 2)
  {
    status = 0;
    msgbox ((uchar*) Near (msg_about), (uchar*) msg_mm_about, 0.0, MBX_OK);
    goto repaint;
  }
  if (status == 3)
    Restart (STATUS_RC);

  while (status != 1)
  {
    LibTchWait (&tsts);
    if (tsts.obj == OBJ_SCR_BAR)
    {
      if (LibScrollClick (&tsts, &scrollbar) != 0x04)
      {
        list_draw (mode, mainmenu_list);
        LibPutDisp ();
      }
    }
    else
    {
      *tchxp = tsts.x; *tchyp = tsts.y;
      newtouched = touched = TRUE;
#ifdef __HITACHI__
      rtch = TRUE;
#endif

      if (tchinside (36, 13, 120, 24)) /* filter input field */
      {
        inputstr ((char*) GM_FILTER, 39, 16, 118, 1, IB_PFONT1, MAXSTRLEN);
        goto reload;
      }

      if (qbox (129, 0, 158, 10)) /* "Tools" */
        LibFuncPtool ();

      if (qbox (13, 13, 23, 23)) /* category dropdown menu */
      {
        if (mainmenu_category ())
          goto reload;
        goto repaint;
      }

      if (qbox (15, 0, 56, 10)) /* "Options" */
      {
        status = mainmenu_options ();
        goto repaint;
      }

      touched = FALSE;
      if ((i = qlist (1, 28, 146, ((scrollbar.vol < 13) ? scrollbar.vol : 13))) != LIST_NONE)
        if (i != LIST_EXIT)
        {
          if (i >= scrollbar.vol)
            continue;
          i = (i + scrollbar.pos) << 1;
          if (mainmenu_list[i] & GF_ISDIR)
          {

          }
          else
          {
            /*ITOS.min = list[i] >> 8;*/
            ITOS.min = *(((int FAR*) (((uchar FAR*) xdata) + mainmenu_list[i + 1])) - 1) & 0x0F;
            strcpy_nf (ITOS.fname, ((uchar FAR*) xdata) + mainmenu_list[i + 1]);
            /*LibPutMsgDlg ("cat:%d\rname:\r%s", ITOS.min, ITOS.fname);*/
            break;
          }
        }
    }
  }
}


