#include <owbasic.h>
#include "inter.h"
#include <graphic.h>

/*
 * ICONS are the bitmaps of pv
 *
 * to stay compatible to pv<1600 the pv1600 stores icons
 * in the same way as array of int.
 * Because of changed sizes and endiness this requires
 * reorganisation before calling libfunctions which
 * take icons as byte[];
 */

const int icon_bitmask[16]={0x0080,0x0040,0x0020,0x0010,
          0x0008,0x0004,0x0002,0x0001,
          0x8000,0x4000,0x2000,0x1000,
          0x0800,0x0400,0x0200,0x0100};

#if FALSE
#ifdef __HITACHI__
const int drawiconmodes[] = {IB_GPOVER, IB_GPOR, IB_GPAND, IB_GPOVER, IB_GPOVER}; /* IB_GPREV and IB_GPMESH are not available on PV-S1600 */
#else
const int drawiconmodes[] = {IB_GPOVER, IB_GPOR, IB_GPAND, IB_GPREV, IB_GPMESH};
#endif
#endif

void iconaddr0(int FAR *aa,int ox,int oy,int *bm,int FAR **p)
{
  int sx, sxm;
  int bo;
  sx=*aa;   /* read iconsize */
  sxm=((sx-1) | 7 ) +1; /* next multiple of 8 */
  bo=oy*sxm+ox;  /* bitoffset */
  *p=aa+2+(bo / 16);
  *bm=icon_bitmask[bo % 16];
}

bool iconaddr(int FAR *aa,int ox,int oy,int *bm,int FAR **p)
{
  int sx,sy;
  sx=*aa; sy=*(aa+1);   /* read iconsizes */
  if ((ox<0)||(ox>=sx)||(oy<0)||(oy>=sy)) return FALSE;
  iconaddr0(aa,ox,oy,bm,p);
  return TRUE;
}

/* Functions on OWB-Arrays */

#ifdef __HITACHI__
static int dummy; /* make iconbuffer word aligned */
byte iconbuffer[3204];
static int dummy2; /* reserve overflow space */

int deref_intp (int* ptr)
{
  register byte* bp = (byte*) ptr;

  if ((((int) ptr) & 0x01) == 0)
    return (*ptr);
  return (((*bp)      << 24)
      || ((*(bp + 1)) << 16)
      || ((*(bp + 2)) << 8)
      ||  (*(bp + 3)));

}
void toiconbuffer (byte* src)
{
  int sx, sy;
  int size;
  short *sptr;
  byte *bptr;
  int* srcptr = (int*) src;

  memcpy ((byte*) &sx, src, sizeof (int));
  memcpy ((byte*) &sy, src + sizeof (int), sizeof (int));
  size = ((sx + 7) / 8) * sy + 4;
  if (size > 3208)
    size = 3208;
  sptr = (short*) iconbuffer;
  *(sptr++) = deref_intp (srcptr++);
  *(sptr++) = deref_intp (srcptr++);
  bptr = (byte*) sptr;
  while (bptr < iconbuffer + size)
    {
      *(bptr++) = deref_intp (srcptr) & 0xFF;
      *(bptr++) = (deref_intp (srcptr) >> 8) & 0xFF;
      ++srcptr;
    }

/*  int sx, sy;
  int size;
  int i = 0;
  byte* dest;
  short* sptr = (short*) iconbuffer;

  memcpy ((byte*) &sx, src, sizeof (int));
  memcpy ((byte*) &sy, src + sizeof (int), sizeof (int));
  size = (((sx + 7) / 8) * sy + sizeof (int) - 1) / sizeof (int); /+ size in integers +/
  if (size > 1604)
    size = 1604;

  sptr = (short*) dest;
  *(sptr++) = sx;
  *(sptr++) = sy;
  dest = (byte*) sptr;
  src += sizeof (int) * 2;

  OutputITrm (sx); OutputITrm (sy); OutputITrm (size);
  while (i < size)
  {
    *(dest++) = *(src + 3);
    *(dest++) = *(src + 2);
    OutputITrm (*(src + 3) | (*(src + 2) << 8));
    src += sizeof (int);
    ++i;
  }
  OutputTrm ("fin\r");
}*/

  /*short *sptr;
  byte *bptr;
  int sindex;

  sptr=(short*)iconbuffer;
  sindex=((int*) src) - xdata;
  *(sptr++)=xdata[sindex++];
  *(sptr++)=xdata[sindex++];
  bptr=(byte*)sptr;
  while (bptr<iconbuffer+3204)
    {
      *(bptr++)=xdata[sindex] & 0xff;
      *(bptr++)=(xdata[sindex] >> 8) & 0xff;
      sindex++;
    }*/
}

void fromiconbuffer (int addr)
{
  byte *bptr;
  short *sptr;
  int sx,sy,sxm,rsize;
  int sindex=addr;

  sptr = (short*) iconbuffer;
  sx=xdata[sindex++] = *(sptr++); /* x size */
  sy=xdata[sindex++] = *(sptr++); /* y size */

  sxm=(sx+7)/8; /* line size in bytes */
  rsize=(sxm*sy+1)/2+2; /* size in "ints" */

  bptr=(byte*)sptr;

  while (sindex<addr+rsize)
    {
      xdata[sindex++]=*(bptr+1)*256+*bptr;
      bptr+=2;
    }
}
#endif

bool checkicon (int sx, int sy, int size)
{
  /*int sx,sy;*/ /* iconsize (pixel)*/
  int sxm;
  int rsize; /* required size (int) */
  if (!checkxy (sx - 1,sy - 1))
    return FALSE;/* invalid sizes! */
  sxm = (sx + 7) >> 3; /* line size in bytes */
  rsize = (sxm * sy + sizeof (int) - 1) / sizeof (int) + 2; /* size in ints */
  return (size >= rsize);
}

#if FALSE
int drawicon (byte FAR* addr, int x, int y, int mode)
{
#ifdef LSI_C
  int FAR* info = (int FAR*) (addr - 2);
#endif
#ifdef __HITACHI__
  int info[3];
  byte* bptr;
  short* sptr;
  int sindex;

  memcpy (&info, addr - sizeof (int), sizeof (int) * 3); /* size, xs, ys */
#endif

  /*LibPutMsgDlg ("%d,%d,%d", info[0], info[1], info[2]);*/
  if (!checkicon (info[1], info[2], info[0]))
    return (59);
  if (!checkxy2 (x, y, x + info[1] - 1, y + info[2] - 1))
    return (65);

#ifdef __HITACHI__
  toiconbuffer (addr);
#endif
  if (mode == 0)
  {
#ifdef LSI_C
    LibPutGraph (x, y, addr);
#endif
#ifdef __HITACHI__
    LibPutGraph (x, y, iconbuffer);
#endif
  }
  else
  {
    if ((mode < 0) || (mode > 4))
      return (38);
#ifdef LSI_C
    LibPutGraphO (x, y, addr, drawiconmodes[mode]);
#endif
#ifdef __HITACHI__
    LibPutGraphO (x, y, iconbuffer, drawiconmodes[mode]);
#endif
  }
  return 0;
}
#endif

int geticon(int addr,int x1,int y1,int x2,int y2)
{
  int size;
  int sx = x2 - x1 + 1, sy = y2 - y1 + 1;
#ifdef __HITACHI__
  byte *bptr;
  short *sptr;
  int sindex;
#endif
  if (!checkxy2(x1,y1,x2,y2)) return 65;
  size=xdata[addr-1];
  xdata[addr]=sx;
  xdata[addr+1]=sy;
  if (! checkicon(sx, sy, size)) return 59;
  if (sx <9) return 39;
#ifdef LSI_C
  LibGetGraph(x1, y1, sx, sy, (byte FAR*)&xdata[addr+2]);
#endif
#ifdef __HITACHI__
  ((short*)iconbuffer)[0]=sx;
  ((short*)iconbuffer)[1]=sy;
  LibGetGraph(x1, y1, sx, sy,&(iconbuffer[4]));
  fromiconbuffer (addr);
#endif
  return 0;
}
