#include <string.h>
#include <stdlib.h>
#include <modecall.h>
#include "owbasic.h"
#include "shared.h"
#include "fnames.h"
#include "sound.h"
#include "getbatt.h"
#include "inter.h"
#include "comp.h"
#include "graphic.h"
#include "srl.h"

#pragma optimize time

uchar block_errors = 0;

/* for event_mask */
#define EVENT_TCH       1
/* unknown mask xxx */
#define EVENT_XXX       2
#define EVENT_CRADLE    4
#define EVENT_BLD1      8

#ifdef LSI_C
#define BREAKTESTCOUNT 1000
int bk_counter;    /* instructions until break test */
#endif

bool touched, newtouched;
byte ex = FALSE;

static char fformat[20] = FFORMATSTD;
static PC addr;

jmp_buf rterrorret;

bool auto_btn = TRUE;
bool auto_off = TRUE;

bool useexithandler = TRUE;

#ifdef LSI_C
unsigned int auto_off_counter;

static void NEAR set_auto_off (void)
{
  if (!TimerRuns)
    StartTimer ();
  auto_off_counter = counter + LibGetAPOTime () * 20;
}

bool switch_off (void)
{
  void (FAR* SysOff) (int);

  switch (getmodel ())
  {
  case 1: /* PV-250X/-450X */
    SysOff = MK_FP (0xC400, 0x07C6);
    break;
  case 2: /* PV-750(+) */
    SysOff = MK_FP (0xC400, 0x07E4);
    break;
  case 3: /* PV-S250/-S450 */
    SysOff = MK_FP (0xC400, 0x0835);
    break;
  case 4: /* PV-S460/-S660/S400+/S600+ */
    SysOff = MK_FP (0xC400, 0x07C4);
    break;
  default:
    return (0);
  }

  LibELHandle (IB_ELP_OFF);
  LibSrlPortClose ();

  PauseTimer ();
  SysOff (0);
  newtouched = FALSE;
  ContinueTimer ();
  if (auto_off)
    set_auto_off ();

  return (1);
}

void swap_light (void)
{
  if (inp (196) == 12)
    LibELHandle (0);
  else
    outp (196, 12);

  newtouched = FALSE;
}

bool check_touch (void)
{
  TCHSTS tsts;
  union REGS reg;
  bk_counter = BREAKTESTCOUNT;
  reg.x.ax = 0x0200 | EVENT_TCH | EVENT_CRADLE;
  reg.x.di = FP_OFF (&tsts);
  reg.x.es = FP_SEG (&tsts);
  int86 (0x50, &reg, &reg);
  *tchobjp = tsts.obj;
  *tchstsp = tsts.act;
  if (tsts.x != -1 || tsts.y != -1)
  {
    *tchxp = tsts.x; *tchyp = tsts.y;
    if (!touched)
      newtouched = TRUE;
    touched = TRUE;

    if (auto_off)
      set_auto_off ();
  }
  else
    touched = FALSE;
  return (newtouched);
}
#endif

#ifdef __HITACHI__
bool switch_off (void)
{
  unsigned long* p = (unsigned long*) 0x8C05EF50; /* PVOS 0.9 */

  if (*p == 0x8C018E5C)
  {
    p = (unsigned long*) 0x8C018E5C;
    *p = 0;
    return (1);
  }

  p = (unsigned long*) 0x8C05EF84; /* PVOS 1.0 */
  if (*p == 0x8C01827C)
  {
    p = (unsigned long*) 0x8C01827C;
    *p = 0;
    return (1);
  }

  p = (unsigned long*) 0x8C05F06C; /* PVOS 1.1 */
  if (*p == 0x8C01827C)
  {
    p = (unsigned long*) 0x8C01827C;
    *p = 0;
    return (1);
  }

  return (0); /* variable reference not found */
}

void check_switchoff (void)
{
  PauseTimer ();
  LibPutMsgDlg ((byte*) ("Press OFF")); /* not very good, but works */
  ContinueTimer ();
}


#if FALSE
void swap_light (void)
{
  LibELHandle (LibGetEL () ? 0 : 2);
}
#endif

int leverpush = 0;

bool rtch = FALSE;

bool check_touch (void)
{
  int touchresult;
  TCHSTS tsts;

  if (!auto_off)
    LibSetAPOTime (LibGetAPOTime ()); /* keep PV alive, even without touch */

  LibTchStackPush (TchAllDsp);
  LibTchStackPush (TchActionKey);
  LibTchStackPush (TchHardIcon);

  touchresult = LibTchWaitScan (&tsts);

  LibTchStackPop ();
  LibTchStackPop ();
  LibTchStackPop ();

  if (touchresult)          /* an input */
  {
    switch (tsts.obj)
    {
    case OBJ_LPSW_PUSH:
      leverpush = 2;
      break;

    case OBJ_LPSW_UP:
      leverpush = 1;
      break;

    case OBJ_LPSW_DOWN:
      leverpush = 3;
      break;

    case OBJ_LPSW_LEFT:
      leverpush = 6;
      break;

    case OBJ_LPSW_RIGHT:
      leverpush = 7;
      break;

    case OBJ_NONE:
      leverpush = 0;

    default: /* display and hardicons */
      switch (tsts.act)
      {
      case ACT_MAKE:     /* newtouch */
        if (!touched)
          newtouched = TRUE;
        rtch = touched = TRUE;
        break;

      case ACT_BREAK:
        rtch = touched = FALSE;
        break;
      }
      *tchstsp = tsts.act;
      *tchobjp = tsts.obj;
      *tchxp = tsts.x; *tchyp = tsts.y;
    }
  }
  else
  {
    leverpush = 0;
    if (*tchyp >= 160)
      rtch = touched = FALSE;
    if (rtch && !touched)
      newtouched = touched = TRUE;
  }

  return (newtouched);
}

#define getleverpush()  leverpush
#endif

void x_leverpush (void)
{
  ipush (getleverpush ());
}

void WaitNoTouch (void)
{
  newtouched = FALSE;
  LibPutDisp ();
  while (touched)
    check_touch ();
}



bool verify_abort (void)
{
  if (!pref.askabort)
    return (TRUE); /* abort without asking user */
  return (msgbox (msg_abort, NULL, 0.0, MBX_YESNO));
}

void x_print_int (void) { OutputITrm (ipop ()); }

void x_print_boolean (void)
{
  uchar hchar[8];
  strcpy_nf (hchar, ipop () ? FN_TRUE : FN_FALSE);
  OutputTrm (hchar);
  OutTrm (' ');
}

void x_print_tab (void) { OutTrm (0x09); }
void x_print_nl (void) { OutTrm (0x0D); }
void x_print_end (void) { DisplayTrm ();
#ifdef LSI_C
bk_counter = 0;
#endif
}

void x_call (void)
{
  GETPCPC (addr);
  gpush (pc);
  pc = addr;
}

void x_call_fptr (void)
{
  int addr = ipop ();
  gpush (pc);
  if (addr)
    pc.c = (codet*) (addr);
  else
  {
    block_errors = 0; /* error must not be blocked */
    rterror (FN_CALL, 41);
  }
}

void x_call_overlay (void)
{
  int procnr, proclen;

  GETIPC (procnr);
  GETPCPC (addr);
  gpush (pc);
  pc = addr;
  ++pc.i;
  GETIPC (proclen);
  if (*(addr.i) != procnr) /* already loaded ? */
  {
    Overlay (OV_LOAD, procnr, addr.c, proclen);
    *(addr.i + 1) = proclen;
  }
}

void x_return (void)
{
  pc = gpop ();
}


/*
 * SETJUMP/JUMP:
 *  ADDR: pointer to memory block where interpreter information is stored
 *        the array must have capacity of #JUMPBUFSIZE
 *
 *  xdata[addr]     - address of SETJUMP command
 *  xdata[addr + 1] - call stack pointer position
 */

int jumpval = 0;

bool jump (int addr, int statval)
{
  register int a = xdata[addr];

  if ((a == 0) || (*((codet*) a) != B_SETJUMP))
  {
    xdata[errorhandler] = 0;
    rterror (FN_JUMP, 41);
  }

  if ((jumpval = statval) == 0)
    --jumpval;
  pc.c = (codet*) (a);
  g_stack_ptr = g_stack + xdata[addr + 1];
}


void x_setjump (void) /* SETJUMP%(ADDR%[]) (MB,4.50) */
{
  int addr;

  if (jumpval == 0)
  {
    addr = ipop ();
    xdata[addr]     = (int) (pc.c - 1);
    xdata[addr + 1] = g_stack_ptr - g_stack;
  }

  ipush (jumpval);
  jumpval = 0;
}

void x_jump (void) /* JUMP ADDR%[], statval% (MB,4.50) */
{
  int statval = ipop ();

  jump (ipop (), statval);
}


void x_end (void)
{
  int mode = ipop ();
  --pc.c;
#ifdef LSI_C
  bk_counter = 0;
#endif
  LibSrlPortClose ();
  LibBuzzerOff ();
  LibPutDisp ();
  if (!switches.remote) /* only wait if not in remote control mode */
    switch (mode)
    {
    case 0: /* no wait */; break;
    case 1: /* silent wait */
      newtouched = FALSE;
      while (!check_touch ()) /* Wait for new touch */ ;
      break;
    case 2: msgbox1 (msg_finished);
      break;
    }
  ex = TRUE;
}

void x_end0 (void)
{
  ipush (pref.finalwait);
  x_end ();
}

void x_cls (void)
{
  switch (ipop ())
  {
  case 1: OutTrm (0x0C); DisplayTrm (); break;
  case 2: LibClrDisp (); break;
  }
}

void x_cls0 (void)
{
  OutTrm (0x0C);
  DisplayTrm ();
}

/*------------------------------------*/
void x_forcheck (void)
{
  int vaddr, vvalue;
  GETIPC (vaddr); vvalue = xdata[vaddr];
  GETPCPC (addr);
  if (vvalue > ipop ())
    pc = addr;
}

void x_forcheckn (void)
{
  int vaddr, vvalue;
  GETIPC (vaddr); vvalue = xdata[vaddr];
  GETPCPC (addr);
  if (vvalue < ipop())
    pc = addr;
}
/*-------------------------------------------*/
#define compare(rel) int i = ipop_fast (); TOS = TOS rel i;

void x_less_ii (void) { compare(<); }
void x_equal_ii (void) { compare(==); }
void x_greater_ii (void) { compare(>); }
void x_not_less_ii (void) { compare(>=); }
void x_not_equal_ii (void) { compare(!=); }
void x_not_greater_ii (void) { compare(<=); }

/*------------------------------------*/

#if FALSE
void x_memalloc (void) /* MEMALLOC PTR%, size% (MB,5.00) */
{
  int size = ipop ();
  int ptr = ipop ();


}

void x_memfree (void) /* MEMFREE PTR% (MB,5.00) */
{

}
#endif

/*------------------------------------*/

void x_assign (void)   { int addr; GETIPC (addr); xdata[addr] = ipop (); }

void x_assign_i (void) { int vi = ipop (); xdata[ipop ()] = vi; }
void x_assign_f (void) { int addr = ipop (); fstore (addr, fpop ()); }
void x_assign_s (void) { int addr = ipop (); spop (addr); }


static void NEAR _checkindex (int addr, uchar mul)
{
  if ((TOS < 0) || (TOS >= xdata[addr - 1]))
  {
    sprintf ((char*) rterrormsg, (Near (msg_index1)), TOS);
    rterror (FN_ARRAY, 1030);
  }
  else
    TOS = addr + (TOS << mul);
}

static void NEAR _checkindex2 (int addr, uchar mul)
{
  int index2 = ipop ();
  int index = ipop () * xdata[addr - 2] + index2;
  if ((index2 < 0) || (index2 >= xdata[addr - 2]) || (index < 0) || (index >= xdata[addr - 1]))
  {
    sprintf ((char*) rterrormsg, (Near (msg_index2)), index, index2);
    rterror (FN_ARRAY, 1030);
  }
  ipush (addr + (index << mul));
}

void x_getvar (void)    { int addr; GETIPC (addr); ipush (xdata[addr]); }
void x_getvar_f (void)  { int addr; GETIPC (addr); fpush (fdata (addr)); }
void x_getvar_s (void)  { int addr; GETIPC (addr); spush (addr); }
/*void x_getvar_b (void)  { int addr; GETIPC (addr); ipush (xdata[addr]); }*/

void x_getvar2 (void)   { int addr; GETIPC (addr); ipush (xdata[xdata[addr]]); }
void x_getvar2_f (void) { int addr; GETIPC (addr); fpush (fdata (xdata[addr])); }
void x_getvar2_s (void) { int addr; GETIPC (addr); spush (xdata[addr]); }
/*void x_getvar2_b (void)  { int addr; GETIPC (addr); ipush (xdata[xdata[addr]]); }*/

void x_getvari (void)   { int addr = ipop (); ipush (xdata[addr]); }
void x_getvari_f (void) { int addr = ipop (); fpush (fdata (addr)); }
void x_getvari_s (void) { int addr = ipop (); spush (addr); }
/*void x_getvari_b (void) { int addr = ipop (); ipush (xdata[addr]); }*/

void x_getarrvar (void)      { int addr; GETIPC (addr); _checkindex (addr, 0); }
void x_getarrvar2 (void)     { int addr; GETIPC (addr); _checkindex (xdata[addr], 0); }
void x_getncarrvar2 (void)   { int addr; GETIPC (addr); TOS += xdata[addr]; }

void x_getarrvar_f (void)    { int addr; GETIPC (addr); _checkindex (addr, FLOATSIZE >> 1); }
void x_getarrvar2_f (void)   { int addr; GETIPC (addr); _checkindex (xdata[addr], FLOATSIZE >> 1); }
void x_getncarrvar2_f (void) { int addr; GETIPC (addr); TOS = xdata[addr] + (TOS * FLOATSIZE); }

/*void x_getarrvar_b (void)    { int addr; GETIPC (addr); _checkindex (addr, 0); }
void x_getarrvar2_b (void)   { int addr; GETIPC (addr); _checkindex (xdata[addr], 0); }
void x_getncarrvar2_b (void) { int addr; GETIPC (addr); TOS += xdata[addr]; }*/

void x_getarr2var (void)     { int addr; GETIPC (addr); _checkindex2 (addr, 0); }
void x_getarr2var2 (void)    { int addr; GETIPC (addr); _checkindex2 (xdata[addr], 0); }

void x_getarr2var_f (void)   { int addr; GETIPC (addr); _checkindex2 (addr, FLOATSIZE >> 1); }
void x_getarr2var2_f (void)  { int addr; GETIPC (addr); _checkindex2 (xdata[addr], FLOATSIZE >> 1); }

/*void x_getarr2var_b (void)   { int addr; GETIPC (addr); _checkindex2 (addr, 0); }
void x_getarr2var2_b (void)  { int addr; GETIPC (addr); _checkindex2 (xdata[addr], 0); }*/

void x_getncarrvari_f (void)
{
  int vi = ipop ();
  TOS += vi * FLOATSIZE;
}

void x_arraysize (void)
{
  int mode = ipop ();
  int size = xdata[TOS - 1];
  int rowsize = xdata[TOS - 2];

  switch (mode)
  {
  case 0:
    TOS = size - 1;
    break;
  case 1:
    if (rowsize)
      TOS = size / rowsize - 1;
    else
      TOS = size - 1;
    break;
  case 2:
    TOS = rowsize - 1;
    break;
  }
}

void x_arraysize1 (void)
{
  TOS = xdata[TOS - 1] - 1;
}

/*void x_inci(void) {int addr; GETIPC(addr);  xdata[addr]++; }
void x_inci2(void) {int addr; int vi;GETIPC(addr);GETIPC(vi);xdata[addr]+=vi;}*/

#ifndef LSI_C
void x_jmp (void)
{
  GETPCPC (addr);
  pc = addr;
}

void x_jmpif (void)
{
  GETPCPC (addr);
  if (!ipop ())
    return;
  pc = addr;
}

void x_jmpifnot (void)
{
  GETPCPC (addr);
  if (ipop ())
    return;
  pc = addr;
}
#else
void x_jmp (void) {};
void x_jmpif (void) {};
void x_jmpifnot (void) {};
#endif

void x_next (void)
{
  int daddr;

  GETIPC (daddr);
  ++xdata[daddr];

  GETPCPC (addr);
  pc = addr;
}

void x_next2 (void)
{
  int daddr;
  int vi;

  GETIPC (daddr);
  GETIPC (vi);
  xdata[daddr] += vi;

  GETPCPC (addr);
  pc = addr;
}

int case_val;

void x_case (void)
{
  case_val = ipop ();
}

void x_of_e (void) /* CASE a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  if (aval != case_val)
    pc = addr;
}

void x_of_ne (void) /* CASE not a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  if (aval == case_val)
    pc = addr;
}

void x_of_bound (void) /* CASE a to b: (MB,4.10) */
{
  int low, high;

  high = ipop ();
  low  = ipop ();
  GETPCPC (addr);
  if ((case_val < low) || (case_val > high))
    pc = addr;
}

#if FALSE
void x_of_nbound (void) /* CASE not a to b: (MB,4.10) */
{
  int low, high;

  high = ipop ();
  low  = ipop ();
  GETPCPC (addr);
  if ((case_val >= low) || (case_val <= high))
    pc = addr;
}
#endif

void x_of_a (void) /* CASE >a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  /* LibPutMsgDlg ("case >"); */
  if (case_val <= aval)
    pc = addr;
}

void x_of_ae (void) /* CASE >=a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  /* LibPutMsgDlg ("case >="); */
  if (case_val < aval)
    pc = addr;
}

void x_of_be (void) /* CASE <=a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  /* LibPutMsgDlg ("case <="); */
  if (case_val > aval)
    pc = addr;
}

void x_of_b (void) /* CASE <a: (MB,4.10) */
{
  int aval = ipop ();
  GETPCPC (addr);
  /* LibPutMsgDlg ("case <"); */
  if (case_val >= aval)
    pc = addr;
}


void x_inc1 (void) { int addr = ipop (); ++xdata[addr]; }
void x_inc (void)  { int vi = ipop (); int addr = ipop (); xdata[addr] += vi; }
void x_dec1 (void) { int addr = ipop (); --xdata[addr]; }
void x_dec (void)  { int vi = ipop (); int addr = ipop (); xdata[addr] -= vi; }

void x_and_ii (void) { int vi = ipop (); TOS &= vi; }
void x_or_ii (void)  { int vi = ipop (); TOS |= vi; }
void x_xor_ii (void) { int vi = ipop (); TOS ^= vi; }

void x_and_bb (void) { int vi = ipop (); TOS = TOS && vi; }
void x_or_bb (void)  { int vi = ipop (); TOS = TOS || vi; }
void x_xor_bb (void) { int vi = ipop (); TOS = (!TOS && vi) || (TOS && !vi); }
void x_not (void)    { TOS = !TOS; }
void x_not_i (void)  { TOS = ~TOS; }

void x_add_ii (void) { int vi = ipop (); TOS += vi; }
void x_sub_ii (void) { int vi = ipop (); TOS -= vi; }
void x_mul_ii (void) { int vi = ipop (); TOS *= vi; }

#ifdef __HITACHI__
void x_muldiv (void)
{
  long int il;
  int id, ifak;
  id = TOS; ifak = ST1; il = ST2;
  il *= ifak;
  if (id == 0)
    rterror (FN_MULDIV, 57);
  else
    il /= id;
  ST2 = il;
  ipopn (2);
}
#endif


void x_sysdlg (void) /* SYSDLG nr% (MB,4.10) */
{
  int nr;

  nr = ipop ();
  switch (nr)
  {
  case 0: /* Pop-up tools */
    LibFuncPtool ();
    break;
  case 1: /* calculator */
    LibCalWin (OFF); /* no "copy to clipboard" button */
    break;
  case 2: /* flash remake */
    LibFuncMemoryManagement ();
    break;
  case 3: /* date time settings dialog */
    LibFuncDateTime ();
    break;
  case 4: /* sound settings dialog */
    LibFuncSound (0);
    break;
  case 5: /* format settings dialog */
    LibFuncFormat ();
    break;
  case 6: /* capacity showing window */
    LibFuncCapa ();
    break;
  case 7: /* contrast settings dialog */
    LibFuncContrast ();
    break;
  case 8: /* touch panel calibration dialog */
    LibFuncDigitizer ();
    break;
  case 9: /* Add-In download dialog */
    LibExeAddin ();
    break;
  case 10: /* Sync dialog */
    LibCrdlOpnJmp ();
    break;
  }
}

void x_div_ii (void)
{
  int vi = ipop ();
  if (vi == 0)
  {
    block_errors = 0;
    rterror (FN_DIV, 57);
  }
  TOS /= vi;
}
void x_mod_ii (void)
{
  int vi = ipop ();
  if (vi == 0)
    rterror (FN_MOD, 57);
  TOS %= vi;
  if (TOS < 0)
    TOS += vi;
}

void x_pow_ii (void)
{
  int vi = ipop ();
  int i = 1;
  int k;
  for (k = 0; k < vi; ++k)
    i *= TOS;
  TOS = i;
}

void x_seti (void) /* Syntax: SETI ARR%[], from%, to%, val% (MB,4.10) */
{
  int val;
  int from;
  int to;
  int addr;

  val  = ipop ();
  to   = ipop ();
  from = ipop ();
  addr = ipop ();

  if (to < from)
    return;
  if (to >= xdata[addr - 1])
    rterror (FN_SETI, 30);

  to += addr;
  from += addr;

  for (; from <= to; ++from)
    xdata[from] = val;
}

void x_seti3 (void)
{
  ipush (0);
  x_seti ();
}

void x_clear (void)
{
  ipush (0);
  ipush (xdata[ST1 - 1] - 1);
  x_seti3 ();
}


void x_neg(void)   { TOS = -TOS; }
void x_imm(void)   { int i; GETIPC (i); ipush (i); }
void x_imm0(void)  { ipush (0); }
void x_imm1(void)  { ipush (1); }
void x_imm2(void)  { ipush (2); }
void x_immm1(void) { ipush (-1); }
/*void x_indir(void) { int index; GETIPC(index); ipush(xdata[index]); }*/

void x_shr (void)  { int s = ipop (); TOS >>= s; }
void x_shl (void)  { int s = ipop (); TOS <<= s; }

void x_shr1 (void) { TOS >>= 1; }
void x_shl1 (void) { TOS <<= 1; }

void x_sgn (void) /* returns -1 for TOS<0, 0 for TOS==0, 1 for TOS>0 (MB,4.10) */
{
  if (TOS != 0)
    if (TOS < 0)
      TOS = -1;
    else
      TOS = 1;
}

void x_abs (void) { if (TOS < 0) TOS = -TOS; }
void x_sqare (void) { TOS *= TOS; }
void x_sqr (void)
{
  int vi, vi1;
  int ct = 0;
  if (TOS < 0)
  {
    rterror (FN_SQR, 36);
    return;
  }
  vi1 = TOS / 2; vi = 0;
  while ((vi != vi1) && (ct < 10))
  {
    vi = vi1;
    vi1 = (TOS / vi + vi) / 2;
    ++ct;
  }
  TOS = vi;
}

void x_min (void) { int vi = ipop (); if (vi < TOS) TOS = vi; }
void x_max (void) { int vi = ipop (); if (vi > TOS) TOS = vi; }

/* ----------------------------- */
void x_conv_si (void) { int vi = atol ((char*) STOS); spop1 (); ipush (vi); }
void x_conv_if (void) { fpush (ipop ()); }
void x_conv_sf (void) { FLOATT vf = atof ((char*) STOS); spop1 (); fpush (vf); }

void x_conv_is (void)
{
  int vi = ipop (); spush1 ();
  sprintf ((char*) STOS, "%d", vi);
}

void x_conv_cs (void)
{
  spush1 ();
  STOS[0] = ipop ();
  STOS[1] = 0;
}

void x_conv_ci (void)
{
  if ((TOS >= '0') && (TOS <= '9'))
    TOS -= '0';
  else
    TOS = 0;
}

void x_conv_fs (void)
{
  FLOATT vf = fpop (); spush1 ();
  sprintf ((char*) STOS, fformat, vf);
}

void x_conv_bs (void)
{
  int b = ipop (); spush1 ();
  if (b)
    strcpy_nf (STOS, FN_TRUE);
  else
    strcpy_nf (STOS, FN_FALSE);
}

/*void x_pop (void)   { int addr = ipop (); xdata[addr] = ipop (); }
void x_push (void)  { int addr = ipop (); ipush (xdata[addr]); }*/
void x_popi (void)  { int addr; GETIPC (addr); xdata[addr] = ipop (); }
void x_pushi (void) { int addr; GETIPC (addr); ipush (xdata[addr]); }
void x_drop (void)  { ipop1 (); }

void x_setfformat (void)
{
  int mod, num, prec;
  char mc;
  prec = ipop ();
  mod = ipop ();
  num = ipop ();
  switch (mod)
  {
  case 1:  mc = 'g'; break;
  case 2:  mc = 'f'; break;
  case 3:  mc = 'e'; break;
  default: rterror (FN_SETFFORMAT, 58);
  }
  sprintf (fformat, FFORMAT, num, prec, mc);
}

void x_setfformat2 (void)
{
  int mod, num;
  char mc;
  mod = ipop ();
  num = ipop ();
  switch (mod)
  {
  case 1: mc = 'g'; break;
  case 2: mc = 'f'; break;
  case 3: mc = 'e'; break;
  default: rterror (FN_SETFFORMAT, 58);
  }
  sprintf (fformat, FFORMAT1, num, mc);
}

void x_setfformat1 (void)
{
  int num;
  num=ipop();
  sprintf(fformat,FFORMAT2,num);
}

void x_setfformat0 (void)
{
  strcpy(fformat,FFORMATSTD);
}

void x_waittouch (void)
{
  newtouched = FALSE;
  while (!check_touch ()); /* Wait for new touch */
  if ((*tchyp > ESC_Y1) && (*tchxp > ESC_X1) && (*tchyp < ESC_Y2)) /* ESC */
    /*ex=TRUE;*/
    ex = verify_abort (); /* "no escape" bug fixed (MB,4.10) */
}

static FLOATT waitend;

void x_wait (void)
{
  /* prepare wait (called one time) */
#ifdef LSI_C
  setintvec ();
#endif
  if (!TimerRuns)
    StartTimer ();
  waitend = Timer () + ipop (); /* end time for wait */
}

void x_wait2 (void)
{
  /* wait process (called until time reached) */
  if (Timer () < waitend) /* end time reached ? */
    --pc.c;               /* no: repeat this step */
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_sync (void)
{
  /* prepare synctimer */
  int rc = InitSync (fpop ());
  if (rc != 0) rterror (FN_SYNC, rc);
}

void x_sync0 (void)
{
  /* wait for sync */
  if (!Sync ())
    --pc.c;
}

void x_system (void)
{
  int vi = ipop ();
  switch (vi)
  {
#ifdef LSI_C
  case 2:
    bk_counter = 0; /* force break poll */
    break;
#endif
    /*    case 3: printstrings(); break;*/
  case 4:
    OutputITrm (firststring - datanext); /* print free string space */
    break;
  case 5:
    garbagecollection (); /* force garbage collection */
    break;
  case 6:
    block_errors = 0 ; /* error messages on */
    break;
  case 7:
    ++block_errors;
    xdata[error] = 0; /* errormessages off */
    break;
  case 8:
  case 9:
    LibSetDispMode (9 - vi);
    break;
  case 10:
    StartTimer ();
    break;
  case 11:
    StopTimer ();
    break;
  case 12:
  case 13:
    auto_btn = 13 - vi;
    break;
  case 14:
#if LSI_C
    set_auto_off ();
#endif
  case 15:
    auto_off = 15 - vi;
    break;
  }
}

void x_syslang (void)
{
  ipush (LibGetLang ());
}

void x_poweroff (void)
{
  switch_off ();
}

void x_getsysvar (void)
{
  int addr = ipop ();
  int n = ipop ();
  /*if (n < 100)*/
    xdata[addr] = ((byte*) (&pref.progsub))[n - 1];
  /*else
    xdata[addr] = ((byte*) (&switches))[n - 100];*/
}

void x_setsysvar (void)
{
  int value = ipop ();
  int n = ipop ();
  if (n < 0)
    savesettings ();
  else
  {
    /*if (n < 100)*/
      ((byte*) (&pref.progsub))[n - 1] = value;
    /*else
      ((byte*) (&switches))[n - 100] = value;*/
  }
}

void x_erroron (void)
{
  if (block_errors > 0)
    --block_errors;
}

void x_erroroff (void)
{
  ++block_errors; /* switch errors off */
  xdata[error] = 0; /* clear old errors */
}

void x_error (void)
{
  rterror (STOS, ipop ());
  spop1 ();
}

void x_locate (void)
{
  int x, y;
  y = ipop (); x = ipop ();
  GotoTrm (x, y);
}

void x_inflocate (void)
{
  int x, y;
  InfTrm (&x, &y);
  xdata[ipop ()] = y; xdata[ipop ()] = x;
}

/* Input */


static void NEAR _input (uchar* str)
{
  xdata[inputrc] = InputTrm (str, MAXSTRLEN - 1);
  if (xdata[inputrc] == TRM_ESC)
    rterror (FN_INPUT, 53);
#ifdef LSI_C
  TimerRuns = 0;
  set_auto_off ();
#endif
}

void x_input (void)
{
  uchar str[MAXSTRLEN];

  _input (str);
  ipush (atoi ((char*) str));
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_input_f (void)
{
  uchar str[MAXSTRLEN];
  FLOATT val;

  _input (str);
  sscanf ((char*) str, FFORMATI, &val);
  fpush (val);
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_input_s (void)
{
  spush1 ();
  _input (STOS);
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_sin (void)
{
  int h = TOS % 360;
  if (h < 0)
    h += 360;
  if (h < 180)
  {
    if (h >= 90)
      h = 180 - h;
    TOS = sin_tab[h];
  }
  else
  {
    if (h < 270)
      TOS = -sin_tab[h - 180];
    else
      TOS = -sin_tab[360 - h];
  }
}

void x_cos (void)
{
  TOS += 90;
  x_sin ();
}

void x_rnd (void)
{
  int sign = FALSE;
  int val, vi;
  if (TOS < 0)
  {
    sign = TRUE;
    TOS = -TOS;
  }
  if (TOS > 0x3FFF)
    vi=0x8000;
  else
  {
    vi = 1;
    while (vi <= TOS)
      vi += vi;
  }
  --vi;
  while ((val = (rand () & vi)) > TOS);
  if (sign)
    TOS = -val;
  else
    TOS = val;
}

void x_rnd_f (void)
{
  /* get floating point pseudo random number */
  switch (ipop ())
  {
  case 1: fpush (rand() * (1.0 / RAND_MAX)); break;
  default: fpush (0.0);
  }
}

void x_randomize (void)
{ /* initialize pseudo random number generator with given seed value */
  srand (ipop ());
}

void x_randomize0 (void)
{
  /* use current time as seed to initialize pseudo random number generator */
  /*word y;
  byte m, d, h, min, sec, dow;
  dow  = LibGetDateTime2 (&y, &m, &d, &h, &min, &sec);
  srand (((h % 4) * 60 + min) * 60 + sec);*/
  ipush (0);
  x_time ();
  x_randomize ();
}

#ifndef LSI_C
static int refday = -1;
#endif

void x_settime (void) /* set time component (MB,4.10) */
{
  int newval;
  word y;
  byte m, d, h, min, sec;

  newval = ipop ();
  LibGetDateTime2 (&y, &m, &d, &h, &min, &sec);
  switch (ipop ())
  {
    /*case 1:                break;*/ /* reset sec to 0 */
    case 2:  min = newval; break;
    case 3:  h   = newval; break;
    case 4:  d   = newval; break;
    case 5:  m   = newval; break;
    case 6:  y   = newval; break;
    default:               return;
  }
  LibSetDateTime2 (y, m, d, h, min);
}

void x_time (void)
{
  /* get time or date component */
#ifdef __HITACHI__
  int day;
#endif
  word y;
  byte m, d, h, min, sec, dow;
  if (TOS < 8)
    dow = LibGetDateTime2 (&y, &m, &d, &h, &min, &sec);
  switch (TOS)
  {
  case 0:
#ifdef LSI_C
    TOS = ((h % 4) * 60 + min) * 60 + sec;
#endif
#ifdef __HITACHI__
    day = LibGetTotalDay2 (y, m, d);
    if (refday < 0)
      refday = day;
    TOS = (((day - refday) * 24 + h) * 60 + min) * 60 + sec;
#endif
    break;
  case 1: TOS = sec; break;
  case 2: TOS = min; break;
  case 3: TOS = h;   break;
  case 4: TOS = d;   break;
  case 5: TOS = m;   break;
  case 6: TOS = y;   break;
  case 7: TOS = dow; break;
#ifdef LSI_C
  case 8: TOS = counter; break;
#endif
#ifdef __HITACHI__
  case 8: TOS = (int) (Timer () * 40.0);
#endif
  }
}

/*
  serial interface
*/

void x_srlopen (void)
{
  int stop, par, rate, bits, fctrl, rc, port;

  port = ipop ();
  fctrl = ipop ();
  stop = ipop ();
  par = ipop ();
  bits = ipop ();
  rate = ipop ();
  rc = srlopen (rate, bits, par, stop, fctrl, port);
  if (rc != 0)
    rterror (FN_SRLOPEN, rc);
}

void x_srlopen0 (void)
{
  int rc;
  rc = srlopen (384, 8, 0, 1, IX_SRL_RSCS, 1);
  if (rc != 0)
    rterror (FN_SRLOPEN, rc);
}

void x_srlclose (void)
{
  if (LibSrlPortClose () != IW_SRL_NOERR)
    rterror (FN_SRLCLOSE, 39);
}

void x_srlsbyte (void)
{
  int byte = ipop ();
  if (LibSrlSendByte (IB_FOLLOW_BUSY, byte) != IW_SRL_NOERR)
    rterror (FN_SRLSBYTE, 39);
}

void x_srlstat (void)
{
  word num, stat;
  LibSrlGetDteStat (&num, &stat);
  ipush (stat);
}

void x_srlrbuf (void)
{
  word num, stat;
  if (LibSrlGetDteStat (&num,&stat) != IW_SRL_NOERR)
    rterror (FN_SRLRBUF, 39);
  ipush (num);
}

void x_srlcstat (void)
{
  ipush (LibSrl232CStat ());
}

void x_srltbuf (void)
{
  ipush (LibSrlGetTBufSpace ());
}

void x_srlrbyte (void)
{
  int rbyte;
  int rc;

  rc = srlrbyte (&rbyte);
  if (rc != 0)
    rterror (FN_SRLRBYTE, rc);
  ipush(rbyte);
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_touch0 (void)
{
  ipush (touched);
}

void x_touch (void) /* TOUCH!%(x1%,y1%,x2%,y2%) (MB,4.25) */
{
  /*int x1, y1, x2, y2;
  y2 = ipop (); x2 = ipop (); y1 = ipop (); x1 = ipop ();
  ipush (touched && (*tchxp >= x1) && (*tchxp <= x2)
                 && (*tchyp >= y1) && (*tchyp <= y2));*/
  x_tchinside ();
  TOS = TOS && touched;
}

void x_tchset (void) /* TCHSET status! (MB,4.25) */
{
  newtouched = ipop ();
}

void x_tchinside (void) /* TCHINSIDE!%(x1%,y1%,x2%,y2%) (MB,4.25) */
{
  int y1, x2, y2;
  y2 = ipop (); x2 = ipop (); y1 = ipop ();
  TOS = ((*tchxp >= TOS) && (*tchxp <= x2)
       && (*tchyp >= y1) && (*tchyp <= y2));
}

void x_touched (void)
{
  x_tchinside ();
  if (TOS = (TOS && newtouched))
    newtouched = FALSE;
}

void x_touched0 (void)
{
  ipush (newtouched);
  newtouched = FALSE;
}


void x_in (void)
{
#ifdef LSI_C
  TOS = (unsigned char) inp (TOS);
#endif
#ifdef __HITACHI__
  rterror (FN_IN, 27);
#endif
}

void x_out (void)
{
  unsigned char val;
  val = ipop ();
#ifdef LSI_C
  outp (ipop (), val);
#endif
#ifdef __HITACHI__
  rterror (FN_OUT, 27);
  ipop ();
#endif
}

void x_peek (void)
{
#ifdef LSI_C
  unsigned char FAR* ptr;
  unsigned long int seg, off;
  off = ipop();
  seg = ipop();
  ptr = (unsigned char FAR*) MK_FP (seg, off);
  ipush(*ptr);
#endif
#ifdef __HITACHI__
  int size;
  int address;
  int val;
  size = ipop ();
  address = ipop ();
  switch (size)
  {
  case 1:
  case 8:  val = *(byte*) address;                 break;
  case 2:
  case 16: val = *(short*) (address & 0xFFFFFFFE); break;
  case 4:
  case 32: val = *(int*) (address & 0xFFFFFFFC);   break;
  }
  ipush (val);
#endif
}

void x_poke (void)
{
#ifdef LSI_C
  unsigned char FAR* ptr;
  unsigned long int seg, off;
  int val;
  val = ipop ();
  off = ipop ();
  seg = ipop ();
  ptr = (unsigned char FAR *) MK_FP (seg, off);
  *ptr = val;
#endif
#ifdef __HITACHI__
  int size;
  int address;
  int val;
  val=ipop();
  size=ipop();
  address=ipop();
  switch (size)
    {
    case 1:
    case 8: *(byte*)address=val; break;
    case 2:
    case 16: *(short*)(address & 0xfffffffe)=val; break;
    case 4:
    case 32: *(int*)(address & 0xfffffffc); break;
    }
#endif
}

void x_buzzer(void)
{
  int x;
  x=ipop();
  if (x<0) LibBuzzerOff();
  else LibBuzzerOn(x);
}

void x_bit(void)
{
  int bo,aa;
  byte FAR *p;
  bo=ipop();
  aa=ipop();
  p=(byte FAR*)&(xdata[aa])+(bo / 8);
  bo=bo % 8;
  ipush((*p >> bo) & 1);
}

void x_byte(void)
{
  int bo,aa;
  byte FAR *p;
  bo=ipop();
  aa=ipop();
  p=(byte FAR*)&(xdata[aa])+bo;
  ipush(*p);
}

void x_setbit(void)
{
  int bo,aa,val;
  byte FAR *p;
  val=ipop(); bo=ipop(); aa=ipop();
  p=(byte FAR *)&(xdata[aa])+(bo / 8);
  bo=bo % 8;
  if (val) *p |= ( 1 << bo);
  else *p &= ~(1 << bo);
}

void x_setbyte(void)
{
  int bo,aa,val;
  byte FAR *p;
  val=ipop(); bo=ipop(); aa=ipop();
  p=(byte FAR *)&(xdata[aa])+bo;
  *p=val;
}

void x_flashsize(void)
{
#ifdef LSI_C
  xdata[ipop()]= mmblocks ();
#else
  xdata[ipop()] = -1;
#endif
  x_flashsize2 ();
}

void x_flashsize2 (void)
{
  xdata[ipop ()] = LibGetFreeBlock ();
  xdata[ipop ()] = LibGetFlash ();
}

void x_bytes(void)
{
  int addr2 = ipop ();
  int addr1 = ipop ();
  int val = ipop ();
  xdata[addr1] = val & 0xFF;
  xdata[addr2] = (val >> 8) & 0xFF;
}

void x_exec (void) /* EXEC prog$ [,cat%] [,showcomp!] [,param$] [,return!=FALSE] (MB,5.03) */
{
  /*int ret = ipop ();*/

  mystatus = 0xE0;

  if (!ipop ())
    mystatus |= STATUS_QUIET;

  if (TOS < 0)
    TOS = 0;

  mc_InitWrite ();
  mc_WriteParam (TOS, SST1, -1);
  if (STOS[0] /*|| ret*/)
  {
    mystatus |= STATUS_PARAM;
    /*mc_WriteInt ((STOS[0] ? 0x01 : 0x00)
               | (ret ? 0x02 : 0x00), MC_DELIM);*/
    if (STOS[0])
      mc_WriteString (STOS, MC_DELIM);
    /*if (ret)
    {
      mc_WriteString (progname, MC_DELIM);
      mc_WriteInt (pc.c - bin, MC_DELIM);
    }*/
  }
  mc_WriteEmpty ();
  mc_WriteEmpty ();

  LibModeJump (mymode, mystatus);
}

void x_exec1 (void)
{
  ipush (0);
  x_exec2 ();
}

void x_exec2 (void)
{
  ipush (1);
  x_exec3 ();
}

void x_exec3 (void)
{
  spush1 ();
  STOS[0] = 0;
  x_exec ();
}

void x_restart (void) /* RESTART status% (MB,5.00) */
{
  Restart (ipop ());
}

void x_modeget(void)
{
  xdata[ipop ()] = mystatus;
  xdata[ipop ()] = mymode & 0xFF;
  xdata[ipop ()] = mymode >> 8;

  /*int a1, a2, a3;
  word mode,status;
#ifdef LSI_C
  word segm,offs;
  LibGetMode(&mode,&status,&segm,&offs);
#endif
#ifdef __HITACHI__
  void *ptr;
  LibGetMode(&mode,&status,&ptr);
#endif
  a3=ipop(); a2=ipop(); a1=ipop();
  xdata[a1]=mode>>8;
  xdata[a2]=mode & 0xFF;
  xdata[a3]=status;*/
}

void x_modename (void)
{
  byte sub_mode;
  byte mode;
  int addr;
  spush1 ();
  addr = ipop (); sub_mode = ipop (); mode = ipop ();
  LibGetProgramName (STOS, mode, sub_mode);
  spop (addr);
}

void x_modefind (void)
{
  word mode_code;
  int maddr, smaddr;
  smaddr = ipop ();
  maddr = ipop ();
  mode_code = mc_FindMode (STOS);
  xdata[smaddr] = mode_code & 0xFF;
  xdata[maddr] = (mode_code >> 8) & 0xFF;
  spop1 ();
}

void x_modejump (void)
{
  int cat, cursorpos;
  cursorpos = ipop ();
  cat = ipop ();
  mc_InitWrite ();
  mc_WriteParam (cat, STOS, cursorpos);
  spop1 ();
  mc_WriteEmpty ();
  mc_WriteEmpty ();
  x_modejump3 ();
}

void x_modejump4 (void)
{
  mc_InitWrite ();
  mc_WriteString (STOS, 0);
  spop1 ();
  mc_WriteEmpty ();
  mc_WriteEmpty ();
  x_modejump3 ();
}

void x_modejump3(void)
{
  byte FAR* pp; /* dummy */
  int mode, status, submode;
  status = ipop ();
  submode = ipop ();
  mode = ipop ();
  if (LibGetMenuIcon (&pp, mode, submode))
    LibModeJump (mode * 256 + submode, status);
  else
    rterror (FN_MODEJUMP, 39);
}


typedef bool (*_modeicon_t) (byte FAR**, byte, byte);

void _modeicon (_modeicon_t modefunc, const uchar FAR* fname)
{
  int icon, submode, mode;
  int i, isize;
  int ix,iy;
  byte FAR* pp;
  byte FAR* dd;
  icon = ipop();
  submode = ipop();
  mode = ipop();
  if (modefunc (&pp, mode, submode))
  {
    ix = *(word FAR*) pp;
    iy = *(word FAR*) &(pp[2]);
    isize = (ix + 7) / 8 * iy + 4;
    dd = (byte FAR*) &(xdata[icon]);
    for (i = 0; i < isize; ++i)
      *(dd++) = pp[i];
  }
  else
    rterror (fname, 39);
}

void x_modeicon (void)
{
  _modeicon (LibGetMenuIcon, FN_MODEICON);
}

void x_modelisticon (void) /* MODELISTICON mode%, submode%, ICON%[] (MB,5.02) */
{
  _modeicon (LibGetListIcon, FN_MODELISTICON);
}

typedef bool (*_libgetver_t) (byte*, byte, byte);
_libgetver_t _libgetver[] = {LibGetModeVer, LibGetLibVer};
void x_modever (void) /* MODEVER$(mode%, submode%, ver%) (MB,5.02) */
{
  int mode, submode, ver;

  ver = ipop ();
  submode = ipop ();
  mode = ipop ();
  spush1 ();
  if ((ver >= 0) && (ver <= 1))
    _libgetver[ver] ((byte*) STOS, mode, submode);
}

/* borrowed from GetOS by Johannes Steingraeber */
#ifdef LSI_C
void _asm_switchbank(char *,int,int);
#define SwitchBank(addr,bank) _asm_switchbank("\n MOV BH,AL\n MOV AL,AH\n MOV AH,BL\n OR AH,80h\n INT 0C8h\n MOV AL,BH\n MOV AH,BL\n INT 0C8h\n",addr,bank);

void x_switchbank(void)
{
  int addr,bank;
  bank=ipop(); addr=ipop();
  if (((addr & 1)!=0)||(bank<1)||(bank==4)||(bank>=6))
    {
      rterror(FN_SWITCHBANK,38);
    }
  else
    {
      SwitchBank(addr,bank);
    }
}

static int cbank1=0xdead;

void x_gpeek(void)
{
  int h,l;
  int bank,segment,offset;
  l=ipop(); h=TOS;
  bank=h & 0xfffe;
  if ((h & 1)==0) segment=0x2000; else segment=0x3000;
  offset=l;
  if (cbank1 != bank)
    SwitchBank(bank,1);
  cbank1=bank;
  TOS=*((unsigned char FAR *)MK_FP(segment,offset));
}
#endif

#ifdef __HITACHI__
void x_switchbank(void) { ipop2(); }
void x_gpeek(void)
{
  int h,l;
  l=ipop(); h=TOS;
  TOS=*((unsigned char*)l);
}
#endif

void x_sound(void)
{
  /* void sound(int ptch, unsigned long dur, int vol); */
  int pitch, duration, volume;
  int rc;
  volume=ipop();
  duration=ipop();
  pitch=ipop();
  rc=sound(pitch, duration, volume);
  if (rc!=0) rterror(FN_SOUND,rc);
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_play(void)
{
  /* void play(uchar *n, unsigned long dur,unsigned int vol); */
  int duration, volume;
  int rc;
  volume=ipop();
  duration=ipop();
  rc=play(STOS, duration, volume);
  spop1();
  if (rc!=0) rterror(FN_PLAY,rc);
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_battstatf (void)
{
  fpush (GetBatt () / 308.9);
}

void x_battstat (void)
{
  ipush (GetBatt ());
}

void x_light (void)
{
  int i = ipop ();
  if ((i < 0) || (i > 2))
    rterror (FN_LIGHT, 38);
  else
  {
#ifdef LSI_C
    if (i < 2)
      LibELHandle (i);
    else
      outp (196, 12);
#endif
#ifdef __HITACHI__
    LibELHandle (i);
#endif
  }
}

void x_light_func (void)
{
#ifdef LSI_C
    ipush (inp (196) == 12);
#endif
#ifdef __HITACHI__
    ipush (LibGetEL ());
#endif
}

void x_getapotime (void)
{
  ipush (LibGetAPOTime ());
}

void x_setapotime (void)
{
  LibSetAPOTime (ipop ());
#ifdef LSI_C
  set_auto_off ();
#endif
}

void x_starttimer (void)
{
  StartTimer ();
}

void x_timer (void)
{
#ifdef LSI_C
  ipush (counter);
#endif
#ifdef __HITACHI__
  ipush ((int) (Timer () * 40.0));
#endif
}

void x_timer_f (void)
{
  fpush (Timer ());
}

void x_stoptimer (void)
{
  StopTimer ();
}

int Exec (PC startpc)
{
  if (setjmp (rterrorret))
    return (FALSE);

  resetstrings ();      /* reset string memory */
  pc = startpc;
  i_stack_ptr = i_stack; /* reset stacks */
  f_stack_ptr.f = f_stack;
  StringStackPointer = -1;
  g_stack_ptr = g_stack;
#ifdef LSI_C
  nbptr = nbuffer;
#endif
  init_global_variables ();
  LibClrDisp ();
#ifdef LSI_C
  TimerRuns = 0;
  set_auto_off ();
#endif

  execute ();
  return (TRUE);
}

#ifdef DEBUGINTER
int lastcodes[10];
/* the interpreter */
int executec (void)
{
  /* the debug version of the interpreter */
  int i;
  int code;

  bk_counter = BREAKTESTCOUNT;
  newtouched = FALSE;
  ex = FALSE;
  breakf = TRUE;

  while (TRUE)
  {
    GETCODEPC (code);

    /* store code for later debugging */
    for (i = 0;i < 9; ++i)
      lastcodes[i] = lastcodes[i + 1];
    lastcodes[9] = code;

    ftable[code] (); /* call interpreter function */
    if (breakf)
    {
      if (ex)
        return; /* end of program */
      if (--bk_counter < 0)
      {
        if ((check_touch ())
         && (*tchyp > ESC_Y1)
         && (*tchxp > ESC_X1)
         && (*tchyp < ESC_Y2)) /* ESC pressed */
          return;
      }
    }
  }
}
#endif


#ifdef __HITACHI__
bool execute_exit (void)
{
  if (useexithandler)
    if (xdata[exithandler])
    {
      useexithandler = ex = 0;
      jump (exithandler, 1);
      return (FALSE);
    }
  return (TRUE);
}

#define TCR0            0xFFFFFE9C
#define BREAKTESTCOUNT  2
/* the interpreter */
int execute (void)
{
  /* the hitachi version of the interpreter */
  register int code;

  newtouched = FALSE;
  ex = FALSE;

  while (TRUE)
  {
    do
    {
      GETCODEPC (code);
      ftable[code] (); /* call interpreterfunction */
      if (ex)
        if (execute_exit ())
          return (0); /* end of program */
    }
    while ((*(word*) TCR0 & 0x100) == 0); /* check watchdog timer */

    *(word*) TCR0 = BREAKTESTCOUNT; /* reset watchdog */

    if (check_touch ())
    {
      if ((*tchyp > ESC_Y1)
       && (*tchxp > ESC_X1)
       && (*tchyp < ESC_Y2))  /* ESC pressed */
        if (verify_abort ())
          if (execute_exit ())
            return (0); /* break */
      if ((*tchyp > 159)
       && (*tchxp < 17)
       && auto_btn)
      {
        /*if (*tchyp <= 178)
        {
          do
            check_touch ();
          while (touched);
          check_switchoff ();
        }*/
        rtch = newtouched = FALSE;
      }
    }
  }
}
#endif
