#include "modeldef.h"
#include <string.h>
#include "owbasic.h"
#include "shared.h"
#include "file.h"
#include "inter.h"

/* interpreter interface for filefunctions */

/* ------------------------------------------------*/
static void NEAR _push_pname (void)
{
  spush1 ();
  strcpy ((char*) STOS, (char*) progname);
}


void x_loadshared (void)
{
  /* load record from shared file */
  int rc;
  FBBNUM = 3072; /* ! Not the real number of bytes! */
  rc = loadshared (SST1, STOS, FBB, 3072);
  if (!rc)
    rterror (FN_LOADSHARED, 39);
  spop2 ();
}

void x_loadshared1 (void)
{
  /* load record from shared file */
  int rc;
  FBBNUM = 3072; /* ! Not the real number of bytes! */
  rc = loadshared (STOS, progname, FBB, 3072);
  if (!rc)
    rterror (FN_LOADSHARED, 39);
  spop1 ();
}

void x_saveshared (void)
{
  /* save record to shared file */
  int rc;
  rc = saveshared (SST1, STOS, FBB, FBBNUM);
  if (!rc)
    rterror (FN_SAVESHARED, 39);
  spop2 ();
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_saveshared1 (void)
{
  /* save record to shared file */
  int rc;
  rc = saveshared (STOS, progname, FBB, FBBNUM);
  if (!rc)
    rterror (FN_SAVESHARED, 39);
  spop1 ();
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_removeshared (void)
{
  /* remove record from shared file */
  int rc;
  rc=removeshared(SST1,STOS);
  if (!rc) rterror(FN_REMOVESHARED,39);
  spop2();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_removeshared1()
{
  /* remove record from shared file */
  int rc;
  rc=removeshared(STOS,progname);
  if (!rc) rterror(FN_REMOVESHARED,39);
  spop1();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_findshared ()
{
  int rc;
  word fp;
  int fpaddr;
  int nameaddr;

  fpaddr = ipop ();
  nameaddr = ipop ();
  fp = xdata[fpaddr];
  spush1 ();
  rc = findshared (SST2, SST1, STOS, MAXSTRLEN, &fp);
  spop (nameaddr);
  spop2 ();
  if (rc)
    xdata[fpaddr] = fp;
  else
    xdata[fpaddr] = -1;
}

void x_findshared3 (void)
{
  _push_pname ();
  x_findshared ();
}

/*
void x_findshared3()
{
  int rc;
  word fp;
  int fpaddr;
  int nameaddr;
  fpaddr=ipop();
  nameaddr=ipop();
  fp=xdata[fpaddr];
  spush1();
  rc=findshared(SST1,progname,STOS,MAXSTRLEN,&fp);
  spop(nameaddr);
  spop1();
  if (rc) xdata[fpaddr]=fp;
  else  xdata[fpaddr]=-1;
}
*/

typedef bool (*lssfunc_t) (const uchar*, const uchar*, uchar FAR*, int);

void _lssharedint (lssfunc_t func, const uchar FAR* ifname)
{
  int size = ipop ();
  int arrayindex = ipop ();
  int arraysize;
  int rc;
  arraysize = xdata[arrayindex - 1];
  if (size < 0) size = arraysize;
  if (size > arraysize)
    rterror (ifname, 38);
  rc = func (SST1, STOS, (uchar FAR*) &xdata[arrayindex], size * sizeof (int));
  if (!rc)
    rterror (ifname, 39);
  spop2 ();
}

void x_savesharedint (void)
{
  _lssharedint (saveshared, FN_SAVESHAREDINT);
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_loadsharedint (void)
{
  _lssharedint (loadshared, FN_LOADSHAREDINT);
}

/*void x_savesharedint()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_SAVESHAREDINT,38);
  rc=saveshared(SST1,STOS,(uchar FAR*)&xdata[arrayindex],size*sizeof(int));
  if (!rc) rterror(FN_SAVESHAREDINT,39);
  spop2();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_loadsharedint()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_LOADSHAREDINT,38);
  rc=loadshared(SST1,STOS,(uchar FAR*)&xdata[arrayindex],size*sizeof(int));
  if (!rc) rterror(FN_LOADSHAREDINT,39);
  spop2();
}*/


void _lssharedfloat (lssfunc_t func, const uchar FAR* ifname)
{
  int size = ipop ();
  int arrayindex = ipop ();
  int arraysize;
  int rc;
  arraysize = xdata[arrayindex - 1];
  if (size < 0)
    size = arraysize;
  if (size > arraysize)
    rterror (ifname, 38);
  rc = func (SST1, STOS, (uchar FAR*) &xdata[arrayindex], size * sizeof (FLOATT));
  if (!rc)
    rterror (ifname, 39);
  spop2 ();
}

void x_savesharedfloat (void)
{
  _lssharedfloat (saveshared, FN_SAVESHAREDFLOAT);
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_loadsharedfloat (void)
{
  _lssharedfloat (loadshared, FN_LOADSHAREDFLOAT);
}


/*
void x_savesharedfloat()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_SAVESHAREDFLOAT,38);
  rc=saveshared(SST1,STOS,(uchar FAR*)&xdata[arrayindex],size*sizeof(FLOATT));
  if (!rc) rterror(FN_SAVESHAREDFLOAT,39);
  spop2();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_loadsharedfloat()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_SAVESHAREDFLOAT,38);
  rc=loadshared(SST1,STOS,(uchar FAR*)&xdata[arrayindex],size*sizeof(FLOATT));
  if (!rc) rterror(FN_LOADSHAREDFLOAT,39);
  spop2();
}*/

void x_loadsharedint3 (void)
{
  _push_pname ();
  x_loadsharedint ();
}
void x_savesharedint3 (void)
{
  _push_pname ();
  x_savesharedint ();
}

void x_loadsharedfloat3 (void)
{
  _push_pname ();
  x_loadsharedfloat ();
}
void x_savesharedfloat3 (void)
{
  _push_pname ();
  x_savesharedfloat ();
}

/*
void x_savesharedint3()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_SAVESHAREDINT,38);
  rc=saveshared(STOS,progname,(uchar FAR*)&xdata[arrayindex],size*sizeof(int));
  if (!rc) rterror(FN_SAVESHAREDINT,39);
  spop1();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_loadsharedint3()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_LOADSHAREDINT,38);
  rc=loadshared(STOS,progname,(uchar FAR*)&xdata[arrayindex],size*sizeof(int));
  if (!rc) rterror(FN_LOADSHAREDINT,39);
  spop1();
}

void x_savesharedfloat3()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_SAVESHAREDINT,38);
  rc=saveshared(STOS,progname,(uchar FAR*)&xdata[arrayindex],size*sizeof(FLOATT));
  if (!rc) rterror(FN_SAVESHAREDFLOAT,39);
  spop1();
#ifdef LSI_C
  bk_counter=0;
#endif
}

void x_loadsharedfloat3()
{
  int size=ipop();
  int arrayindex=ipop();
  int arraysize;
  int rc;
  arraysize=xdata[arrayindex-1];
  if (size<0) size=arraysize;
  if (size>arraysize) rterror(FN_LOADSHAREDINT,38);
  rc=loadshared(STOS,progname,(uchar FAR*)&xdata[arrayindex],size*sizeof(FLOATT));
  if (!rc) rterror(FN_LOADSHAREDFLOAT,39);
  spop1();
}
*/

void x_savesharedint2() { ipush(-1); x_savesharedint3();}
void x_savesharedfloat2() { ipush(-1); x_savesharedfloat3();}
void x_loadsharedint2() { ipush(-1); x_loadsharedint3();}
void x_loadsharedfloat2() { ipush(-1); x_loadsharedfloat3();}
