#include <owbasic.h>
#include "inter.h"
#include <graphic.h>

#ifdef LSI_C
/* int vramsegment;*/
#endif

#ifdef __HITACHI__
const int drawiconmodes[] = {IB_GPOVER, IB_GPOR, IB_GPAND, IB_GPOVER, IB_GPOVER}; /* IB_GPREV and IB_GPMESH are not available on PV-S1600 */
#else
const int drawiconmodes[] = {IB_GPOVER, IB_GPOR, IB_GPAND, IB_GPREV, IB_GPMESH};
#endif



static int NEAR inrange (int x, int x1, int x2)
{
  register int h;
  if (x1 > x2)
  {
    h = x1;
    x1 = x2;
    x2 = h;
  }
  return ((x >= x1) && (x <= x2));
  /*if (x < x1)
    return (FALSE);
  return (x <= x2);*/
}


void x_messagebox (void)
{
  int mode = ipop ();
  switch (mode)
  {
  case 0: LibPutMsgDlg (STOS);  break;
  case 1: LibPutMsgDlg4 (STOS); break;
  case 2: LibPutMsgDlg2 (STOS); break;
  case 4: LibPutMsgDlg3 (STOS);
  case 3: LibPutMsgDlg3 (STOS); break;
  }
  spop1 ();
  TimerRuns = 0;
}

void x_messagebox1 (void)
{
  LibPutMsgDlg (STOS);
  spop1 ();
  TimerRuns = 0;
}

void x_msgbox (void) /* MSGBOX text$ [,caption$] [,type%] [,waittime#] (MB,4.50) */
{
  msgbox (SST1, STOS, fpop (), ipop ());
  spop2 ();
}

void x_msgbox3 (void)
{
  ipush (MBX_OK);
  x_msgbox ();
}

void x_msgbox2 (void)
{
  msgbox (SST1, STOS, 0.0, MBX_OK);
  spop2 ();
}

void x_msgbox1 (void)
{
  msgbox1 (STOS);
  spop1 ();
}

void x_ask (void)
{
  ipush (msgbox (SST1, STOS, 0.0, MBX_YESNO));
  spop2 ();
}

void x_ask1 (void)
{
  spush1 ();
  STOS[0] = 0;
  x_ask ();
}

/*------------------------------------*/
void x_show0 (void) { LibPutDisp (); }
void x_show (void)
{
  int x1, y1, x2, y2;
  y2 = ipop (); x2 = ipop (); y1 = ipop (); x1 = ipop ();
  LibPutDispBox (x1, y1, x2 - x1 + 1, y2 - y1 + 1);
}

/*-------------- runtime functions ----------------------*/
#ifndef LSI_C
void x_pset (void)
{
  int x, y, z;
  z = ipop(); y = ipop(); x = ipop();
  if (checkxy (x, y))
    psetfunc[z & DRAWMODEMASK] (x, y);
  else rterror (FN_PSET, 65);
}
#endif

void x_pset2 (void)
{
  ipush (1);
  x_pset ();
}

void x_line (void)
{
  int x1, y1, x2, y2, z;
  int rc;

  z = ipop ();
  y2 = ipop (); x2 = ipop (); y1 = ipop (); x1 = ipop ();
  if (z == 0)
    z = 2;
  rc = Line (x1, y1, x2, y2, z);

  if (rc)
    rterror (FN_LINE, rc);
}

void x_line4 (void)
{
  ipush (1);
  x_line ();
}

void x_polygon (void) /* POLYGON COORDS%[] [, style%=1] (MB,4.50) */
{
  int style, fillcol, col;
  int addr;
  int FAR* last;
  int FAR* i;

  /*
  style%:
    100 closed polygon
    000 open polygon
    1   black line
    2   white line
    4   dotted line
    5   inverted line
  */

  col = ipop ();
  fillcol = col / 10;
  style = col / 100;
  col %= 10;

  addr = ipop ();

  last = &xdata[addr + xdata[addr] * 2 - 2];
  i = &xdata[addr + 1];

  for (; i <= last; i += 2)
    Line (*i, i[1], i[2], i[3], col);
  if (style)
    Line (*i, i[1], xdata[addr + 1], xdata[addr + 2], col);
}

void x_polygon1 (void)
{
  ipush (1);
  x_polygon ();
}

void x_ellipse (void)
{
  int xm, ym, rx, ry, z;
  int rc;
  z = ipop ();

  ry = ipop (); rx = ipop (); ym = ipop (); xm = ipop ();
  if (z == 0)
    z = 2;
  rc = Ellipse (xm, ym, rx, ry, z);

  if (rc)
    rterror (FN_ELLIPSE, rc);
}

void x_ellipse4 (void)
{
  ipush (1);
  x_ellipse ();
}

void x_circle (void)
{
  int xm, ym, r, z;
  int rc;
  z = ipop ();

  r = ipop (); ym = ipop (); xm = ipop ();
  if (z == 0)
    z = 2;
  rc = Ellipse (xm, ym, r, r, z);

  if (rc)
    rterror (FN_CIRCLE, rc);
}

void x_circle3 (void)
{
  ipush (1);
  x_circle ();
}

void x_box (void)
{
  int rc;
  rc = Box (ST4, ST3, ST2, ST1, TOS);
  if (rc)
    rterror (FN_BOX, rc);
  ipopn (5);
}

void x_box4 (void)
{
  ipush (1);
  x_box ();
}

void x_igraph(void)
{
  if (checkxy (ST1, TOS) && inrange (ST2, 0, 340))
    LibPutFarData (ST1,TOS,ST2);
  else
    rterror (FN_IGRAPH,65);
  ipopn (3);
}

void x_scroll (void) /* SCROLL x1%, y1%, x2%, y2%, diff% (MB,4.20) */
{
  int x1, y1, x2, y2;
  int diff;

  diff = ipop ();
  y2  = ipop (); x2 = ipop ();
  y1  = ipop (); x1 = ipop ();

  if (!checkxy2 (x1, y1, x2, y2) || (abs (diff) > (y2 - y1)))
  {
    rterror (FN_SCROLL, 65);
    return;
  }
  x2 -= x1;
  y2 -= y1;
  ++x2; ++y2;
  if (diff < 0)
    LibGrpUp (x1, y1, x2, y2, -diff);
  if (diff > 0)
    LibGrpDwn (x1, y1, x2, y2, diff);
}

void x_stringsize (void)
{
  TOS = stringsize (STOS, TOS);
  spop1();
}

void x_stringheight (void)
{
  TOS = stringheight (STOS, TOS);
  spop1 ();
}

void x_drawstring (void) /* DRAWSTRING str$, x%, y% [,mode%=0] [,maxr%=159] (MB,4.24) */
{
  int x, y, xl, font;
  int rc;
  xl = ipop (); font = ipop (); y = ipop (); x = ipop ();
  rc = drawstring (STOS, x, y, font, xl);
  if (rc)
    rterror (FN_DRAWSTRING, rc);
  spop1 ();
}

void x_drawstring4 (void)
{
  ipush (159);
  x_drawstring ();
}

void x_drawstring3 (void)
{
  ipush (IB_PFONT1);
  ipush (159);
  x_drawstring ();
}

#ifdef LSI_C
static void NEAR _drawicon_b (byte FAR* addr)
{
  int x, y;
  int mode;
  int FAR* info = (int FAR*) (addr - 2);
  mode = ipop (); y = ipop (); x = ipop (); ipop1 ();

  /*LibPutMsgDlg ("%d,%d,%d", info[0], info[1], info[2]);*/
  if (!checkicon (info[1], info[2], info[0]))
  {
    rterror (FN_DRAWICON, 59);
    return;
  }
  if (!checkxy2 (x, y, x + info[1] - 1, y + info[2] - 1))
  {
    rterror (FN_DRAWICON, 65);
    return;
  }

  if (mode == 0)
    LibPutGraph (x, y, addr);
  else
  {
    if ((mode < 0) || (mode > 4))
      rterror (FN_DRAWICON, 38);
    else
      LibPutGraphO (x, y, addr, drawiconmodes[mode]);
  }
  return;
}
#endif

void x_drawicon (void) /* DRAWICON BM%[], x%, y% [, mode%=0] [, yoffs1%, yoffs2%] (MB,4.50) */
{
#ifdef LSI_C
  int yoffs1, yoffs2;
  int rec[6];
  byte FAR* dest;
  int FAR* arraddr;
  int sy;

  /*
   * ST3 - addr
   * ST2 - xs
   * ST1 - ys
   * TOS - mode
   */

  yoffs2 = ipop (); yoffs1 = ipop ();

  arraddr = xdata - 1 + ST3;
  dest = ((byte FAR*) arraddr) + ((arraddr[1] + 7) / 8) * yoffs1;

  if ((yoffs1 > yoffs2) || (yoffs1 < 0) || (yoffs2 > arraddr[2]))
    rterror (FN_DRAWICON, 65);

  far_memcpy ((byte*) rec, (byte FAR*) arraddr, sizeof (int) * 3); /* backup array data */
  far_memcpy ((byte*) rec + sizeof (int) * 3, dest, sizeof (int) * 3); /* backup data */

  sy = rec[2];
  rec[2] = yoffs2 - yoffs1 + 1;
  far_memcpy (dest, (byte*) rec, sizeof (int) * 3);
  rec[2] = sy;
  _drawicon_b (dest + sizeof (int));

  far_memcpy ((byte FAR*) arraddr, (byte*) rec, sizeof (int) * 3); /* restore array data */
  far_memcpy (dest, (byte*) rec + sizeof (int) * 3, sizeof (int) * 3); /* restore data */
#endif

#ifdef __HITACHI__
  int yoffs1, yoffs2;
  word rec[2];
  byte* dest;
  int x, y;
  int rc, mode, addr;


  yoffs2 = ipop (); yoffs1 = ipop ();
  mode = ipop (); y = ipop (); x = ipop (); addr = ipop ();


  toiconbuffer ((byte*) (xdata + addr));
  if ((yoffs1 >= yoffs2) || (yoffs1 < 0) || (yoffs2 > ((short*) iconbuffer)[1]))
    rterror (FN_DRAWICON, 65);

  dest = iconbuffer + ((((short*) iconbuffer)[0] + 7) / 8) * yoffs1;

  far_memcpy ((byte*) rec, iconbuffer, sizeof (word) * 2); /* backup array data */

  rec[1] = yoffs2 - yoffs1 + 1;
  far_memcpy (dest, (byte*) rec, sizeof (word) * 2);
  if (!checkicon (rec[0], rec[1], xdata[addr - 1]))
  {
    rterror (FN_DRAWICON, 59);
    return;
  }
  if (!checkxy2 (x, y, x + rec[0] - 1, y + rec[1] - 1))
  {
    rterror (FN_DRAWICON, 65);
    return;
  }

  if (mode == 0)
    LibPutGraph (x, y, dest);
  else
  {
    if ((mode < 0) || (mode > 4))
      rterror (FN_DRAWICON, 38);
    else
      LibPutGraphO (x, y, dest, drawiconmodes[mode]);
  }
#endif
}

void x_drawicon4 (void)
{
#ifdef LSI_C
  _drawicon_b ((byte FAR*) (xdata + ST3));
#endif
#ifdef __HITACHI__
  int x, y;
  int mode, addr;
  int info[3];

  mode = ipop (); y = ipop (); x = ipop (); addr = ipop ();

  memcpy (&info, (byte*) (xdata + addr) - sizeof (int), sizeof (int) * 3); /* size, xs, ys */

  /*LibPutMsgDlg ("%d,%d,%d", info[0], info[1], info[2]);*/
  if (!checkicon (info[1], info[2], info[0]))
  {
    rterror (FN_DRAWICON, 59);
    return;
  }
  if (!checkxy2 (x, y, x + info[1] - 1, y + info[2] - 1))
  {
    rterror (FN_DRAWICON, 65);
    return;
  }

  toiconbuffer ((byte*) (xdata + addr));
  if (mode == 0)
    LibPutGraph (x, y, iconbuffer);
  else
  {
    if ((mode < 0) || (mode > 4))
      rterror (FN_DRAWICON, 38);
    else
      LibPutGraphO (x, y, iconbuffer, drawiconmodes[mode]);
  }
  return;
#endif
}

void x_drawicon3 (void)
{
  ipush (0);
  x_drawicon4 ();
}


void x_geticon (void)
{
  int x1, y1,  x2, y2;
  int aaddr;
  int rc;
  y2 = ipop (); x2 = ipop ();
  y1 = ipop (); x1 = ipop ();
  aaddr = ipop ();
  rc = geticon (aaddr, x1, y1, x2, y2);

  if (rc)
    rterror (FN_GETICON, rc);
  /*  bk_counter=0;*/
}

void x_seticonpix (void)
{
  int aa, ox, oy, val;
  int bm;
  int FAR* p;
  int size;

  val = ipop (); oy = ipop (); ox = ipop (); aa = ipop (); /* read parameter */
  size = xdata[aa - 1];
  if (!checkicon (xdata[aa], xdata[aa + 1], size))
    rterror (FN_SETICONPIX, 59);
  if (!iconaddr (&(xdata[aa]), ox, oy, &bm, &p))
    rterror (FN_SETICONPIX, 30);
  if (val)
    *p |= bm;
  else
    *p &= ~bm;
}

void x_iconpix(void)
{
  int aa, ox, oy;
  int bm;
  int FAR *p;
  int size;

  oy = ipop (); ox = ipop (); aa = ipop (); /* read parameter */
  size = xdata[aa - 1];
  if (!checkicon (xdata[aa], xdata[aa + 1], size))
    rterror (FN_ICONPIX, 59);
  if (!iconaddr (&(xdata[aa]), ox, oy, &bm, &p))
    rterror (FN_ICONPIX, 30);
  ipush ((*p & bm) ? 1 : 0);
}

void x_resizeicon(void)
{
  int darraysize;
  int sarraysize;
  int h;
  int xd, yd;
  int x1, y1, x2, y2;
  int fx, fy;
  int ssx, ssy;
  int sbm, dbm;
  int FAR *sptr;
  int FAR *dptr;
  int x, y;
  int bm;
  int FAR*p;
  int val;

  y2=ipop(); x2=ipop(); /* source window lr */
  y1=ipop(); x1=ipop(); /* source window ul */
  yd=ipop(); xd=ipop(); /* destination size */
  dbm=ipop(); /* destination bitmap */
  sbm=ipop(); /* source bitmap */
  sptr=&(xdata[sbm]);
  dptr=&(xdata[dbm]);
  darraysize=xdata[dbm-1];
  sarraysize=xdata[sbm-1];
  if (darraysize<2) rterror(FN_RESIZEICON,59);/*can't be enough for an icon*/
  xdata[dbm]=xd; xdata[dbm+1]=yd;
  if (! checkicon(xdata[dbm], xdata[dbm + 1],darraysize)) rterror(FN_RESIZEICON,59);/*check size*/

  if (! checkicon(xdata[sbm], xdata[sbm + 1],sarraysize)) rterror(FN_RESIZEICON,59);/*check size*/
  ssx=xdata[sbm]; ssy=xdata[sbm+1]; /* source size */
  if ((xd<=0)||(yd<=0)) rterror(FN_RESIZEICON,38);

  if (x1>x2) { h=x1;x1=x2;x2=h; }
  if (y1>y2) { h=y1;y1=y2;y2=h; }
  if ((x1<0)||(y1<0)||(x2>=ssx)||(y2>=ssy)) rterror(FN_RESIZEICON,30);

  fx=(x2-x1+1)/xd; fy=(y2-y1+1)/yd;
  if ((fx>0)||(fy>0))
    {
      /* destination is smaller */
      for (y=0;y<yd;y++)
        for (x=0;x<xd;x++)
          {
            iconaddr0(sptr,x*fx+x1,y*fy+y1,&bm,&p);
            val=*p & bm ? 1 : 0;
            iconaddr0(dptr,x,y,&bm,&p);
            if (val) *p |= bm;
            else *p &= ~bm;
          }
    }
  else
    {
      fx=xd/(x2-x1+1); fy=yd/(y2-y1+1);
      if ((fx==0)||(fy==0)) rterror(FN_RESIZEICON,38);
      else
        {
          /* destination is bigger */
          for (y=0;y<yd;y++)
            for (x=0;x<xd;x++)
              {
                iconaddr0(sptr,x/fx+x1,y/fy+y1,&bm,&p);
                val=*p & bm ? 1 : 0;
                iconaddr0(dptr,x,y,&bm,&p);
                if (val) *p |= bm;
                else *p &= ~bm;
              }
        }
    }
}

void x_resizeicon4 (void)
{
  register int sbm = ST3;
  /*int xd, yd;
  int dbm;
  int ssx, ssy;*/

  /*yd = TOS; xd = ST1;*/ /* destination size */
  /*dbm = ST2;*/ /* destination bitmap */
  /*sbm = ST3;*/ /* source bitmap */
  /*ssx = xdata[sbm]; ssy = xdata[sbm + 1];*/ /* source size */
  /*if ((xd <= 0) || (yd <= 0))
    rterror (FN_RESIZEICON, 38);*/ /* done in x_resizeicon () */
  ipush (0); ipush (0);
  ipush (xdata[sbm] - 1); ipush (xdata[sbm + 1] - 1);
  x_resizeicon ();
}

void x_inrange (void)
{
  int x, x1, x2;
  x2 = ipop (); x1 = ipop (); x = ipop ();
  ipush (inrange (x, x1, x2));
}

void x_inside (void)
{
  int x, x1, x2;
  int y, y1, y2;
  y2 = ipop ();  x2 = ipop ();
  y1 = ipop ();  x1 = ipop ();
  y =  ipop ();  x =  ipop ();
  ipush (inrange (x, x1, x2) && inrange (y, y1, y2));
}

void x_insideg (void)
{
  int y;
  y = ipop ();
  TOS = checkxy (TOS, y);
}

#ifdef LSI_C
#if FALSE
bool CheckSeg (int addr)
{
  unsigned char FAR *vramptr;
  vramptr=MK_FP(addr,0x0000);
  LibDotOn(0,0); LibDotOff(1,0);
  LibDotOn(2,0); LibDotOff(3,0);
  LibDotOn(4,0); LibDotOff(5,0);
  LibDotOn(6,0); LibDotOff(7,0);
  if (*vramptr!=0xAA) return FALSE;
  LibDotOff(0,0); LibDotOff(2,0);
  if (*vramptr!=0x0A) return FALSE;
  return TRUE;
}

int DetectVideoRam (void)
{
  if (CheckSeg(0x100))
    return 0x100;
  return 0;
}
#endif
#endif

#ifdef __HITACHI__
void x_pixel ()
{
  const byte mask[] = {128,64,32,16,8,4,2,1};
  int y = ipop();
  int x = TOS;
  int xh = x & 0xF8;
  int xl = x & 0x07;
  if (checkxy (x,y))
  {
    LibGetGraph (xh, y, 8, 1, iconbuffer);
    TOS = iconbuffer[0] & mask[xl] ? 1 : 0;
  }
  else
    TOS = 0;
}
#endif


#ifndef SMALL_INPUTI_AS_INPUTF
#define TOUCHED_SCREEN(x1,y1,x2,y2) ((*tchxp >= x1) && (*tchxp <= x2)  \
                                  && (*tchyp >= y1) && (*tchyp <= y2))
const static signed char _iinput_nr[] = {'7', '8', '9', '4', '5', '6', '1', '2', '3', '0', -1, -2};
void x_inputi (void) /* INPUTI VAL% (MB,4.24) */
{
  int save[330];
  char sval[30];
  char buf[30];
  bool exit = FALSE;
  bool changed = FALSE;
  char i = 0;
  int vali = ipop ();

  save[0] = 58; save[1] = 82;
  LibGetGraph (0, 78, 58, 82, (byte FAR*) (save + 2)); /* save screen area */
  LibPutFarData (0, 89, 181); /* numeric keyboard */

  LibPutProStr (IB_PFONT1, 24, 132, (byte*) "+-", 40);
  LibPutProStr (IB_PFONT1, 46, 131, (byte*) "x", 60);

  sprintf (sval, (char*) "%d", xdata[vali]);

  do
  {
    Box (0, 78, 57, 88, 1012);
    LibPutProStr (IB_PFONT1, 55 - LibGetProStrSize (IB_PFONT1, (uchar*) sval), 80, (byte*) sval, 55);
    if (!changed)
    {
      sval[0] = '0';
      sval[1] = '\0';
    }
    LibPutDisp ();

    while (!check_touch ());
    newtouched = FALSE;

    if (TOUCHED_SCREEN (0, 143, 28, 159))
    {
      changed = TRUE;
      sval[0] = '0';
      sval[1] = '\0';
    }
    else if (TOUCHED_SCREEN (29, 143, 57, 159))
    {
      if (changed)
        xdata[vali] = atoi (sval);
      break;
    }
    else if (TOUCHED_SCREEN (0, 89, 56, 140))
    {
      changed = TRUE;
      i = _iinput_nr[(*tchyp - 89) / 13 * 3 + (*tchxp / 19)];
      if (i == -2)
        exit = TRUE;
      else if (i == -1)
        sprintf (sval, "%d", -atoi (sval));
      else
      {
        sprintf (buf, "%s%c", sval, i);
        sprintf (sval, "%d", atoi (buf));
      }
    }

  } while (!exit);

  LibPutGraph (0, 78, (byte FAR*) save); /* restore graphics */
}
#else
void x_inputi (void) /* INPUTI VAL% (MB,4.24) */
{
  int addr = ipop ();
  FLOATT f = (FLOATT) xdata[addr];
  floatinput (&f);
  xdata[addr] = (int) f;
}
#endif



void x_kbdraw (void) /* KBDRAW (MB,5.03) */
{
  LibKeyInit ();
  LibDispKey ();
}

void x_kbwait (void) /* KBWAIT!(KEY&) (MB,5.03) */
{
  TCHSTS tsts;
  byte key;

  xdata[TOS] = key = LibGetKeyM (&tsts);
  TOS = key != KEY_NONE;
  newtouched = check_touch ();
}


void x_inputtext (void) /* INPUTTEXT STR$, x1%, y1%, x2%, lnr%, maxchar% (MB,5.00) */
{
  uchar str[MAXSTRLEN];
  int addr;
  int x1, y1, x2, lnr, max;

  max = ipop ();
  lnr = ipop ();
  x2 = ipop (); y1 = ipop (); x1 = ipop ();

  addr = ipop ();
  getvar (addr, str);

  if (inputstr ((char*) str, x1, y1, x2, lnr, IB_PFONT1, max) != TRM_ESC)
    putvar (addr, str);
  newtouched = FALSE;
}

void x_inputs (void) /* INPUTS STR$ [, prompt$] (MB,4.40) */
{
  uchar str[MAXSTRLEN];
  int addr;

  SCREEN_SAVE ();

  addr = ipop ();
  getvar (addr, str);

  strinpbkg (STOS);
  spop1 ();

  if (inputstr ((char*) str, 2, 12, 157, 8, IB_PFONT1, MAXSTRLEN - 1) != TRM_ESC)
    putvar (addr, str);
  newtouched = FALSE;

  SCREEN_RESTORE ();
}

void x_inputs1 (void)
{
  spush1 ();
  STOS[0] = '\0';
  x_inputs ();
}

