#include <string.h>
#include "owbasic.h"
#include "inter.h"
#include "graphic.h"

#ifndef SMALL_INTERFM
 #include "form.h"
#endif


static uchar* NEAR eos (uchar* s)
{
  while (*s)
    ++s;
  return (s);
}

static int NEAR wrong_len (int len)
{
  return (len < 0) || (len > MAXSTRLEN);
}

static int NEAR wrong_index (uchar* s, int index)
{
  return (index < 0) || (index > eos (STOS) - s - 1);
}

void x_print_string () { OutputTrm (STOS); spop1 ();}
void x_print_char ()   { OutTrm (ipop ()); }

/* ------------------------------------------ */

static int NEAR st_strcmp_ss (void)
{
  int res = strcmp ((char*) SST1, (char*) STOS);
  spop2 ();
  return res;
}

#define compare_ss(rel) ipush(st_strcmp_ss () rel 0)

void x_less_ss() { compare_ss (<); }
void x_equal_ss()  { compare_ss (==); }
void x_greater_ss()  { compare_ss (>); }
void x_not_less_ss() { compare_ss (>=); }
void x_not_equal_ss() { compare_ss (!=); }
void x_not_greater_ss() { compare_ss (<=); }


static int NEAR st_strcmp_cs (void)
{
  int res;
  char c[2];
  c[0] = ipop (); c[1] = '\0';
  res = strcmp (c, (char*) STOS);
  spop1 ();
  return res;
}

#define compare_cs(rel) ipush (st_strcmp_cs () rel 0)

void x_less_cs() { compare_cs (<); }
void x_equal_cs() { compare_cs (==); }
void x_greater_cs()  { compare_cs (>); }
void x_not_less_cs() { compare_cs (>=); }
void x_not_equal_cs() { compare_cs (!=); }
void x_not_greater_cs() { compare_cs (<=); }


#define compare_sc(rel) ipush (0 rel st_strcmp_cs ())

void x_less_sc() { compare_sc (<); }
void x_equal_sc()  { compare_sc (==); }
void x_greater_sc()  { compare_sc (>); }
void x_not_less_sc() { compare_sc (>=); }
void x_not_equal_sc() { compare_sc (!=); }
void x_not_greater_sc() { compare_sc (<=); }

/*#define compare_cc(rel) int i=ipop_fast(); TOS=TOS rel i;

void x_less_cc() { compare_cc(<); }
void x_equal_cc() { compare_cc(==); }
void x_greater_cc() { compare_cc(>); }
void x_not_less_cc() { compare_cc(>=); }
void x_not_equal_cc() { compare_cc(!=); }
void x_not_greater_cc() { compare_cc(<=); }*/

/*void x_less_cc() { x_less_ii(); }
void x_equal_cc() { x_equal_ii(); }
void x_greater_cc() { x_greater_ii(); }
void x_not_less_cc() { x_not_less_ii(); }
void x_not_equal_cc() { x_not_equal_ii(); }
void x_not_greater_cc() { x_not_greater_ii(); }*/

/*------------------------------------*/

void x_add_ss (void)
{
  uchar *sptr = STOS;
  uchar *dptr = eos (SST1);
  while ((*sptr) && (dptr < SST1 + MAXSTRLEN))
    *(dptr++) = *(sptr++);
  if (dptr - SST1 >= MAXSTRLEN)
    rterror (FN_STRING, 32);
  *dptr = 0;
  spop1 ();
}

void x_add_sc (void)
{
  uchar *dptr = eos (STOS); /* find end of string */
  if (dptr - STOS >= MAXSTRLEN - 1)
    rterror (FN_STRING, 32);  /* string too long? */
  *(dptr++) = ipop (); /* replace null with new character */
  *dptr = 0; /* add null */
}

void x_add_cs (void)
{
  uchar *dptr = eos (STOS); /* find end of string */
  if (dptr - STOS >= MAXSTRLEN-1)
    rterror (FN_STRING, 32); /* string to long? */
  *(dptr + 1) = 0; /* set null one position behind string */
  while (dptr > STOS)
  {
    *dptr = *(dptr - 1); /* move chars one step */
    --dptr;
  }
  *dptr = ipop (); /* set new value at first position */
}

void x_add_cc (void)
{
  spush1 ();
  STOS[2] = '\0';
  STOS[1] = ipop ();
  STOS[0] = ipop ();
}

/* ------------------------------------------------- */

#if FALSE
void x_assign_s (void) /* now defined in inter.c */
{
  /* assignment of STOS to string variable */
  int addr = ipop ();
  spop (addr);
}
#endif

void x_assign_sc (void)
{ /* assignment of char on stack to char of string variable */
  int cv = ipop (); /* char value */
  register int index = ipop (); /* index of char in string */
  register int addr = xdata[ipop ()]; /* addr of string variable */

  if ((addr == 0) || (index < 0) || (index >= xdata[addr + 2]))
    rterror (FN_CHAR, 30);

  ((uchar FAR*) (xdata + addr + 3))[index] = cv;

#if FALSE
  spush (addr); /* get string variable */
  if (wrong_index (STOS, index))
    rterror (FN_STRING, 30);
  else STOS[index] = cv; /* set character */
  spop (addr);  /* store string variable */
#endif
}

/* ------------------------------------------------------ */

/*
  void x_pushs()
  {
  int addr=ipop();
  spush(addr);
  }

void x_pops()
{
  int addr=ipop();
  spop(addr);
}

void x_pushis()
{
  int addr;
  GETIPC(addr);
  spush(addr);
}
*/

void x_popis (void)
{
  int addr;
  GETIPC (addr);
  spop (addr);
}

/*#ifndef SMALL_NO_AAS
void x_array_addr_s (void)
{
  ARRAY (int);
}

void x_array2_addr_s (void)
{
  ARRAY2 (int);
}
#endif*/

void x_getchar (void)
{
  register int index = ipop ();
  TOS = xdata[TOS];
  /*LibPutMsgDlg ("%d,%d,%d", index, TOS, xdata[TOS]);*/
  if ((index < 0) || (index > xdata[TOS + 2]))
    rterror (FN_CHAR, 30);
  if (TOS != 0)
    TOS = ((uchar FAR*) (xdata + TOS + 3))[index];

  /*if (wrong_index (STOS, TOS))
    rterror (FN_CHAR, 30);
  else
    TOS = STOS[TOS];
  spop1 ();*/
}

void x_imm_s (void)
{
  int i;
  uchar FAR *sptr;
  uchar *dptr;
  GETIPC (i);
  sptr = (uchar FAR*) &(xdata[i]);
  spush1 ();
  dptr = STOS;
  while (*sptr)
    *(dptr++) = *(sptr++);
  *dptr = *(sptr++);
}


void x_sets (void) /* Syntax: SETS ARR$[], from%, to%, val$ (MB,4.10) */
{
  int from;
  int to;
  int addr;

  to   = ipop ();
  from = ipop ();
  addr = ipop ();

  if (to < from)
    return;

  if (to >= xdata[addr - 1])
    rterror (FN_SETS, 30);
  from += addr;
  to += addr;

  for (; from <= to; ++from)
  {
    spush1 ();
    strcpy ((char*) (STOS), (char*) (SST1));
    spop (from);
  }

  spop1 ();
}

void x_sets3 (void)
{
  spush1();
  STOS[0] = 0;
  x_sets ();
}

void x_clears (void)
{
  ipush (0);
  ipush (xdata[ST1 - 1] - 1);
  x_sets3 ();
}


void x_len_s (void)
{
  ipush (eos (STOS) - STOS);
  spop1 ();
}

void x_left_s (void)
{
  int len = ipop ();
  if (wrong_len (len))
    rterror(FN_LEFT,30);
  else
  {
    uchar *e = eos (STOS);
    uchar *last = STOS + len;
    while (e < last)
      *(e++) = ' ';
    *last = 0;
  }
}

void x_right_s (void)
{
  int slen;
  int i, i1;
  int nsize = ipop ();

  if (wrong_len (nsize))
    rterror (FN_RIGHT,30);
  slen = strlen ((char*) STOS);
  if (nsize == slen)
    return;
  if (nsize < slen)
  {
    i = slen - nsize;
    for (i1 = 0; i1 <= nsize; ++i1, ++i)
      STOS[i1] = STOS[i];
    return;
  }
  /* nsize > i=len */
  i1 = nsize; i = slen;
  for (i1 = nsize; i >= 0; --i1, --i)
    STOS[i1] = STOS[i];
  while (i1 >= 0)
    STOS[i1--] = ' ';
}

void x_mid_s (void)
{
  int i;
  int i1;
  int nsize = ipop ();
  int pos = ipop ();
  if ((pos >= 0) && (nsize >= 0))
  {
    i = strlen ((char*) STOS);
    if (pos >= i)
    {
      /* empty string */
      STOS[0] = 0;
      return;
    }
    i = 0; i1 = pos;
    while ((STOS[i1] != 0) && (i1 < MAXSTRLEN - 1) && (i < nsize))
      STOS[i++]=STOS[i1++];
    STOS[i] = 0;
  }
  else
    rterror (FN_MID, 38);
}

void x_mid_s2 (void)
{
  ipush (1);
  x_mid_s ();
}

void x_pos (void)
{
  TOS = pos (SST1, STOS, TOS);
  spop2 ();
}

void x_pos2 (void) /* POS%(needle$, haystack$ [, case_sensitive!=TRUE] (MB,5.00) */
{
  ipush (TRUE);
  x_pos ();
}

void x_countc (void)
{
  ipush (countc (ipop (), STOS));
  spop1 ();
}

void x_char_s (void)
{
  spush1 ();
  STOS[0] = ipop (); STOS[1] = 0;
}

void x_asc_s (void)
{
  ipush ((unsigned char) STOS[0]);
  spop1 ();
}

#if FALSE
void x_char_c (void)
{
  /* do nothing */
}

void x_asc_c (void)
{
  /* do nothing */
}
#endif

void x_xchgs (void) /* XCHGS S1$, S2$ (MB,5.00) */
{
  int addr2 = ipop ();
  int addr1 = ipop ();
  int tmp = xdata[addr1];

  xdata[addr1] = xdata[addr2]; xdata[xdata[addr2] + 1] = addr1;
  xdata[addr2] = tmp; xdata[tmp + 1] = addr2;
}

void x_split (void)
{
  int addr1, addr2;
  int apos = 0;
  int hpos;
  int plen;
  addr2 = ipop ();
  addr1 = ipop ();
  spush (addr1);

  plen = strlen ((char*) SST1);

  while ((STOS[apos])
      && (strncmp ((char*) SST1, (char*) STOS + apos, plen)))
    ++apos;

  if (STOS[apos] == 0)
  {
    /* not found */
    spop (addr2);
    spush1 ();
    STOS[0] = 0;
    spop (addr1);
    spop1 ();
    return;
  }

  STOS[apos] = 0;
  spop (addr2);
  spush (addr1);
  apos = apos + plen;
  hpos = 0;
  while (STOS[apos])
      STOS[hpos++] = STOS[apos++];
  STOS[hpos] = 0;
  spop (addr1);
  spop1 ();
}

void x_split2()
{
  int addr1;
  int apos,hpos;
  int plen;
  addr1=ipop();
  spush(addr1);

  plen=strlen((char*)SST1);

  apos=0;
  while
    (
     (STOS[apos]!=0) &&
     (strncmp((char*)SST1,(char*)STOS+apos,plen))
     ) apos++;

  if (STOS[apos]==0)
    {
      /* not found */
      spop2();
      spush1();
      STOS[0]=0;
      spop(addr1);
      return;
    }

  apos=apos+plen;
  hpos=0;
  while (STOS[apos]!=0)
    {
      STOS[hpos]=STOS[apos];
      hpos++; apos++;
    }
  STOS[hpos]=0;
  spop(addr1);
  spop1();
}

void x_splitn()
{
  /* split n characters from string */
  int addr1, addr2;
  int apos, hpos;
  int cnumber;
  addr2=ipop();
  cnumber=ipop();
  addr1=ipop();

  spush(addr1);

  apos=0;
  while ((STOS[apos]!=0) && (apos<cnumber)) apos++;

  if (STOS[apos]==0)
    {
      /* split all characters */
      spop(addr2);
      spush1();
      STOS[0]=0;
      spop(addr1);
      return;
    }

  STOS[apos]=0;
  spop(addr2);
  spush(addr1);
  hpos=0;
  while (STOS[apos]!=0)
    {
      STOS[hpos]=STOS[apos];
      hpos++; apos++;
    }
  STOS[hpos]=0;
  spop(addr1);
}

void x_splitn2()
{
  /* split n characters from string */
  int addr1;
  int apos, hpos;
  int cnumber;

  cnumber=ipop();
  addr1=ipop();

  spush(addr1);

  apos=0;
  while ((STOS[apos]!=0) && (apos<cnumber)) apos++;

  if (STOS[apos]==0)
    {
      /* store remaining empty string */
      STOS[0]=0;
      spop(addr1);
      return;
    }

  hpos=0;
  while (STOS[apos]!=0)
    {
      STOS[hpos]=STOS[apos];
      hpos++; apos++;
    }
  STOS[hpos]=0;
  spop(addr1);
}

void x_trim()
{
  trim(STOS);
}

void x_upcase()
{
  strupper(STOS);
}

void x_lowcase()
{
  strlower(STOS);
}

void x_dup (void) /* DUP$(c&,n%) (MB,4.24) */
{
  int c, n;
  int i;

  n = ipop (); c = ipop ();
  spush1 ();

  if (n < MAXSTRLEN)
    for (i = 0; i < n; ++i)
      STOS[i] = c;
  else
  {
    rterror (FN_DUP, 32);
    n = MAXSTRLEN - 1;
  }
  STOS[n] = '\0';
}

void x_drops (void)
{
  spop1 ();
}

void x_filelabel (void) /* FILELABEL$(mode%,submode%) (MB,4.25) */
{
  char buf[198];
  int mode, submode;

  submode = ipop ();
  mode = ipop ();
  spush1 ();

  if ((submode < 1) || (submode > 5))
    rterror (FN_FILELABEL, 38);
  switch (mode)
  {
  case 3: /* MEMO */
    submode += 5;
  case 1:
  case 2: /* CONTACTS */
    --submode;
    LibLblAreaRead ((byte*) buf, submode);
    strcpy ((char*) STOS, buf);
    break;
  default:
    rterror (FN_FILELABEL, 58);
  }
}

void x_drawtext (void)
{
  int x1, y1, x2, y2;
  int rc;
  int font;
  font = ipop ();
  y2 = ipop (); x2 = ipop ();
  y1 = ipop (); x1 = ipop ();
  rc = drawtext (STOS, x1, y1, x2, y2, font);
  if (rc != 0)
    rterror (FN_DRAWTEXT, rc);
  spop1 ();
}

void x_drawtext5 (void)
{
  ipush (-1);
  x_drawtext ();
}

void x_textbox()
{
  int x1,y1,x2,y2;
  int rc;
  int font;
  font=ipop();
  y2=ipop(); x2=ipop();
  y1=ipop(); x1=ipop();
  rc=textbox(STOS,x1,y1,x2,y2,font);
  if (rc!=0) rterror(FN_TEXTBOX,rc);
  spop1();
}

void x_textbox5()
{
  ipush(-1);
  x_textbox();
}

#ifndef SMALL_INTERFM
void x_forminit (void)
{
  int rc;
  int deffont = ipop ();
  uchar defstat = ipop ();

  rc = forminit (defstat, deffont);
  if (rc)
    rterror (FN_FORMINIT, rc);
}

void x_forminit1 (void)
{
  ipush (-1);
  x_forminit ();
}

void x_forminit0 (void)
{
  ipush (0);
  ipush (-1);
  x_forminit ();
}

void x_formdisplay (void)
{
  int rc;
  rc = formdisplay ();
  if (rc)
    rterror (FN_FORMDISPLAY, rc);
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_formentry (void)
{
  int x1, y1, x2, y2;
  int typ, id;
  int rc;
  id = ipop (); typ = ipop ();
  y2 = ipop (); x2  = ipop ();
  y1 = ipop (); x1  = ipop ();
  rc = formentry (STOS, x1, y1, x2, y2, typ, id);
  if (rc)
    rterror (FN_FORMENTRY, rc);
  spop1 ();
}

void x_formtouch (void)
{
  int sel, rc;
  int addr;
  int nowait;
  nowait = ipop ();
  addr = ipop ();
  rc = formtouch (&sel, nowait);

  if (rc)
    rterror (FN_FORMTOUCH, rc);

  xdata[addr] = sel;
#ifdef LSI_C
  bk_counter = 0;
#endif
}

void x_formtouch1 (void)
{
  ipush (FALSE);
  x_formtouch ();
}

void x_formsetstatus (void)
{
  int fid, sel;
  int rc;
  sel = ipop ();
  fid = ipop ();
  rc = formsetstatus (fid, sel);
  if (rc)
    rterror (FN_FORMSETSTATUS, rc);
}

void x_formresetstatus (void)
{
  int fid, sel;
  int rc;
  sel = ipop ();
  fid = ipop ();
  rc = formresetstatus (fid, sel);
  if (rc)
    rterror (FN_FORMRESETSTATUS, rc);
}
#endif
