/*
 * TermLib - Library for Pocketviewer for terminal emulation
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* numout.c */

#include "stdio.h"
#include "define.h"
#include "libc.h"
#include "trm.h"
#include "math.h"

void OutputITrm(int i)
{
  byte c[20];
  sprintf((char*)c,"%d ",i);
  OutputTrm(c);
}


void OutputFTrm(float f)
{
  uchar c[40];
  if (fabs(f)<1e10)
    sprintf((char*)c,"%f ",(double)f);
  else
    sprintf((char*)c,"%g ",(double)f);
  OutputTrm(c);
}

void OutputDTrm(double f)
{
  uchar c[40];
  if (fabs(f)<1e10)
    sprintf((char*)c,"%lf ",f);
  else
    sprintf((char*)c,"%lg ",f);
  OutputTrm(c);
}
