#include "owbasic.h"
#include "srl.h"
#include "rc.h"
#include "graphic.h"
#include "comp.h"
#include "form.h"

#ifdef REMOTE_CONTROL
bool CompileAndTransfer;
bool Replace;
bool Get;
bool SendBinary;

static int NEAR SendByte (byte b)
{
  while (LibSrlSendByte (IB_FOLLOW_BUSY, b) != IW_SRL_NOERR);
}

static int NEAR SendWord (word w)
{
  SendByte (w & 0xFF);
  SendByte ((w >> 8) & 0xFF);
}

static int NEAR SendString (uchar* s)
{
  do
    SendByte (*s);
  while (*(s++));
}

static void near ShowMsg (bool transfer)
{
  char buf[50];

  strcpy_nf (buf, transfer ? msg_rc_send : msg_rc_wait);
  strcat (buf, Near (msg_rc_escmsg));
  msgbox (buf, Near (msg_rc_caption), 0.0, MBX_DRAW);
  LibPutDisp ();
}

int rc_readname(uchar *name)
{
  int ct,rc;
  int c;
  ct=0;
  do
    {
      rc=srlrbyte(&c);
      if ((rc!=0)||(c<0))
  {
    rterror(FN_SRLRBYTE,rc);
    return FALSE;
  }

      if ((c>1)&&(c!=0x0d)&&(c!=0x0a))
  {
    if (ct<NAMELEN-1)
      {
        name[ct]=c;
        ct++;
      }
  }
    }
  while ((c>1)&&(c!=0x0d)&&(c!=0x0a));
  name[ct]=0;
  return TRUE;
}

int rc_readblock(void)
{
  int ct,rc;
  int c;
  ct=0;
  do
    {
      rc=srlrbyte(&c);
      if ((rc!=0)||(c<0))
  {
    rterror(FN_SRLRBYTE,rc);
    return FALSE;
  }

      if (c>0)
  {
    if (ct<2047) FB[ct]=c;
    ct++;
  }
    }
  while (c>0);
  FB[ct]=0;
  if (ct>2047)
    {
      rterror(FN_SRLRBYTE,71);
      return FALSE;
    }
  return TRUE;
}

bool rc_selprog()
{
  bool readnm = TRUE;
  int rc, ret = FALSE;
  int c;
  int ready;
  int oldtimeout;
  rc = srlopen (384, 8, 0, 1, 2, 1);
  if (rc)
  {
    rterror (FN_SRLOPEN, rc);
    return FALSE;
  }
  oldtimeout = srltimeout;
  srltimeout = 40;
  ready = FALSE;
  ShowMsg (FALSE);
  /*textbox ((uchar*)Near(rcmsg),5,20,155,40,-1);
  textbox ((uchar*)Near(escmsg),95,123,157,154,-1);
  LibPutDisp ();*/

  while(!ready) {
    do {
      rc=srlrbyte(&c);
      if (rc!=0)
  {
    rterror(FN_SRLRBYTE,rc);
    srltimeout=oldtimeout;
    srlclose();
    /*Box(5,20,155,40,10);*/
    return FALSE;
  }
      if (check_touch()) return FALSE;

    } while(c<0);

    CompileAndTransfer = FALSE;
    Replace = FALSE;
    Get = FALSE;
    SendBinary = FALSE;

#if FALSE
    switch (c)
      {
      case 'C': /* compile and run program from pc */
  rc_readname(ITOS.fname);
  ready=TRUE; ret=TRUE;
  break;
      case 'B': /* compile and run program from pc, transfer binary to pc */
  rc_readname(ITOS.fname);
  ready=TRUE; ret=TRUE;
  SendBinary=TRUE;
  break;
      case 'T': /* transfer to pv and compile and run program from pc */
  rc_readname(ITOS.fname);
  ready=TRUE; ret=TRUE;
  CompileAndTransfer=TRUE;
  break;
      case 't': /* transfer to pv and erase old, compile and run program from pc */
  rc_readname(ITOS.fname);
  ready=TRUE; ret=TRUE;
  CompileAndTransfer=TRUE;
  Replace=TRUE;
  break;
      case 'g': /* compile and run program from pv and transfer all parts to pc */
  rc_readname(ITOS.fname);
  ready=TRUE; ret=TRUE;
  Get=TRUE;
  break;
      case 'X': ready=TRUE; break;
      default: /* ignore other commands */
  break;
      }
#endif

    switch (c)
    {
    case 'B': /* compile and run program from pc, transfer binary to pc */
        SendBinary = TRUE;
    case 'C': /* compile and run program from pc */
      break;

    case 't': /* transfer to pv and erase old, compile and run program from pc */
      Replace = TRUE;
    case 'T': /* transfer to pv and compile and run program from pc */
      CompileAndTransfer = TRUE;
      break;

    case 'g': /* compile and run program from pv and transfer all parts to pc */
      Get=TRUE;
      break;
    case 'X':
      ready = TRUE;
    default: /* ignore other commands */
      readnm = FALSE;
    }
    if (readnm)
    {
      rc_readname (ITOS.fname);
      ready = TRUE;
      ret = TRUE;
    }
  }
  srlclose ();
  srltimeout = oldtimeout;
  ShowMsg (TRUE);
  return (ret);
}

void DeleteOld (const uchar *name,int type)
{
  word fp;
  uchar *sig;
  bool found;
  switch (type)
    {
    case MMAIN: sig=PROGRAMSIG; break;
    case MINCLUDE: sig=INCLUDESIG; break;
    case MAPPEND: sig=APPENDSIG; break;
    }
  do
    {
      load_memo_named(pref.progsub,sig,name,&fp);
      if (found=(fp!=-1))
  {
    fileremove(3,pref.progsub,fp);
  }
    }
  while (found);
}

bool rc_loadprog()
{
  uchar schar[]=".mia";
  uchar rchar[]=".MIA";
  int b, rc;
  int oldtimeout;

  if (Get)
    {
      /* loads memo (!) and sends (!) memo to pc */
      if (!loadprogmemo()) return FALSE;
      if (prog!=fb.fbuf.text.fsb_text_buf_) return TRUE;/* second load */

      rc=srlopen(384,8,0,1,2,1);
      if (rc!=0)
  {
    rterror(FN_SRLOPEN,rc);
    return FALSE;
  }
      SendByte(schar[ITOS.progtype]);
      SendString(ITOS.fname); /* send name of memo */
      SendString(prog);       /* send content of memo */
      srlclose();
      return TRUE;
    }

  /* normal load of memo from pc */
  rc=srlopen(384,8,0,1,2,1);
  if (rc!=0)
    {
      rterror(FN_SRLOPEN,rc);
      return FALSE;
    }

  oldtimeout=srltimeout;
  srltimeout=40;

  /* send request */
  SendByte(rchar[ITOS.progtype]);
  SendString(ITOS.fname); /* send name */

  do {
    rc=srlrbyte(&b);
    if (rc!=0)
      {
  srlclose();
  srltimeout=oldtimeout;
  return FALSE;
      }
  }
  while (b<0);
  if (b=='O')
    {
      if ((Replace)&&(prog==fb.fbuf.text.fsb_text_buf_) /* and first read */ )
  {
    DeleteOld(ITOS.fname,ITOS.progtype);
  }
      rc=rc_readblock(); /* read text */
      srlclose();
      srltimeout=oldtimeout; /* restore timeout */
      if ((rc)&& /* if successful ..*/
    (CompileAndTransfer)&&  /* and "compile and store" */
    (prog==fb.fbuf.text.fsb_text_buf_) /* and first read */ )
  {
    save_file (3,pref.progsub,-1); /* save as memo */
  }
      return rc;
    }
  /*  if (b=='E') {*/
  /* error */
  srlclose();
  srltimeout=oldtimeout;
  return FALSE;
}

void rc_send_binary()
{
#if FALSE
  word i, ct, cs, rc;

  rc=srlopen(384,8,0,1,2,1);
  if (rc!=0)
    {
      rterror(FN_SRLOPEN,rc);
      return;
    }
 SendByte('b');
 cs=pc.c-bin;
 SendWord(cs);/* code size */
 for (i=0; i<cs; i++) /* send code */
   SendWord(bin[i]);
 SendWord(bin_start.c-bin); /* prog start */
 SendWord(datanext); /* size of variables */
 i=0;
 while (i<datanext) /* send variables */
   {
     SendWord(xdata[i]); i++;
     ct=0;          /* runlength coded series of 0 values */
     while ((xdata[i]==0)&&(i<datanext)) { ct++; i++; }
     SendWord(ct);
   }
 SendWord(0);                   /* end of variables */
 SendWord(DATASIZE-firstconst); /* size of constants */
 for (i=firstconst;i<DATASIZE;i++) /* send constants as is */
   SendWord(xdata[i]);
 SendWord(tchxi);
 SendWord(tchyi);
 SendWord(tchobji);
 SendWord(tchstsi);
 SendWord(pvmodeli);
 SendWord(owbversioni);
 SendWord(formstrings);
 srlclose();
#endif
}

bool rc_finish (int success, uchar *message)
{
  srlopen (384,8,0,1,2,1);
  if (success)
    SendByte ('O');
  else
    {
      SendByte ('E');
      SendString (message);
    }
  srlclose ();
  return (0);
}
#endif
