#include "owbasic.h"
#include "srl.h"
/*
  serial interface
*/

SRL_STAT srlstat;
int srltimeout = -1;


int srlopen (int rate, int bits, int par, int stop, int fctrl, int port)
{
  switch (port)
  {
  case 1: srlstat.port = IB_SRL_COM2; break;
  case 2: srlstat.port = IB_SRL_COM3; break;
  default: return (38);
  }

  srlstat.fctrl = fctrl;

  switch (stop)
  {
  case 1: srlstat.stopb = IX_SRL_1STOP; break;
  case 2: srlstat.stopb = IX_SRL_2STOP; break;
  default: return (38);
  }

  switch (par)
  {
  case 0: srlstat.parit = IX_SRL_NONE; break;
  case 1: srlstat.parit = IX_SRL_ODD; break;
  case 2: srlstat.parit = IX_SRL_EVEN; break;
  default: return (38);
  }

  switch (bits)
  {
  case 7: srlstat.datab = IX_SRL_7DATA; break;
  case 8: srlstat.datab = IX_SRL_8DATA; break;
  default: return (38);
  }

  switch (rate)
  {
  case 1152: srlstat.speed = IB_SRL_115200BPS; break;
  case 576: srlstat.speed = IB_SRL_57600BPS; break;
  case 384: srlstat.speed = IB_SRL_38400BPS; break;
  case 192: srlstat.speed = IB_SRL_19200BPS; break;
  case 96: srlstat.speed = IB_SRL_9600BPS; break;
  case 48: srlstat.speed = IB_SRL_4800BPS; break;
  case 24: srlstat.speed = IB_SRL_2400BPS; break;
  case 12: srlstat.speed = IB_SRL_1200BPS; break;
  case 6: srlstat.speed = IB_SRL_600BPS; break;
  case 3: srlstat.speed = IB_SRL_300BPS; break;
  default: return (38);
  }

  if (LibSrlPortOpen (&srlstat) != IW_SRL_NOERR)
    return (39);
  return (0);
}

int srlrbyte(int *rb)
{
  word num, stat;
  byte by;
#ifdef LSI_C
  /*!!!!!*/
  int tr;
  int ta;
#endif
  int timeoutcounter;

#ifdef LSI_C
  /*!!!!!*/
  tr=timerruns;
  if (!tr) setintvec();
  ta=counter;
#endif
  timeoutcounter=srltimeout;

  do {
    if (LibSrlGetDteStat(&num,&stat)!= IW_SRL_NOERR)
      {
  return 39;
      }
#ifdef LSI_C
    /* !!!!!!! */
    if (ta!=counter)
      {
  ta=counter;
  if (timeoutcounter>0) timeoutcounter--;
      }
#endif
  } while ((num<1)&&(timeoutcounter!=0));
#ifdef LSI_C
    /* !!!!!!! */
  if (!tr) resetintvec();
#endif
  if (timeoutcounter == 0)
    {
      *rb = -1;
      return (0);
    }
  if (LibSrlRecvByte (&by) != IW_SRL_NOERR)
    return (39);
  *rb=by;
  return (0);
}

void srlclose (void)
{
  while (LibSrlPortClose () != IW_SRL_NOERR);
}
