#include "owbasic.h"
#pragma optimize time

int i_stack[I_STACK_SIZE];
int *i_stack_ptr;

FLOATT f_stack[F_STACK_SIZE];
FSTACKPTR f_stack_ptr;

PC g_stack[G_STACK_SIZE];
PC* g_stack_ptr;

/*------------ Stacks ------------------------*/
/* int */

#ifndef FAST_MACRO
#ifndef LSI_C
int ipop()
{
#ifndef FAST
  if (i_stack_ptr<i_stack) rterror(FN_STACK,3);
#endif
  return *(i_stack_ptr--);
}

int ipop_fast()
{
  return *(i_stack_ptr--);
}

void ipop1()
{
#ifndef FAST
  if (i_stack_ptr<i_stack) rterror(FN_STACK,3);
#endif
  i_stack_ptr--;
}

void ipop2()
{
#ifndef FAST
  if (i_stack_ptr<i_stack) rterror(FN_STACK,3);
#endif
  i_stack_ptr-=2;
}

#endif

#ifndef LSI_C
  void ipush(int i)
{
  *(++i_stack_ptr)=i;
#ifndef FAST
  if (i_stack_ptr>=i_stack+I_STACK_SIZE-1) rterror(FN_STACK,7);
#endif
}
#endif
/* float */
FLOATT fpop()
{
#ifndef FAST
  if (f_stack_ptr.f<f_stack) rterror(FN_STACK,25);
#endif
  return *(f_stack_ptr.f--);
}

void fpopn(int n)
{
  f_stack_ptr.f-=n;
#ifndef FAST
  if (f_stack_ptr.f<f_stack-1) rterror(FN_STACK,25);
#endif
}

void fpush(FLOATT i)
{
  *(++f_stack_ptr.f)=i;
#ifndef FAST
  if (f_stack_ptr.f>=f_stack+F_STACK_SIZE-1) rterror(FN_STACK,26);
#endif
}

void ipopn(int n)
{
  i_stack_ptr-=n;
#ifndef FAST
  if (i_stack_ptr<i_stack-1) rterror(FN_STACK,3);
#endif
}
#endif


/* GOSUB stack */
PC gpop()
{
/*#ifndef FAST*/
  if (g_stack_ptr==g_stack) rterror(FN_STACK,8);
/*#endif*/
  return *(g_stack_ptr--);
}

void gpush(PC i)
{
  g_stack_ptr++;
/*#ifndef FAST*/
  if (g_stack_ptr>=g_stack+G_STACK_SIZE) rterror(FN_STACK,9);
/*#endif*/
  *g_stack_ptr=i;
}
