#include <string.h>
#include <stdlib.h>
#include "owbasic.h"
#include "fnames.h"
#include "sound.h"
#include "getbatt.h"
#include "inter.h"
#include "comp.h"
#include "graphic.h"
#include "srl.h"

#ifdef __HITACHI__
#define TSTR 0xFFFFFE92
#define TCOR0 0xFFFFFE94
#define TCNT0 0xFFFFFE98
#define TCR0 0xFFFFFE9C
#define TCOR1 0xFFFFFEA0
#define TCNT1 0xFFFFFEA4
#define TCR1 0xFFFFFEA8
#define TCOR2 0xFFFFFEAC
#define TCNT2 0xFFFFFEB0
#define TCR2  0xFFFFFEB4
#endif

char TimerRuns = 0;

#ifdef __HITACHI__
void InitBreakTimer (void)
{
  /* timer 0 for touch screen and break test */
  *(byte*) TSTR  = *(byte*) TSTR & 0xFE;
  *(int*) TCOR0  = 6000;
  *(int*) TCNT0  = 0;
  *(short*) TCR0 = 3;
  *(byte*) TSTR  = *(byte*) TSTR | 0x01;
}
#endif

void StartTimer (void)
{
#ifdef __HITACHI__
  /* start timer 2 with RTC clock */
  *(byte*) TSTR  = *(byte*) TSTR & 0xFB;
  *(int*) TCOR2  = 0xFFFFFFFF;
  *(int*) TCNT2  = 0xFFFFFFFF;
  *(short*) TCR2 = 3;
  *(byte*) TSTR  = *(byte*) TSTR | 0x04;
#endif
#ifdef LSI_C
  setintvec ();
  counter = 0;
#endif
  TimerRuns = 1;
}

/*void InitTimer (void)
{
  StartTimer (); /+ At the moment the same as inittimer +/
}*/

#ifdef __HITACHI__
FLOATT Timer (void)
{
  return (0xFFFFFFFF - *(int*) TCNT2) / 57540.0;
}
#endif

#ifdef LSI_C
FLOATT Timer (void)
{
  return (counter * (1.0 / 40.0));
}
#endif

static int rcnt;
static bool timerruns2;

void PauseTimer (void)
{
  if (timerruns2 = TimerRuns)
  {
#ifdef __HITACHI__
    rcnt = *(int*) TCNT2;
#endif
#ifdef LSI_C
    rcnt = counter;
#endif
    StopTimer ();
  }
}

void ContinueTimer (void)
{
  if (timerruns2)
  {
    StartTimer ();
#ifdef __HITACHI__
    *(int*) TCNT2 = rcnt;
#endif
#ifdef LSI_C
    counter = rcnt;
#endif
  }
}

void StopTimer (void)
{
#ifdef __HITACHI__
  *(byte*) TSTR = *(byte*) TSTR & 0xFB;
#endif
#ifdef LSI_C
  resetintvec ();
#endif
  TimerRuns = 0;
}

FLOATT lasttime;
FLOATT nexttime;
FLOATT timestep;

int InitSync (FLOATT dt)
{
  if (dt < 0.0)
    return (38);
  StartTimer ();
  lasttime = /*Timer ()*/ 0.0;
  nexttime = /*lasttime +*/ dt;
  timestep = dt;
  return (0);
}

bool Sync (void)
{
  FLOATT atime = Timer ();
  if ((atime < lasttime) /* overflow */
   || (atime >= nexttime))
  {
    lasttime = nexttime;
    nexttime += timestep;
    return (TRUE);
  }
  return (FALSE);
}
