#ifndef _CSTACK_H
#define _CSTACK_H

#include "modeldef.h"

/* types of control structures */
#define CFOR 1
#define CIF 2
#define CCASE 3
#define CWHILE 4
#define CDO 5
#define CDOC 6

#define C_BREAK     0
#define C_CONTINUE  1

#ifdef LSI_C
 #define C_BRK    0x80
 #define C_CNT    0x40
 #define C_UMASK  0xC0
 #define C_NMASK  0x3F
 typedef uchar csstype;
#endif

#ifdef __HITACHI__
 #define C_BRK    0x8000
 #define C_CNT    0x4000
 #define C_UMASK  0xC000
 #define C_NMASK  0x3FFF
 typedef short csstype;
#endif

typedef struct cstack_entry {
  uchar type; /* kind of control structure */
  csstype brkuse; /* bit 0-5: last loop entry index, bit 6: CONTINUE used, bit 7: BREAK used */
  int var;  /* var for "for", type for case */
  PC start; /* CFOR: where to go, if closing loop */
  PC ende;  /* CFOR: where to put jump -> after NEXT */
  /* CIF: where to link jump to END or ELSE */
  int step; /* step width for CFOR; count of OF for CCASE */
  int brkcnt; /* CFOR, CWHILE, CDO, CDOC: break label number; CCASE: extended type */
} cstack_entry;

extern cstack_entry cstack[FOR_NEST];
extern int cstack_label;

/*void noopenerror(int type);*/
void notclosederror(int type);
void cpush(cstack_entry i);
cstack_entry cpopandtest(int type);
cstack_entry cpop(void);
#endif
