#ifndef FILE_H
#define FILE_H

#include "modeldef.h"
#include "code.h"

/* --------FILE OPERATIONS -------------------- */
extern FILE_BUF fb; /* filebuffer for all fileoperations */
#define FB fb.fbuf.text.fsb_text_buf_
#define FBB fb.fbuf.bin.bin_buf
#define FBBNUM fb.fbuf.bin.char_num

#ifdef __HITACHI__
 #define FBSIZE (32 * 1024)
#endif
#ifdef LSI_C
 #define FBSIZE (3 * 1024)
#endif

/* !!! */
/* extern word fbfp; */  /* corresponding filepointer */
/* extern byte fbmin;  */ /* corresponding minor mode */
/*
  extern byte fbmode;
*/
extern FILE_INFO finf;

extern int fbptr;

#ifdef LSI_C
unsigned int mmblocks (void); /* borrowed from mmblocks.a86 by Johannes Steingrber (MB,4.10) */
#endif

void SetFP(int mode,int sub,word fp);
/*
  extern uchar filename[NAMELEN];
*/
extern uchar progname[NAMELEN];
extern uchar recordname[];

word get_file_fp(int mode,int sub, int nr);

void fbuffer2name(uchar *name);
int fp2name(byte sub,word fp,uchar *name);

bool load_memo_named(int sub,const uchar *sig,const uchar *name,word *fp);

int loadmemofp(int addr,int size,int sub,word fp,int *total);
int savememofp(int addr,int size,int sub,word *fp,int anz);
int loadmemo(int addr,int size,int sub,int nr,int *total);
int savememo(int addr,int size,int sub,int nr,int anz);
int loadmemonamed(int addr,int size,int sub,const uchar *name,
      const uchar* sig,int* total,word* fp);

int loadqmfp (int addr, int size, int sub, word fp);
int saveqmfp (int addr, int size, int sub, word FAR* fp);
int loadqm (int addr,int size,int sub,int nr);
int saveqm (int addr,int size,int sub,int nr);
int loadqmhash (int addr,int size,int sub,int crc1,int crc2,word* fp,int mode);
int iconhash (int addr, int size, int FAR* crc1, int FAR* crc2, int mode);

int namedfile (const uchar* name,int* imode,int* isubmode);

bool load_file (int mode,int sub,int nr);
bool save_file (int mode,int sub,int nr);

int  filefind   (int mode, int sub, const uchar* name, const uchar* sig, word* fp);
word filenext   (int mode, int sub, word fp);
word fileprev   (int mode, int sub, word fp);
word filewrite  (int mode, int sub, word fp);
bool fileread   (int mode, int sub, word fp);
bool fileremove (int mode, int sub, word fp);
bool filemove   (int mode, int sub, word fp, word fpz);

bool loadshared   (const uchar *sig, const uchar* pname, uchar FAR* buf, int n);
bool saveshared   (const uchar *sig, const uchar* pname, uchar FAR* buf, int n);
bool removeshared (const uchar *sig, const uchar* pname);
bool findshared   (const uchar *sig, const uchar* pname, uchar* rname, int namelen, word* fp);


/*#define OV_DELETE 0*/
#define OV_LOAD   1
#define OV_SAVE   2

bool Overlay (int action, int nr, codet* addr, int n);

/*bool SaveOverlay (codet* addr, int n, int procnr);
bool LoadOverlay (codet* addr, int n, int procnr);
void DeleteOverlay (int procnr);*/

/* ---- FILEBUFFER OPERATIONS ------------------------*/
#ifndef SMALL_FBDATETIME
int fbdate (int i, uchar* s);
int fbputdate (int i, uchar* s);
int fbtime (int i, uchar* s);
int fbputtime (int i, uchar* s);
#else
typedef uchar* fbdatetime_t;
extern const fbdatetime_t FAR fbdatep[];
extern const fbdatetime_t FAR fbtimep[];
int fbdatetimei (int i, uchar* s, int max, int put, const fbdatetime_t FAR* tbl);

#define fbdate(i,s)     fbdatetimei (i, s, 8, FALSE, fbdatep)
#define fbtime(i,s)     fbdatetimei (i, s, 4, FALSE, fbtimep)
#define fbputdate(i,s)  fbdatetimei (i, s, 8, TRUE, fbdatep)
#define fbputtime(i,s)  fbdatetimei (i, s, 4, TRUE, fbtimep)
#endif
/* write/read of string data to text file buffer and move pointer */
int fbstore (uchar* s, int del);
int fbstring (uchar* s, int* rc, int del);
/*  write and read  binary filebuffer FBB */
#ifndef FAST_MACRO
int fbinit (void);
int fbbinit (void);
int fbbtell (void);
#else
#define fbinit()  (fbptr = 0)
#define fbbinit() (fbptr = 0)
#define fbbtell() (fbptr)
#endif
int fbbseek (int bnumber);

int fbbputint (int val);
int fbbputbyte (int bval);
int fbbputfloat (FLOATT val);
int fbbputstring (uchar* s);

int fbbint (int* ival);
#ifdef __HITACHI__
int fbbshort (int* ival);
#endif
int fbbbyte (int* bval);
int fbbfloat (FLOATT* val);
int fbbstring (uchar* s);

#endif
