#ifndef GRAPHIC_H
#define GRAPHIC_H

#include "modeldef.h"
#include "ostring.h"
#include "owbasic.h"

/* auxiliary function crc */
extern int default_hash_mode;
void crc (byte FAR *sptr, int len, int FAR* crc1, int FAR* crc2, int mode);

#define MINX 0
#define MINY 0
#define MAXX 159
#define MAXY 159

/* graphic */

#ifdef __HITACHI__
extern uchar libfonts[4];
#define LFONT(i) libfonts[i & 3]
#else
#define LFONT(i) i
#endif

#ifndef FAST_MACRO
int checkx(int x);
int checky(int y);
int checkxy(int x,int y);
#else
#define checkx(x)     (((x) < MINX) ? FALSE : ((x) <= MAXX))
#define checky(y)     (((y) < MINY) ? FALSE : ((y) <= MAXY))
#define checkxy(x,y)  (checkx(x) ? checky(y) : FALSE)
#endif
int checkxy2(int x,int y,int x1,int y1);

/*int inrange(int x,int x1,int x2);*/

int pset(int x,int y,int c);

int Line(int x1,int y1,int x2,int y2,int color);
int Ellipse(int xm,int ym,int rx,int ry,int color);
int Box(int x1,int y1,int x2,int y2,int mode);
bool Ask(uchar* message, uchar* caption);

/* graphtext */
int stringsize(uchar *text,int font);
int stringheight(uchar *text,int font);
int drawstring(uchar *text,int x0,int y0,int font,int xend);
int textbox(uchar *text,int x1,int y1,int x2,int y2,int font);
int drawtext(uchar *text,int x1,int y1,int x2,int y2,int font);
void floatinput (FLOATT* f);
void strinpbkg (const uchar* topic);

#define MBX_DRAW  0
#define MBX_WAIT  1
#define MBX_OK    2
#define MBX_YESNO 3
int  msgbox (uchar* text, uchar* caption, FLOATT time, int type);
void msgbox1 (uchar* text);

int  qbox (int x1, int y1, int x2, int y2);
void dbox (int x1, int y1, int x2, int y2, uchar* caption);

int tchinside (int x1, int y1, int x2, int y2);

extern const uchar FAR fn57[8*256];

/* icon */
bool checkicon (int xs, int ys, int size);

void iconaddr0(int FAR *aa,int ox,int oy,int *bm,int FAR **p);
bool iconaddr(int FAR *aa,int ox,int oy,int *bm,int FAR **p);

/*int drawicon(byte FAR* addr,int x,int y, int mode);*/
int geticon(int addr,int x1,int y1,int x2,int y2);

#ifdef __HITACHI__
extern byte iconbuffer[3204];
void toiconbuffer(byte* addr);
void fromiconbuffer(int addr);
#endif

#define MAXDRAWMODES (1<<3)
#define DRAWMODEMASK (MAXDRAWMODES-1)
extern const byte FAR drawmode[MAXDRAWMODES];
#define DRAWMODE(x) drawmode[x & DRAWMODEMASK]

typedef void setfunc(int x,int y);
typedef setfunc *setfuncp;
extern const setfuncp FAR psetfunc[MAXDRAWMODES];

typedef void linfunc(int x1,int y1,int x2,int y2);
typedef linfunc *linfuncp;
extern const linfuncp FAR linefunc[MAXDRAWMODES];

typedef void boxfunct(int x1,int y1,int x2,int y2);
typedef boxfunct *boxfuncp;
extern const boxfuncp FAR boxfunc[MAXDRAWMODES];

#define MAXFILLMODES (1<<3)
#define FILLMODEMASK (MAXFILLMODES-1)
extern const byte FAR fillmode[MAXFILLMODES];
#define FILLMODE(x) fillmode[x & FILLMODEMASK]


#endif


