/*
   Mathematik fr OWBasic.
*/

#include "modeldef.h"
#include "owbasic.h"
#include <math.h>

extern FLOATT cf;
extern FLOATT cf2;

#ifndef FAST_MATH
FLOATT Sin(FLOATT value);
FLOATT Cos(FLOATT value);
FLOATT Tan(FLOATT value);
FLOATT Log(FLOATT value);
FLOATT Log2(FLOATT value);
FLOATT Ln(FLOATT value);
FLOATT Sqrt(FLOATT value);
FLOATT ASin(FLOATT value);
FLOATT ACos(FLOATT value);
FLOATT ATan(FLOATT value);
FLOATT Sinh(FLOATT value);
FLOATT Cosh(FLOATT value);
FLOATT Tanh(FLOATT value);
FLOATT ASinh(FLOATT value);
FLOATT ACosh(FLOATT value);
FLOATT ATanh(FLOATT value);
FLOATT ALog(FLOATT value);
FLOATT ALog2(FLOATT value);
FLOATT ALn(FLOATT value);
FLOATT Sqr(FLOATT value);
FLOATT Pow(FLOATT value, FLOATT val);
FLOATT Nrt(FLOATT value, FLOATT val);
FLOATT ATan2(FLOATT value,FLOATT value2);


FLOATT XCart(FLOATT r,FLOATT fi);
FLOATT YCart(FLOATT r,FLOATT fi);
FLOATT Radius(FLOATT x,FLOATT y);
FLOATT Phi(FLOATT x,FLOATT y);

/* Conversion from current mode (rad/degree/grad) to specified mode */

FLOATT Deg(FLOATT value);
FLOATT Rad(FLOATT value);
FLOATT Grad(FLOATT value);

#else

#define LN10 (/*log(10)*/ 2.302585092994046)
#ifdef LSI_C
#define LN2 (/*log(2)*/ 0.6931471805599453)
#else
#define LN2 log(2)
#endif

#define NAN (1.0e301)

#define TORAD(value) ((value) * cf2)
#define FROMRAD(value) ((value) * cf)

#define Sin(val)      (sin (TORAD (val)))
#define Cos(val)      (cos (TORAD (val)))
#define Tan(val)      (tan (TORAD (val)))
#define Log(val)      (log (val) / LN10)
#define Log2(val)     (log (val) / LN2)
#define Ln(val)       (log (val))
#define Sqrt(val)     (sqrt (val))
#define ASin(val)     (FROMRAD (asin (val)))
#define ACos(val)     (FROMRAD (acos (val)))
#define ATan(val)     (FROMRAD (atan (val)))
#define ATan2(v1,v2)  (FROMRAD (atan2 (v1, v2)))
#define Sinh(val)     (sinh (val))
#define Cosh(val)     (cosh (val))
#define Tanh(val)     (tanh (val))
#define ASinh(val)    (log (val + sqrt (val * val + 1)))
#define ACosh(val)    (log ((val > 0.0) ? (val + sqrt (val * val - 1)) : (val - sqrt (val * val - 1))))
#define ATanh(val)    (0.5 * log ((1 + val) / (1 - val)))
#define ALog(val)     (exp (val * LN10))
#define ALog2(val)    (exp (val * LN2))
#define ALn(val)      (exp (val))
#define Sqr(val)      (val * val)
#define Pow(v1,v2)    (pow (v1, v2))
#define Nrt(v1,v2)    (pow (v1, 1.0 / v2))

/*
 * Koordinatenwandlungen
 */

#define XCart(r,phi)  (cos (TORAD (phi)) * r)
#define YCart(r,phi)  (sin (TORAD (phi)) * r)
#define Radius(x,y)   (Sqrt ((x * x) + (y * y)))
#define Phi(x,y)      (ATan2 (y, x))

/* Conversion from current mode (rad/degree/grad) to specified mode */

#define Deg(val)      (val * cf2 * (180 / PI))
#define Rad(val)      (TORAD (val))
#define Grad(val)     (val * cf2 * (200 / PI))

#endif
