#ifndef _OSTRING_H
#define _OSTRING_H

#include "owbasic.h"

#ifndef UCHAR
#define UCHAR
typedef unsigned char uchar;
#endif

int strcmp_nf(const uchar *sn,const uchar FAR *sf);
void strcpy_nf(uchar *sn,const uchar FAR *sf);

void strlower(uchar *s);
void strupper(uchar *s);

#ifdef NEVER_DEFINED
/* copy "special" strings (with given stringlength) */
#define strcpy_ident(d,s)   strncpy ((char*) (d), (char*) (s), IDENTLEN)
#define strcpy_string(d,s)  strncpy ((char*) (d), (char*) (s), MAXSTRLEN)
#define strcpy_name(d,s)    strncpy ((char*) (d), (char*) (s), NAMELEN)
#else
void strcpy_ident (uchar *d,const uchar *s);
void strcpy_string (uchar *d,const uchar *s);
void strcpy_name (uchar *d,const uchar *s);
#endif

void trim(uchar *s);
int countc(uchar c,const uchar *s);
int pos (const uchar* needle, const uchar* haystack, bool case_sensitive);

extern uchar stringstack1[]; /* OWBasic parameter at compile time */
extern uchar stringstack2[]; /* file list filter in main menu; file signature in cache functions */
extern uchar stringstack3[]; /* near buffer at compile time */

#ifdef LSI_C
#define stringstack4  ((uchar*) (IncStack))
#define stringstack5  ((uchar*) (cstack))

 #define NEARBUFFERSIZE 50
 extern char nbuffer[NEARBUFFERSIZE];
 extern char* nbptr;
 char* Near (char FAR*);
#else
extern uchar stringstack4[];
extern uchar stringstack5[];

 #define Near(c) c
#endif

#endif


