/*
 * SharedLib - Library for Pocketviewer for access to shared file
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef SHARED_H
#define SHARED_H

#ifdef __HITACHI__
#define FAR /* nothing */
#define NEAR /* nothing */
#include <stdio.h>
#define FREEBYTES 30000
extern FILE_BUF fbuf;
#else
#define FAR far
#define NEAR near
#define FREEBYTES 3000
#endif

#include <libc.h>

#define FILENAME "SHARED"

#ifndef UCHAR
#define UCHAR
typedef unsigned char uchar;
#endif

int sfLoadRecord(const uchar *signature,int size,byte FAR *buffer);
int sfSaveRecord(const uchar *signature,int size,byte FAR *buffer);
int sfRemoveRecord(const uchar *signature);
int sfFindRecord(const uchar *signature,uchar *recname,int nlen,word *fp);

/* private functions */
int sffindfile(FILE_BUF *fb);
int sffindrecord(const uchar signature[],FILE_BUF *fb,FILE_INFO *fi);
#endif
