#ifndef STACKS_H
#define STACKS_H

#include "modeldef.h"
#include "owbasic.h"
/*-------------- stacks ---------*/
#define I_STACK_SIZE    22

extern int i_stack[I_STACK_SIZE];
extern int *i_stack_ptr;

#define TOS *i_stack_ptr
#define ST1 *(i_stack_ptr-1)
#define ST2 *(i_stack_ptr-2)
#define ST3 *(i_stack_ptr-3)
#define ST4 *(i_stack_ptr-4)

#ifdef FAST_MACRO

#define ipop()        *(i_stack_ptr--)
#define ipop_fast()   *(i_stack_ptr--)
#define ipopn(n)      i_stack_ptr -= n
#define ipop1()       --i_stack_ptr
#define ipop2()       i_stack_ptr -= 2

#ifdef LSI_C
 #define ipush(i)     *(++i_stack_ptr) = i
#else
 #define ipush(i)     *(i_stack_ptr + 1) = i; ++i_stack_ptr
 /* this is necessary because the PV-S1600 compiler first increments i_stack_ptr and then
    evaluates i; the first variant would cause different results on different hardware */
#endif

#else
int ipop(void);
int ipop_fast(void);

void ipush(int i);
void ipopn(int n);
void ipop1(void);
void ipop2(void);
#endif


#ifdef __HITACHI__
 #define F_STACK_SIZE   40
#else
 #define F_STACK_SIZE   20
#endif

typedef union _FSTACKPTR
{
  FLOATT* f;
  int*    i;
} FSTACKPTR;

extern FLOATT f_stack[F_STACK_SIZE];
extern FSTACKPTR f_stack_ptr;

#define FTOS *(f_stack_ptr.f)
#define FST1 *(f_stack_ptr.f - 1)
#define FST2 *(f_stack_ptr.f - 2)
#define FST3 *(f_stack_ptr.f - 3)
#define FST4 *(f_stack_ptr.f - 4)


#define I2TOS *(f_stack_ptr.i)
#define I2ST1 *(f_stack_ptr.i - 1)
#define I2ST2 *(f_stack_ptr.i - 2)
#define I2ST3 *(f_stack_ptr.i - 3)
#define I2ST4 *(f_stack_ptr.i - 4)

#define i2pop()   *(f_stack_ptr.i--)
#define i2popn(n) f_stack_ptr.i -= n

#ifdef LSI_C
 #define i2push(n)  *(++f_stack_ptr.i) = n
#else
 #define i2push(n)   *(f_stack_ptr.i + 1) = n; ++f_stack_ptr.i
 /* see above */
#endif

#ifdef FAST_MACRO
#define fpop()      *(f_stack_ptr.f--)
#define fpopn(n)    f_stack_ptr.f -= n

#ifdef LSI_C
 #define fpush(n)   *(++f_stack_ptr.f) = n
#else
 #define fpush(n)   *(f_stack_ptr.f + 1) = n; ++f_stack_ptr.f
 /* see above */
#endif

#else
FLOATT fpop(void);
void fpush(FLOATT f);
void fpopn(int n);
#endif

#endif


