################################################################
#  SHC INSTALLATION DIRECTORY SETTING
################################################################
TCDIR=c:\pvshcom\shc
#########################################################################
#	MAKE file for release application (MOD.1)
#########################################################################

#------------------------------------------------------------------------
# Tools									|
# SH C/C++ Compiler phase
PVSDK_BASE=..

CC=$(TCDIR)\bin\shc.exe

# SH Assembler
ASM=$(TCDIR)\bin\asmsh.exe

# OptLinker
LNK=$(TCDIR)\bin\optlnk.exe

# Set Header
SETHED=$(PVSDK_BASE)\TOOLS\sethead.exe

# Put Name
PUTNAME=$(PVSDK_BASE)\TOOLS\putname.exe

# End of Tools 								|
#------------------------------------------------------------------------
#------------------------------------------------------------------------
# PV system config							|
STARTUP = $(PVSDK_BASE)\system\obj\startapl.obj
SETUP = $(PVSDK_BASE)\system\obj\setup.obj
SECT = $(PVSDK_BASE)\system\obj\section.obj
SYSRAM = $(PVSDK_BASE)\system\obj\rsysram.obj
BOOTINF = $(PVSDK_BASE)\system\obj\bootinf.obj

LDIR= $(PVSDK_BASE)\lib\LibH
SYSSRCDIR = $(PVSDK_BASE)\system
LCOM_H="$(LDIR)\define.h" "$(LDIR)\LIBC.H" "$(LDIR)\L_LIBC.H" "$(LDIR)\L_define.h"
LLIB   ="$(PVSDK_BASE)\lib\libc.lib"
ADDLIB ="$(PVSDK_BASE)\lib\addlibc.lib" 
TERMLIB="$(PVSDK_BASE)\lib\termlib.lib"
SHAREDLIB="$(PVSDK_BASE)\lib\shared.lib"
MODECALLLIB="$(PVSDK_BASE)\lib\modecall.lib"

HIDIR = $(PVSDK_BASE)\lib\hilib
HILIB = "$(HIDIR)\HiLIB.LIB"
SHCLIB ="$(TCDIR)\shclib.lib"

#Common setting for Application
SOURCES = sources.def
SUBCOM = $(PVSDK_BASE)\tools\Makefile.sub
SRCDIR = c
OUTDIR = release
BINOUTDIR = user_bin
INC="h","$(LDIR)","$(HIDIR)"
LNKINF0=$(LCOM_H) $(LLIB) $(ADDLIB) $(TERMLIB) $(SHAREDLIB) $(MODECALLLIB) $(SHCLIB) $(STARTUP) $(SOURCES)
CCINF=-include=$(INC) -subcommand=$(SUBCOM)
SETHEDINF=-vl0100 -m1 -pA -o -bImenuicon\icon.bmp -bLmenuicon\licon.bmp

PUTNAMEINF=-p0 -wp

# End of system config							|
#------------------------------------------------------------------------
# Description blocks
SHCENV : 
	set PATH=$(TCDIR)\bin
	set SHC_INC=$(TCDIR)\include
	set SHC_LIB=$(TCDIR)\bin
	set SHC_TMP=$(TCDIR)
#########################################################################
#	Application Independent Definations
#########################################################################

#########################################################################
#	Application							#

# use this name when a script creates *.pva,*.abs and *.dbg
TARGET=OWBasic

# PV Application Title (This name is displayed on PV Menu)
TITLE="OWBasic"

# ProgramVersion(EX. 0100->Ver1.00)
VERSION = 0500
OWBVersion = 500
CCINF0 = -define=OWBVersion="$(OWBVersion)" $(CCINF)

# Application Sources (src\*.c)
FILE0=code
FILE1=owbasic
FILE2=cstack
FILE3=error
FILE4=exparse
FILE5=interg
FILE6=file
FILE7=filebuf
FILE8=interfm
FILE9=graphic
FILE10=graphtext
FILE11=inter
FILE12=interf
FILE13=comp
FILE14=stringtools
FILE15=srl
FILE16=interm
FILE17=inters
FILE18=lex
FILE19=list
FILE20=gui
FILE21=stacks
FILE22=math
FILE23=string
FILE24=rc
FILE25=sound
FILE26=ftable4
FILE27=interfs
FILE28=icon
FILE29=getbatt
FILE30=timer
FILE31=crc
FILE32=bin
FILE33=fardata
FILE34=cache
FILE35=msg

#FILE20=menu
#FILE33=fnames
#FILE34=font
#FILE35=sinus
#FILE36=tables
USERALLOBJ=	\
	"$(OUTDIR)\$(FILE0).obj" \
	"$(OUTDIR)\$(FILE1).obj" \
	"$(OUTDIR)\$(FILE2).obj" \
	"$(OUTDIR)\$(FILE3).obj" \
	"$(OUTDIR)\$(FILE4).obj" \
	"$(OUTDIR)\$(FILE5).obj" \
	"$(OUTDIR)\$(FILE6).obj" \
	"$(OUTDIR)\$(FILE7).obj" \
	"$(OUTDIR)\$(FILE8).obj" \
	"$(OUTDIR)\$(FILE9).obj" \
	"$(OUTDIR)\$(FILE10).obj" \
	"$(OUTDIR)\$(FILE11).obj" \
	"$(OUTDIR)\$(FILE12).obj" \
	"$(OUTDIR)\$(FILE13).obj" \
	"$(OUTDIR)\$(FILE14).obj" \
	"$(OUTDIR)\$(FILE15).obj" \
	"$(OUTDIR)\$(FILE16).obj" \
	"$(OUTDIR)\$(FILE17).obj" \
	"$(OUTDIR)\$(FILE18).obj" \
	"$(OUTDIR)\$(FILE19).obj" \
	"$(OUTDIR)\$(FILE20).obj" \
	"$(OUTDIR)\$(FILE21).obj" \
	"$(OUTDIR)\$(FILE22).obj" \
	"$(OUTDIR)\$(FILE23).obj" \
	"$(OUTDIR)\$(FILE24).obj" \
	"$(OUTDIR)\$(FILE25).obj" \
	"$(OUTDIR)\$(FILE26).obj" \
	"$(OUTDIR)\$(FILE27).obj" \
	"$(OUTDIR)\$(FILE28).obj" \
	"$(OUTDIR)\$(FILE29).obj" \
	"$(OUTDIR)\$(FILE30).obj" \
	"$(OUTDIR)\$(FILE31).obj" \
	"$(OUTDIR)\$(FILE32).obj" \
	"$(OUTDIR)\$(FILE33).obj" \
	"$(OUTDIR)\$(FILE34).obj" \
	"$(OUTDIR)\$(FILE35).obj"

#									#
#########################################################################

#########################################################################
#	Application							#
!MESSAGE
!MESSAGE Executing SH C/C++ Compiler phase
!MESSAGE

"$(OUTDIR)\$(FILE0).obj" : "$(SRCDIR)\$(FILE0).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE0).c" -objectfile="$(OUTDIR)\$(FILE0).obj" $(CCINF0)

"$(OUTDIR)\$(FILE1).obj" : "$(SRCDIR)\$(FILE1).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE1).c" -objectfile="$(OUTDIR)\$(FILE1).obj" $(CCINF0)

"$(OUTDIR)\$(FILE2).obj" : "$(SRCDIR)\$(FILE2).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE2).c" -objectfile="$(OUTDIR)\$(FILE2).obj" $(CCINF0)

"$(OUTDIR)\$(FILE3).obj" : "$(SRCDIR)\$(FILE3).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE3).c" -objectfile="$(OUTDIR)\$(FILE3).obj" $(CCINF0)

"$(OUTDIR)\$(FILE4).obj" : "$(SRCDIR)\$(FILE4).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE4).c" -objectfile="$(OUTDIR)\$(FILE4).obj" $(CCINF0)

"$(OUTDIR)\$(FILE5).obj" : "$(SRCDIR)\$(FILE5).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE5).c" -objectfile="$(OUTDIR)\$(FILE5).obj" $(CCINF0)

"$(OUTDIR)\$(FILE6).obj" : "$(SRCDIR)\$(FILE6).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE6).c" -objectfile="$(OUTDIR)\$(FILE6).obj" $(CCINF0)

"$(OUTDIR)\$(FILE7).obj" : "$(SRCDIR)\$(FILE7).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE7).c" -objectfile="$(OUTDIR)\$(FILE7).obj" $(CCINF0)

"$(OUTDIR)\$(FILE8).obj" : "$(SRCDIR)\$(FILE8).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE8).c" -objectfile="$(OUTDIR)\$(FILE8).obj" $(CCINF0)

"$(OUTDIR)\$(FILE9).obj" : "$(SRCDIR)\$(FILE9).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE9).c" -objectfile="$(OUTDIR)\$(FILE9).obj" $(CCINF0)

"$(OUTDIR)\$(FILE10).obj" : "$(SRCDIR)\$(FILE10).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE10).c" -objectfile="$(OUTDIR)\$(FILE10).obj" $(CCINF0)

"$(OUTDIR)\$(FILE11).obj" : "$(SRCDIR)\$(FILE11).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE11).c" -objectfile="$(OUTDIR)\$(FILE11).obj" $(CCINF0)

"$(OUTDIR)\$(FILE12).obj" : "$(SRCDIR)\$(FILE12).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE12).c" -objectfile="$(OUTDIR)\$(FILE12).obj" $(CCINF0)

"$(OUTDIR)\$(FILE13).obj" : "$(SRCDIR)\$(FILE13).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE13).c" -objectfile="$(OUTDIR)\$(FILE13).obj" $(CCINF0)

"$(OUTDIR)\$(FILE14).obj" : "$(SRCDIR)\$(FILE14).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE14).c" -objectfile="$(OUTDIR)\$(FILE14).obj" $(CCINF0)

"$(OUTDIR)\$(FILE15).obj" : "$(SRCDIR)\$(FILE15).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE15).c" -objectfile="$(OUTDIR)\$(FILE15).obj" $(CCINF0)

"$(OUTDIR)\$(FILE16).obj" : "$(SRCDIR)\$(FILE16).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE16).c" -objectfile="$(OUTDIR)\$(FILE16).obj" $(CCINF0)

"$(OUTDIR)\$(FILE17).obj" : "$(SRCDIR)\$(FILE17).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE17).c" -objectfile="$(OUTDIR)\$(FILE17).obj" $(CCINF0)

"$(OUTDIR)\$(FILE18).obj" : "$(SRCDIR)\$(FILE18).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE18).c" -objectfile="$(OUTDIR)\$(FILE18).obj" $(CCINF0)

"$(OUTDIR)\$(FILE19).obj" : "$(SRCDIR)\$(FILE19).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE19).c" -objectfile="$(OUTDIR)\$(FILE19).obj" $(CCINF0)

"$(OUTDIR)\$(FILE20).obj" : "$(SRCDIR)\$(FILE20).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE20).c" -objectfile="$(OUTDIR)\$(FILE20).obj" $(CCINF0)

"$(OUTDIR)\$(FILE21).obj" : "$(SRCDIR)\$(FILE21).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE21).c" -objectfile="$(OUTDIR)\$(FILE21).obj" $(CCINF0)

"$(OUTDIR)\$(FILE22).obj" : "$(SRCDIR)\$(FILE22).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE22).c" -objectfile="$(OUTDIR)\$(FILE22).obj" $(CCINF0)

"$(OUTDIR)\$(FILE23).obj" : "$(SRCDIR)\$(FILE23).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE23).c" -objectfile="$(OUTDIR)\$(FILE23).obj" $(CCINF0)

"$(OUTDIR)\$(FILE24).obj" : "$(SRCDIR)\$(FILE24).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE24).c" -objectfile="$(OUTDIR)\$(FILE24).obj" $(CCINF0)

"$(OUTDIR)\$(FILE25).obj" : "$(SRCDIR)\$(FILE25).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE25).c" -objectfile="$(OUTDIR)\$(FILE25).obj" $(CCINF0)

"$(OUTDIR)\$(FILE26).obj" : "$(SRCDIR)\$(FILE26).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE26).c" -objectfile="$(OUTDIR)\$(FILE26).obj" $(CCINF0)

"$(OUTDIR)\$(FILE27).obj" : "$(SRCDIR)\$(FILE27).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE27).c" -objectfile="$(OUTDIR)\$(FILE27).obj" $(CCINF0)

"$(OUTDIR)\$(FILE28).obj" : "$(SRCDIR)\$(FILE28).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE28).c" -objectfile="$(OUTDIR)\$(FILE28).obj" $(CCINF0)

"$(OUTDIR)\$(FILE29).obj" : "$(SRCDIR)\$(FILE29).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE29).c" -objectfile="$(OUTDIR)\$(FILE29).obj" $(CCINF0)

"$(OUTDIR)\$(FILE30).obj" : "$(SRCDIR)\$(FILE30).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE30).c" -objectfile="$(OUTDIR)\$(FILE30).obj" $(CCINF0)

"$(OUTDIR)\$(FILE31).obj" : "$(SRCDIR)\$(FILE31).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE31).c" -objectfile="$(OUTDIR)\$(FILE31).obj" $(CCINF0)

"$(OUTDIR)\$(FILE32).obj" : "$(SRCDIR)\$(FILE32).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE32).c" -objectfile="$(OUTDIR)\$(FILE32).obj" $(CCINF0)

"$(OUTDIR)\$(FILE33).obj" : "$(SRCDIR)\$(FILE33).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE33).c" -objectfile="$(OUTDIR)\$(FILE33).obj" $(CCINF0)

"$(OUTDIR)\$(FILE34).obj" : "$(SRCDIR)\$(FILE34).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE34).c" -objectfile="$(OUTDIR)\$(FILE34).obj" $(CCINF0)

"$(OUTDIR)\$(FILE35).obj" : "$(SRCDIR)\$(FILE35).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE35).c" -objectfile="$(OUTDIR)\$(FILE35).obj" $(CCINF0)

#									#
#########################################################################

#########################################################################
#	MAKE file for release application (MOD.2)
#########################################################################
# USER OPTIONS
SETHEDUINF =  -vp$(VERSION)

ALLOBJ = $(USERALLOBJ) 

#########################################################################

all:	SHCENV \
	$(ALLOBJ) \
	"$(OUTDIR)\$(TARGET).pva"

#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Executing OptLinker phase
!MESSAGE

"$(OUTDIR)\$(TARGET).rld" : $(ALLOBJ) $(LNKINF0)
	$(LNK) -subcommand=<<
form sectrel
noprelink
nomessage 
list "$(OUTDIR)\$(TARGET).map"
show symbol
nologo
input $(STARTUP)
input $(SETUP)
input $(SECT)
input $(SYSRAM)
input $(BOOTINF)
input $(ALLOBJ)
library $(MODECALLLIB)
library $(SHAREDLIB)
library $(TERMLIB)
library $(LLIB)
library $(ADDLIB)
library $(HILIB)
library $(SHCLIB)
output "$(OUTDIR)\$(TARGET).rld"
exit
<<

#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Create PV Application Binary Object phase
!MESSAGE

"$(TARGET).pva" : $(ALLOBJ) $(LNKINF0)
	$(SETHED) "$(OUTDIR)\$(TARGET).rld" "$(BINOUTDIR)\$(TARGET).pva" $(SETHEDINF) $(SETHEDUINF)
	$(PUTNAME) $(PUTNAMEINF) "$(BINOUTDIR)\$(TARGET).pva" $(TITLE)
	copy make\fin "$(BINOUTDIR)\fin"
