/*
 * SharedLib - Library for Pocketviewer for access to shared file
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "modeldef.h"
#include "shared.h"

int sfFindRecord(const uchar *signature,uchar *recname,int nlen,word *fp)
{
#ifdef LSI_C
  FILE_BUF fbuf;
#endif
  FILE_INFO fi;
  const uchar *s;
  uchar *p;
  uchar *n;
  int found=FALSE;
  if (!sffindfile(&fbuf)) return FALSE;   /* find or create shared file */
  /* search record starting with signature and load it*/
  fi.fp = *fp;
  fi.kind = FILE_KIND_BIN;    /* binary file */
  
  while ((!found) && (LibFileFindNext(&fbuf,&fi,0)))
    {
      if (!LibFileReadEx(&fbuf,&fi,3072/FILE_BLOCK_SIZE)) 
	return FALSE; /* Read error */
      s=signature; n=fbuf.fbuf.bin.bin_buf;
      while ((*s==*n)&&(*s!=0)) {s++; n++;} /* check identity with signature */
      found=(*s==0); /* */
    }
  
  if (found) 
    {
      p=recname; n=fbuf.fbuf.bin.bin_buf; /* return complete recordname */
      while ((*n!=0)&&(p-recname<nlen-1)) 
	*(p++)=*(n++);
      *p=0;
      *fp=fi.fp;
    }
  else
    {
      recname[0]=0;
      *fp=-1;
    }
  return found;
}
