/*
 * SharedLib - Library for Pocketviewer for access to shared file
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "modeldef.h"
#include <shared.h>
#ifdef __HITACHI__
static FILE_BUF fbuf;                       
#endif

int sfRemoveRecord(const uchar *signature)
{
  FILE_INFO fi;
#ifndef __HITACHI__
  FILE_BUF fbuf;                          /* requires very much stack space */
#endif  
  if (!sffindfile(&fbuf)) return FALSE;   /* find or create shared file */
  if (!sffindrecord(signature,&fbuf,&fi)) /* find record */
    return TRUE;                          /* ..no need to remove */
  
  return LibFileRemove(&fbuf,&fi);        /* remove it */
}






