################################################################
#  SHC INSTALLATION DIRECTORY SETTING
################################################################
TCDIR=c:\pvshcom\shc
#########################################################################
#	MAKE file for debug application (MOD.1)
#########################################################################

#------------------------------------------------------------------------
# Tools									|
# SH C/C++ Compiler phase
PVSDK_BASE=..

CC=$(TCDIR)\bin\shc.exe

# SH Assembler
ASM=$(TCDIR)\bin\asmsh.exe

# OptLinker
LNK=$(TCDIR)\bin\optlnk.exe

# End of Tools 								|
#------------------------------------------------------------------------
#------------------------------------------------------------------------
# PV system config							|
STARTUP ="$(PVSDK_BASE)\system\obj\startapl.obj"
SETUP = "$(PVSDK_BASE)\system\obj\setup.obj"
SECT = "$(PVSDK_BASE)\system\obj\section.obj"
SYSRAM = "$(PVSDK_BASE)\system\obj\rsysram.obj"

SYSSRCDIR = $(PVSDK_BASE)\system
LDIR= $(PVSDK_BASE)\lib\LibH
LCOM_H="$(LDIR)\define.h" "$(LDIR)\LIBC.H" "$(LDIR)\L_LIBC.H" "$(LDIR)\L_define.h"
LLIB   ="$(PVSDK_BASE)\lib\libc.lib"
ADDLIB ="$(PVSDK_BASE)\lib\addlibc.lib"

HIDIR = $(PVSDK_BASE)\lib\hilib
HILIB = "$(HIDIR)\HiLIB.LIB"
SHCLIB ="$(TCDIR)\shclib.lib"

#Common setting for Application
SOURCES = sources.def
SUBCOM = $(PVSDK_BASE)\tools\MakeDbg.sub
SRCDIR = c
OUTDIR = debug
BINOUTDIR = user_bin
INC="h","$(LDIR)","$(HIDIR)"
LNKINF0=$(LCOM_H) $(SOURCES)
CCINF0=-include=$(INC) -subcommand=$(SUBCOM)

# End of system config							|
#------------------------------------------------------------------------
# Description blocks
SHCENV : 
	set PATH=$(TCDIR)\bin
	set SHC_INC=$(TCDIR)\include
	set SHC_LIB=$(TCDIR)\bin
	set SHC_TMP=$(TCDIR)
#------------------------------------------------------------------------
#########################################################################
#	Application Independent Definations
#########################################################################

#########################################################################
#	Application							#

# use this name when a script creates *.pva,*.abs and *.dbg
TARGET=Shared

# PV Application Title (This name is displayed on PV Menu)
TITLE="Shared"

# ProgramVersion(EX. 0100->Ver1.00)
VERSION = 0100

# Application Sources (src\*.c)
FILE0=shared
FILE1=remove
FILE2=find

#									#
#########################################################################
USERALLOBJ=	\
	"$(OUTDIR)\$(FILE0).obj" \
	"$(OUTDIR)\$(FILE1).obj" \
	"$(OUTDIR)\$(FILE2).obj"

#									#
#########################################################################

#########################################################################
#	Application							#
!MESSAGE
!MESSAGE Executing SH C/C++ Compiler phase
!MESSAGE

"$(OUTDIR)\$(FILE0).obj" : "$(SRCDIR)\$(FILE0).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE0).c" -objectfile="$(OUTDIR)\$(FILE0).obj" $(CCINF0)

"$(OUTDIR)\$(FILE1).obj" : "$(SRCDIR)\$(FILE1).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE1).c" -objectfile="$(OUTDIR)\$(FILE1).obj" $(CCINF0)

"$(OUTDIR)\$(FILE2).obj" : "$(SRCDIR)\$(FILE2).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE2).c" -objectfile="$(OUTDIR)\$(FILE2).obj" $(CCINF0)

#									#
#########################################################################

#########################################################################
#	MAKE file for debug application  (MOD.2)
#########################################################################
# ADDED SYSTEM FILE

ALLOBJ = $(USERALLOBJ)

#------------------------------------------------------------------------
all:	SHCENV \
	$(ALLOBJ) \
	"$(OUTDIR)\$(TARGET).lib"
#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Executing OptLinker phase
!MESSAGE

"$(OUTDIR)\$(TARGET).lib" : $(ALLOBJ) $(LNKINF0)
	$(LNK) -subcommand=<<
form Library
noprelink
nomessage 
list "$(OUTDIR)\$(TARGET).map"
show symbol
nologo
input $(ALLOBJ)
output "$(OUTDIR)\$(TARGET).lib"
exit
<<
	copy "$(OUTDIR)\$(TARGET).lib" ..\lib
	copy h\*.h ..\Lib\LibH
	copy make\fin "$(OUTDIR)\findbg"
