/*
 * TermLib - Library for Pocketviewer for terminal emulation
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef TRM_H
#define TRM_H


#ifdef __HITACHI__
#include <stdio.h>
#endif

#include <libc.h>
#ifndef __HITACHI__
 #include <stdrom.h>
#endif

#ifndef UCHAR
#define UCHAR
typedef unsigned char uchar;
#endif

#define TRMCOLS 26
#define TRMLINES 17

#define TRMCHARS (TRMLINES * TRMCOLS)

#define M_LONG  1
#define M_SHORT 2

/* Return-Codes from Input */
#define TRM_ENTER 0x1000
#define TRM_NEXT  0x2000
#define TRM_ESC   0x3000

/* High level functions: output to screen with screen update */
void GotoTrm(int col,int row);
void InfTrm(int *col,int *row);
void InitTrm(void);
int InputTrm(uchar *ib,int cnr);
void OutputTrm(uchar *ob);
void OutputITrm(int i);
void OutputFTrm(float f);
void OutputDTrm(double d);
int inputstr (char* str, int x1, int y1, int x2, int lnr, byte font, int max);

/* low level procedures */
void OutTrm(uchar c);
void DisplayTrm(void);

/* private function of TermLib - direct use not recommended */
void ModeTrm(int mode);
void cursornext(void);

extern int spline, spcol; /* place to store current cursor position */
extern int cursorline, cursorcol;
extern uchar trmbuffer[TRMCHARS+1];
#endif
